2004-04-10  Michael Koch  <konqueror@gmx.de>

	* .cvsignore: Ignore ltmain.sh.
	* gnu/java/nio/channels/.cvsignore,
	gnu/regexp/.cvsignore: New files.

2004-04-10  Guilhem Lavaux <guilhem@kaffe.org>

	* java/text/FieldPosition.java
	(FieldPosition) Constructor now behaves as it should according
	to the java documentation.

2004-04-10  Mark Wielaard  <mark@klomp.org>

	* native/fdlibm/Makefile.am (libfdlibm_la_SOURCES): Add java-assert.h.

2004-04-09  Mark Wielaard  <mark@klomp.org>

	* configure.ac (AM_CFLAGS): Don't define _POSIX_SOURCE.

	* native/jni/gtk-peer/gthread-jni.c (maybe_rethrow): Explicitly
	malloc and free buf.

	* native/jni/java-nio/gnu_java_nio_channels_FileChannelImpl.c
	(GET_NATIVE_FD): Remove macro.
	(get_native_fd): Replace GET_NATIVE_FD macro.

	* native/target/generic/target_generic_misc.h
	(TARGET_NATIVE_MISC_FORMAT_STRING): Remove unused macro.

2004-04-09  Mark Wielaard  <mark@klomp.org>

	* autogen.sh: Check for explicit versions of the autotools installed
	in /usr/bin.

2004-03-25  Archie Cobbs  <archie@dellroad.org>

	* INSTALL: Document GNU make requirement for building.

2004-04-09  Dalibor Topic  <robilad@kaffe.org>

	* java/lang/SecurityManager.java: (checkAccess): Use getThreadGroup().
	Improved documentation.

2004-04-09  Jeroen Frijters  <jeroen@frijters.net>

	* java/net/URLConnection.java: (setContentHandlerFactory): Fixed
	to check static field instead of argument.

2004-04-09  Jeroen Frijters  <jeroen@frijters.net>

	* gnu/java/nio/channels/FileChannelImpl.java: (fd, mode) Made private.
	(length, pos) Removed. (FileChannelImpl (int, int)) Removed.
	(implPosition, seek, implTruncate, unlock, lock) Added throws clause.

2004-04-09  Jeroen Frijters  <jeroen@frijters.net>

	* java/io/FileDescriptor.java: (FileDescriptor) Added public
	constructor. (valid) Added null check.

2004-04-09  Mark Wielaard  <mark@klomp.org>

	* configure.ac: Set AM_CFLAGS to ISO C90 pedantic ansi, but with
	longlong (jlong) support and modern POSIX and BSD C library
	funtions/prototypes.
	* native/fdlibm/Makefile.am: Cancel out project wide AM_CFLAGS.
	* native/fdlibm/mprec.h: Remove C++ comments.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMenuPeer.c: Turn C++
	comments into C comments.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkPopupMenuPeer.c:
	Likewise.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkPopupMenuPeer.c:
	Likewise.
	* native/jni/java-io/FileDescriptor.c: Likewise.
	* native/jni/java-io/java_io_File.c: Likewise.
	* native/jni/java-io/javaio.c: Remove unused fprintf calls.
	* native/jni/java-net/javanet.c: Turn C++ comments into C comments.
	* native/jni/java-nio/gnu_java_nio_channels_FileChannelImpl.c:
	Likewise.
	* native/target/generic/target_generic_file.h: Likewise.
	* native/target/generic/target_generic_network.h: Likewise.

2004-04-09  Mark Wielaard  <mark@klomp.org>

	* config.guess: Removed automatically generated file.
	* config.sub: Likewise.
	* .cvsignore: Ignore config.guess and config.sub.

2004-04-09  Michael Koch  <konqueror@gmx.de>

	* include/gnu_java_nio_PipeImpl.h,
	include/gnu_java_nio_SelectorImpl.h,
	native/jni/java-nio/gnu_java_nio_PipeImpl.c,
	native/jni/java-nio/gnu_java_nio_SelectorImpl.c:
	New files.
	* native/jni/java-nio/Makefile.am:
	Build gnu_java_nio_PipeImpl.c and gnu_java_nio_SelectorImpl.c.
	* include/Makefile.am:
	Generate gnu_java_nio_PipeImpl.h and gnu_java_nio_SelectorImpl.h.

2004-04-08  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMenuPeer.c
	(accel_attach): Comment out _gtk_accel_group_attach call.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkPopupMenuPeer.c
	(setupAccelGroup): Likewise.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* java/security/AccessController.java:
	Fixed all @return tags.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* java/nio/DirectByteBufferImpl.java,
	java/nio/MappedByteBuffer.java,
	java/nio/MappedByteBufferImpl.java:
	Forgot to commit this during the big NIO commit.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* java/io/BufferedWriter.java,
	java/io/FilterInputStream.java,
	java/io/ObjectInputStream.java:
	More javadoc and coding style work.

2004-04-08  Michael Koch  <konqueror@gmx.de>
,
	* java/nio/channels/DatagramChannel.java,
	java/nio/channels/FileChannel.java,
	java/nio/channels/FileLock.java,
	java/nio/channels/Pipe.java,
	java/nio/channels/ServerSocketChannel.java,
	java/nio/channels/SocketChannel.java,
	java/nio/channels/spi/AbstractInterruptibleChannel.java,
	java/nio/channels/spi/AbstractSelectableChannel.java,
	java/nio/channels/spi/AbstractSelectionKey.java,
	java/nio/channels/spi/AbstractSelector.java,
	java/nio/channels/spi/SelectorProvider.java:
	Reworked coding style and javadocs.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* resource/gnu/regexp/.cvsignore: New file.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* java/nio/Buffer.java,
	java/nio/ByteBufferImpl.java,
	java/nio/CharBufferImpl.java,
	java/nio/DoubleBufferImpl.java,
	java/nio/DoubleViewBufferImpl.java,
	java/nio/FloatBufferImpl.java,
	java/nio/FloatViewBufferImpl.java,
	java/nio/IntBufferImpl.java,
	java/nio/IntViewBufferImpl.java,
	java/nio/LongBufferImpl.java,
	java/nio/LongViewBufferImpl.java,
	java/nio/ShortBufferImpl.java,
	java/nio/ShortViewBufferImpl.java,
	java/nio/channels/AlreadyConnectedException.java,
	java/nio/channels/AsynchronousCloseException.java,
	java/nio/channels/ByteChannel.java,
	java/nio/channels/CancelledKeyException.java,
	java/nio/channels/Channel.java,
	java/nio/channels/ClosedByInterruptException.java,
	java/nio/channels/ClosedChannelException.java,
	java/nio/channels/ClosedSelectorException.java,
	java/nio/channels/ConnectionPendingException.java,
	java/nio/channels/FileLockInterruptionException.java,
	java/nio/channels/GatheringByteChannel.java,
	java/nio/channels/IllegalBlockingModeException.java,
	java/nio/channels/IllegalSelectorException.java,
	java/nio/channels/InterruptibleChannel.java,
	java/nio/channels/NoConnectionPendingException.java,
	java/nio/channels/NonReadableChannelException.java,
	java/nio/channels/NonWritableChannelException.java,
	java/nio/channels/NotYetBoundException.java,
	java/nio/channels/NotYetConnectedException.java,
	java/nio/channels/OverlappingFileLockException.java,
	java/nio/channels/ReadableByteChannel.java,
	java/nio/channels/ScatteringByteChannel.java,
	java/nio/channels/SelectableChannel.java,
	java/nio/channels/SelectionKey.java,
	java/nio/channels/Selector.java,
	java/nio/channels/UnresolvedAddressException.java,
	java/nio/channels/UnsupportedAddressTypeException.java,
	java/nio/channels/WritableByteChannel.java,
	java/nio/charset/spi/CharsetProvider.java:
	Reworked coding style and javadocs.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* ChangeLog, acinclude.m4, lib/Makefile.am:
	Added support for building and installing glibj.zip and separate
	class files.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* autogen.sh: New script to generate configure and friends.
	* ltmain.sh: Removed. This gets added now by calling libtoolize.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* configure.ac: Added gnu/java/nio/channels/Makefile to output files.
	* gnu/java/nio/Makefile.am: Added subdir channels.
	* include/gnu_java_nio_channels_FileChannelImpl.h: New file.
	* include/java_io_FileDescriptor.h,
	include/java_nio_DirectByteBufferImpl.h: Updates.
	* include/java_nio_channels_FileChannelImpl.h: Removed.
	* include/Makefile.am: Handle generation of
	gnu_java_nio_channels_FileChannelImpl.h.
	* java/nio/channels/Makefile.am (EXTRA_DIST): Removed FileChannelImpl.java.
	* native/jni/java-nio/Makefile.am
	(libjavanio_la_SOURCES): Removed java_nio_FileChannelImpl.c and
	added gnu_java_nio_channels_FileChannelImpl.c.
	* native/jni/java-io/FileDescriptor.c: Commented out all code.
	* native/jni/java-nio/gnu_java_nio_channels_FileChannelImpl.c: New file.
	* native/jni/java-nio/java_nio_DirectByteBufferImpl.c: Fixed method names.
	* native/jni/java-nio/java_nio_FileChannelImpl.c: Removed.

2004-04-08  Per Bothner  <per@bothner.com>

	* java/nio/channels/Channels.java (newInputStream, newOutputStream):
	Optimize when argument is a FileChannelImpl.
	(newInputStream(FileChannelImpl), newOutputStream(FileChannelImpl)):
	New native methods.

2004-04-08  Per Bothner  <per@bothner.com>

	* java/nio/channels/FileChannelImpl.java:  Moved to package
	gnu/java/nio/channels, since we need to refer to it from java.io.
	* java/nio/channels/natFileChannelImpl.cc:  Removed file.
	* gnu/java/nio/channels/FileChannelImpl.java:  New class, renamed
	from java/nio/channels.  Don't depend on FileDescriptor.
	(in, out, err):  New static fields.
	(mode):  New field.
	(SET, CUR, READ, WRITE, APPEND, EXCL, SYNC, DSYNC):  Moved constants
	from FileDescriptor.
	(by):  Removed MappedByteBuffer field.
	(map):  New working implementation.
	* java/io/FileDescriptor.java:  Implement on top of FileChannel.
	Remove native methods.
	* gnu/java/nio/FileLockImpl.java (fd):  Remove field, replacing it by:
	(ch):  New FileChannelImpl field.  Update constructor to match.
	(releaseImpl):  Remove native method.  Instead ...
	(release):  Call unlock on channel.
	* java/io/FileInputStream.java (ch):  Change type to FileChannelImpl.
	(<init>(File)):  Allocate a FileChannelImpl, not a FileDescriptor.
	(<init>(FileChannelImpl)):  New package-private constructor.
	(<init>(FileDescriptor)):  Extract FileChannelImpl from arg.
	(available, close, read, skip):  Implement using FileChannelImpl.
	(getFD):  Allocate FileDescriptor if needed.
	(getChannel):  Is now trivial.
	* java/io/FileOutputStream.java:  Corresponding changes.
	* java/io/RandomAccessFile.java:  Corresponding changes.
	* java/nio/MappedByteBuffer.java: (forceImpl, isLoadedImpl, loadImpl,
	unmapImpl):  New dummy methods, to be overridden by subclass.
	(finalize, isLoaded, load, force):  New methods.
	* java/nio/MappedByteBufferImpl.java:  More-or-less rewrite.
	Now works, at least for read mapping.

2004-04-08  Per Bothner  <per@bothner.com>

	* java/nio/CharBufferImpl.java:  Inline super constructor.
	* java/nio/DoubleBufferImpl.java:  Likewise.
	* java/nio/FloatBufferImpl.java:  Likewise.
	* java/nio/IntBufferImpl.java:  Likewise.
	* java/nio/LongBufferImpl.java:  Likewise.
	* java/nio/ShortBufferImpl.java:  Likewise.
	* java/nio/CharBuffer.java:  Remove unused constructor.
	* java/nio/DoubleBuffer.java:  Likewise.
	* java/nio/FloatBuffer.java:  Likewise.
	* java/nio/IntBuffer.java:  Likewise.
	* java/nio/LongBuffer.java:  Likewise.
	* java/nio/ShortBuffer.java:  Likewise.
	* java/nio/CharViewBufferImpl.java:  New convenience constructor.
	Fix buggy call to super constructor.
	* java/nio/DoubleViewBufferImpl.java:  Likewise.
	* java/nio/FloatViewBufferImpl.java:  Likewise.
	* java/nio/IntViewBufferImpl.java:  Likewise.
	* java/nio/LongViewBufferImpl.java:  Likewise.
	* java/nio/ShortViewBufferImpl.java:  Likewise.
	* java/nio/ByteBuffer.java (endian):  Make non-private so other
	java.nio classes can inherit it.
	(<init>):  Don't bother clearing array_offset.
	* java/nio/ByteBuffer.java (allocate):  Re-implement using wrap.
	* java/nio/ByteBuffer.java (get(byte[],int,int)):  Check underflow.
	Remove redundant test.
	* java/nio/ByteBufferImpl.java (asCharBuffer, asShortBuffer,
	asIntBuffer, asLongBuffer, asFloatBuffer, asDoubleBuffer):
	Use new XxxViewBufferImpl constructors.
	* java/nio/MappedByteBufferImpl.java:  Likewise.
	* java/nio/DirectByteBufferImpl.java:  Likewise.
	* java/nio/ByteBufferImpl.java:  Remove one constructor.
	Inline super in remaining constructor.
	* java/nio/ByteBuffer.java:  Remove unused constructor.
	* java/nio/ByteBufferImpl.java (shiftDown):  New optimized method.
	* java/nio/ByteBufferImpl.java (get, put):  Add array_offset.
	* java/nio/DirectByteBufferImpl.java (owner):  New field.
	(offset):  Remove unused field.
	(<init>):  Modify one and add another constructor.  Change callers.
	(allocateDirect):  Removed - not used.
	(getImpl, putImpl):  Make static and pass address explicitly,
	to make them useful for MappedByteBufferImpl.
	(get, put):  Check for underflow.  Modify for new getImpl.
	(getImpl):  New native method where target is array.
	(get(byte[],int,int)):  Use the above.
	(adjustAddress):  New static native method.
	(slice, duplicate, asReadOnly):  New implementations.

2004-04-08  Per Bothner  <per@bothner.com>

	* java/nio/ByteBuffer.java (shiftDown):  New helper method.
	* java/nio/ByteBufferImpl.java (compact):  Use new shiftDown method.
	* sava/nio/ByteBufferHelper.java:  Remove redundant 'final' specifiers.
	Pass ByteOrder parameter to most methods, since the underlying
	ByteBuffer's order isn't always what we should use.
	* java/nio/ByteBufferImpl.java:  Pass byte-order various places.
	* java/nio/DirectByteBufferImpl.java:  Likewise.
	Use ByteBufferHelper methods.
	* java/nio/MappedByteBufferImpl.java:  Likewise.
	(compact):  Use shiftDown.
	* java/nio/CharViewBufferImpl.java (<init>):  Pass byte-order.
	(get, put):  Use ByteBufferHelper.
	(compact):  Use new shiftDown method.
	(duplicate(boolean)):  New helper method.
	(duplicate, asReadOnlyBuffer):  Use it.
	(order):  Return endian field.
	* java/nio/DoubleViewBufferImpl.java:  Likewise.
	* java/nio/FloatViewBufferImpl.java:  Likewise.
	* java/nio/IntViewBufferImpl.java:  Likewise.
	* java/nio/LongViewBufferImpl.java:  Likewise.
	* java/nio/ShortViewBufferImpl.java:  Likewise.
	* java/nio/CharViewBufferImpl.java (subsequence):  Redundant test.
	* java/nio/DirectByteBufferImpl.java (shiftDown):  New native method.
	(compact):  Re-implement using shiftDown.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* java/net/ContentHandler.java,
	java/net/ContentHandlerFactory.java,
	java/net/Inet4Address.java,
	java/net/Inet6Address.java,
	java/net/JarURLConnection.java,
	java/net/MimeTypeMapper.java,
	java/net/URI.java,
	java/net/URL.java,
	java/net/URLClassLoader.java,
	java/net/URLConnection.java,
	java/net/URLStreamHandler.java:
	Reworked javadocs and coding style.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* java/net/Authenticator.java,
	java/net/BindException.java,
	java/net/ConnectException.java,
	java/net/DatagramPacket.java,
	java/net/DatagramSocket.java,
	java/net/DatagramSocketImpl.java,
	java/net/DatagramSocketImplFactory.java,
	java/net/FileNameMap.java,
	java/net/HttpURLConnection.java,
	java/net/InetSocketAddress.java,
	java/net/MalformedURLException.java,
	java/net/MulticastSocket.java,
	java/net/NetPermission.java,
	java/net/NetworkInterface.java,
	java/net/NoRouteToHostException.java,
	java/net/PasswordAuthentication.java,
	java/net/PortUnreachableException.java,
	java/net/ProtocolException.java,
	java/net/ServerSocket.java,
	java/net/Socket.java,
	java/net/SocketAddress.java,
	java/net/SocketException.java,
	java/net/SocketImpl.java,
	java/net/SocketImplFactory.java,
	java/net/SocketOptions.java,
	java/net/SocketTimeoutException.java,
	java/net/URISyntaxException.java,
	java/net/URLDecoder.java,
	java/net/URLEncoder.java,
	java/net/URLStreamHandlerFactory.java,
	java/net/UnknownHostException.java,
	java/net/UnknownServiceException.java:
	Reworked javadoc and coding style all over.

2004-04-08  Michael Koch  <konqueror@gmx.de>

	* java/io/ByteArrayInputStream.java,
	java/io/DataInput.java,
	java/io/DataInputStream.java,
	java/io/InputStream.java,
	java/io/InputStreamReader.java,
	java/io/ObjectStreamClass.java,
	java/io/ObjectStreamField.java,
	java/io/PushbackReader.java,
	java/io/StringWriter.java,
	java/io/Writer.java:
	Fixed javadocs and style all over.

2004-04-06  Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/ObjectStreamField.java
	(setBooleanField, setCharField, setByteField, setShortField,
	setIntField, setLongField, setFloatField, setDoubleField,
	setObjectField): Use native methods directly to be able to set
	final fields.

	* vm/reference/java/io/VMObjectStreamClass.java
	(setBooleanNative, setCharNative, setByteNative, setShortNative,
	setIntNative, setLongNative, setFloatNative, setDoubleNative,
	setObjectNative): New methods for serialization to be able to
	set final fields.

	* native/jni/java-io/java_io_VMObjectStreamClass.c:
	Implemented new native methods of java.io.VMObjectStreamClass
	accordingly.

	* include/java_io_VMObjectStreamClass.h: Regenerated.

	* NEWS: Added a warning clause about the VM Interface change.

2004-04-07  Patrik Reali  <reali@acm.org>

	* doc/www.gnu.org/events/fosdem04.wml: link to group picture added

2004-04-07  Mark Wielaard  <mark@klomp.org>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkCheckboxPeer.c:
	Changed C++ comments into C comments. Removed commented out code.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c:
	Likewise.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c:
	Likewise.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkFileDialogPeer.c:
	Likewise.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkListPeer.c:
	Likewise.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextComponentPeer.c:
	Likewise.
	* native/jni/gtk-peer/gthread-jni.c:
	Likewise.

2004-04-07  Ingo Proetel  <proetel@aicas.com>

	* java/awt/image/SampleModel.java (<init>): Added error cause
	information to thrown exception.

2004-04-07  Ingo Proetel  <proetel@aicas.com>

	* java/awt/image/SinglePixelPackedSampleModel.java (getDataElements):
	New method.
	(setDataElements): New method.
	(setPixels): New method.
	(toString): New method.

2004-04-07  Ingo Proetel  <proetel@aicas.com>

	* java/awt/Polygon.java (getBoundingBox): Use correct y-coordinate
	in Rectangle constructor.

2004-04-07  Ingo Proetel  <proetel@aicas.com>

	* java/awt/image/Raster.java (toString): Added method. 

2004-04-07  Patrik Reali  <reali@acm.org>

	* doc/www.gnu.org/newsitems.txt: JamVM release; ServiceFactory release

2004-04-06  Patrik Reali  <reali@acm.org>

	* doc/www.gnu.org/downloads/downloads.wml: removed download links
	0.00 to 0.05 because they do not exist; link to 0.07 fixed

2004-04-06  Patrik Reali  <reali@acm.org>

	* doc/www.gnu.org/downloads/downloads.wml: link to 0.08 corrected

2004-04-05  Patrik Reali  <reali@acm.org>

	* doc/www.gnu.org/README: some custom tags documented
	* doc/www.gnu.org/newsitems.txt: planet classpath added
	* doc/www.gnu.org/faq/faq.wml doc/www.gnu.org/include/layout.wml 
        doc/www.gnu.org/include/macros.wml: faq entry on installing classpath
	and mauve, custom tags for commented code

2004-04-02  Tom Tromey  <tromey@redhat.com>

	* doc/hacking.texinfo (Source Code Style Guide): Mention `extends
	Object' and `import java.lang.Integer' as redundant.

	* java/rmi/MarshalledObject.java (MarshalledObject): Removed
	redundant `extends'.
	* java/security/Security.java (Security): Removed redundant
	`extends'.
	* java/security/spec/DSAPublicKeySpec.java (DSAPublicKeySpec):
	Removed redundant `extends'.
	* java/security/spec/DSAPrivateKeySpec.java (DSAPrivateKeySpec):
	Removed redundant `extends'.
	* java/security/spec/DSAParameterSpec.java (DSAParameterSpec):
	Removed redundant `extends'.
	* javax/naming/directory/SearchControls.java (SearchControls):
	Removed redundant `extends'.
	* javax/naming/spi/DirStateFactory.java (Result): Removed
	redundant modifiers.
	* java/util/Map.java (Entry): Removed redundant modifiers.
	* java/text/AttributedCharacterIterator.java (Attribute): Removed
	redundant modifiers.
	* java/security/Security.java (provides): Removed unused label.

2004-04-02  Mark Wielaard  <mark@klomp.org>

	* doc/hacking.texi: Added sections on needed libraries, coding
	conventions, hacking on the code, writing ChangeLog
	entries. Updated old/deprecated information.

	* HACKING: Moved all content to doc/hacking.text. Add pointer to
	above document.

2004-04-01  Mark Wielaard  <mark@klomp.org>

	* javax/swing/JViewport.java (JViewport): Make constructor public.

2004-04-01  Jeroen Frijters  <jeroen@frijters.net>

	* java/text/DecimalFormat.java (scanFix): Removed suffix check
	for percent and permill check.

2004-03-31  Michael Koch  <konqueror@gmx.de>

	* include/gnu_java_nio_ByteBufferImpl.h,
	include/gnu_java_nio_CharBufferImpl.h,
	include/gnu_java_nio_DoubleBufferImpl.h,
	include/gnu_java_nio_FloatBufferImpl.h,
	include/gnu_java_nio_IntBufferImpl.h,
	include/gnu_java_nio_LongBufferImpl.h,
	include/gnu_java_nio_ShortBufferImpl.h:
	Removed, unused.

2004-03-29  Steven Augart  <steve+freejava@augart.com>

	* doc/vmintegration.texinfo; Added dir entry.
	* doc/hacking.texinfo: Likewise.

2004-03-28  Jeroen Frijters  <jeroen@frijters.net>

	* java/io/OutputStreamWriter.java
	(OutputStreamWriter): Added call to set bad character value for the
	encoder.

2004-03-28  Etienne M. Gagnon  <gagnon.etienne_m@uqam.ca>

	* doc/vmintegration.texinfo, doc/www.gnu.org/stories.wml: Update
	SableVM related descriptions.

2004-03-19  Ito Kazumitsu <kaz@maczuka.gcd.org>

	* libraries/javalib/java/util/Properties (load): Delete leading
	whitespaces before checking comment characters.

2004-03-26  Peter Moon  <peterm@miraculum.com>

	* java/text/NumberFormat.java: Fix spelling of setCurrency
	method.

2004-03-26  Mark Wielaard  <mark@klomp.org>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkChoicePeer.c
	(item_activate): Declare label before use.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(gtkSetFont): Removed unused variable label.
	(addExposeFilter): Declare variables before use.
	(removeExposeFilter): Likewise.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkFileDialogPeer.c
	(ok_clicked): Declare str_fileName before use.

2004-03-25  Archie Cobbs  <archie@dellroad.org>

	* configure.ac: Use the more portable ``:'' expr(1)
	keyword instead of ``match''.

2004-03-25  Mark Wielaard  <mark@klomp.org>

	* gnu/java/awt/peer/gtk/GtkFontPeer.java: Use fallback when
	MissingResourceException is thrown.
	* gnu/java/awt/peer/gtk/GtkToolkit.java (getFontPeer): Don't return
	null when a MissingResourceException is thrown. Should never happen.

2004-03-24  Tom Tromey  <tromey@redhat.com>

	* doc/hacking.texinfo (Serialization): Typo.

2004-03-24  Sascha Brawer  <brawer@dandelis.ch>

	* javax/imageio, javax/imageio/spi: New directories.
	* javax/imageio/spi/ServiceRegistry.java: Implemented.
	* javax/imageio/spi/RegisterableService.java: Implemented.

2004-03-24  Sascha Brawer  <brawer@dandelis.ch>

	* gnu/classpath/ServiceFactory.java: Implemented a general
	facility for loading plug-in services specified via resources
	in META-INF/services.

	* gnu/classpath/ServiceProviderLoadingAction.java: New file.

2004-03-22  Ingo Proetel  <proetel@aicas.com>

	* java/awt/event/MouseEvent.java (<init>): fixed field assignment 

2004-03-22 Ingo Proetel <proetel@aicas.com>

	* java/awt/Graphics.java (draw3DRect): fixed lower horizontal line

2004-03-22  Ingo Proetel  <proetel@aicas.com>

	* java/awt/FontMetrics.java:
	(charsWidth): fixed accumulation of total_width
	(getWidth): simple default implementation

2004-03-21  Ito Kazumitsu <kaz@maczuka.gcd.org>

        * libraries/javalib/java/net/ServerSocket.java
        (accept): Close the socket when error occured.

2004-03-21  Norbert Frese  <postfach@nfrese.net>

	* gnu/java/rmi/server/RMIIncomingThread.java: New file.
	* gnu/java/rmi/server/UnicastConnection.java:
	Create a new RMIObjectOuputStream/RMIObjectInputStream for every
	rmi-message.
	(getObjectInputStream): Return object reference, throw IOException if null.
	(startObjectInputStream): Create new RMIObjectInputStream on top of 'din'.
	(getObjectOutputStream): Return object reference, throw IOException if null.
	(startObjectOutputStream): Create new RMIObjectOutputStream on top of 'dout'.
	* gnu/java/rmi/server/UnicastConnectionManager.java:
	(UnicastConnectionManager): Throw RemoteException if port is not available.
	(getInstance): Throw RemoteException.
	(run): Lookup client host and attach it to new RMIIncomingThread for later retrieval.
	* gnu/java/rmi/server/UnicastRef.java:
	Start a new RMIObjectInputStream/RMIObjectOutputStream for every rmi-message.
	Collect Exceptions which are returned by a rmi-call and fix void returns.
	* gnu/java/rmi/server/UnicastRemoteCall.java:
	Start a new RMIObjectInputStream/RMIObjectOutputStream for every rmi-message.
	* gnu/java/rmi/server/UnicastServer.java:
	(dispatch): Answer ping messages which are sent by other java implementions.
	(incomingMessageCall): Start a new RMIObjectInputStream/RMIObjectOutputStream
	for every rmi-message and fix void return problems.
	* gnu/java/rmi/server/UnicastServerRef.java
	(UnicastServerRef): Throw RemoteException.
	(exportObject): Find the class up the class hierarchy which has a _Stub generated by rmic.
	In some situations it is necessary to export a subclass of the class which has the _Stub.
	For instance when the class with has the _Stub is abstract.
	(findStubSkelClass): New method which looks for the class which has the _Stub.
	(getClientHost): Implementated.
	* java/rmi/server/RemoteServer.java
	(getClientHost): Implemented.
	* gnu/java/rmi/server/Makefile.am
	(EXTRA_DIST): RMIIncomingThread.java.

2004-03-20  Jeroen Frijters  <jeroen@frijters.net>

	* java/net/URI.java (parseURI): Added unquoting.
	(unquote): New method.
	(quoteAuthority): Implemented.
	(quote(String,String)): New method.
	(quotePath): Implemented.
	(getRawSchemeSpecificPart): Return new rawSchemeSpecificPart field.
	(getSchemeSpecificPart): Removed FIXME comment.
	(getRawAuthority): Return new rawAuthority field.
	(getAuthority): Removed FIXME comment.
	(getRawUserInfo): Return new rawUserInfo field.
	(getUserInfo): Removed FIXME comment.
	(getRawPath): Return new rawPath field.
	(getPath): Removed FIXME comment.
	(getRawQuery): Return new rawQuery field.
	(getQuery): Removed FIXME comment.
	(getRawFragment): Return new rawFragment field.
	(getFragment): Removed FIXME comment.

2004-03-20  Norbert Frese  <postfach@nfrese.net>

	* java/net/InetAddress.java
	(getByName): Handle hostname == "" case.

2004-03-20  Michael Koch  <konqueror@gmx.de>

	* java/net/InetAddress.java: Reformated.
	(equals): Removed unneeded pointer check.

2004-03-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/http/Connection.java
	(getOutputStream): Dont set POST method.

2004-03-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/PipeImpl.java
	(SourceChannelImpl): Made final.
	(read): Implemented.
	(SinkChannelImpl): Made final.
	(write): Implemented.

2004-03-19  Michael Koch  <konqueror@gmx.de>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkClasspathFontPeerMetrics.c,
	native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGlyphVector.c,
	native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics.c,
	native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics2D.c,
	native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkCheckboxPeer.c,
	native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c,
	native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c,
	native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkLabelPeer.c,
	native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c:
	Merged from libgcj. I actually forgot this in my last commit.

2004-03-19  Michael Koch  <konqueror@gmx.de>

	* java/net/HttpURLConnection.java:
	Fixed typos in javadoc.

2004-03-19  Michael Koch  <konqueror@gmx.de>

	* gnu/java/awt/peer/ClasspathFontPeer.java:
	Fixed javadoc to be correct xhtml.

2004-03-19  Michael Koch  <konqueror@gmx.de>

	* gnu/java/awt/peer/gtk/Makefile.am,
	java/awt/image/Makefile.am,
	javax/swing/plaf/basic/Makefile.am:
	Added new files.
	* include/gnu_java_awt_peer_gtk_GdkGraphics.h,
	include/gnu_java_awt_peer_gtk_GtkCheckboxPeer.h,
	include/gnu_java_awt_peer_gtk_GtkComponentPeer.h,
	include/gnu_java_awt_peer_gtk_GtkLabelPeer.h:
	Regenerated.

2004-03-19  Michael Koch  <konqueror@gmx.de>

	* java/awt/image/AffineTransformOp.java
	(AffineTransformOp): Made public.
	* javax/swing/JComponent.java
	(listenerList): Made protected.
	(accessibleContext): Likewise.
	* javax/swing/JList.java
	(valueChanged): Dont use internal fields of ListSelectionEvent.
	* javax/swing/JViewport.java
	(getView): Dont use internal fields of Component.
	(addImpl): Likewise.
	* javax/swing/Timer.java
	(isRunning): Made public.
	(start): Likewise.
	(stop): Likewise.
	* javax/swing/UIDefaults.java
	(getInt): Made public.
	* javax/swing/plaf/basic/BasicListUI.java
	(mousePressed): Dont use internal fields of MouseEvent.
	(propertyChanged): Dont use internal fields of PropertyChangeEvent.
	* javax/swing/plaf/basic/BasicScrollBarUI.java
	(arrowIcon): Made static.
	* javax/swing/plaf/basic/BasicViewportUI.java
	(stateChanged): Dont use internal field on ChangeEvent.
	* javax/swing/text/JTextComponent.java
	(getUI): Call UIManager.getUI().
	(updateUI): Use getUI().

2004-03-19  Graydon Hoare  <graydon@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java: Clipping fixes.
	* javax/swing/JComponent.java (paint): Use persistent double buffer. 
	* javax/swing/JList.java (ListListener): Revalidate on changes.
	* javax/swing/JScrollPane.java: Reimplement.
	* javax/swing/JViewport.java: Reimplement.
	* javax/swing/ScrollPaneLayout.java: Reimplement.
	* javax/swing/ViewportLayout.java: Tidy up.
	* javax/swing/plaf/basic/BasicButtonListener.java: Remove printlns.
	* javax/swing/plaf/basic/BasicScrollPaneUI.java: Reimplement.
	* javax/swing/plaf/basic/BasicSliderUI.java: Handle missing labels.
	* javax/swing/plaf/basic/BasicViewportUI.java: Implement in terms of
	backing store only.

2004-03-19  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(window_wm_protocols_filter): New function.
	(window_focus_in_cb): Remove function.
	(window_focus_out_cb): Likewise.
	(window_focus_or_active_state_change_cb): New function.
	(create): Add filter that removes WM_TAKE_FOCUS client messages.
	(connectSignals): Don't attach handlers to focus-in-event or
	focus-out-event signals.  Handle notify signal.

2004-03-19  David Jee  <djee@redhat.com>

	* gnu/java/awt/peer/gtk/GtkCheckboxPeer.java
	(gtkSetLabel): New native method declaration.
	(setLabel): Use gtkSetLabel.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkCheckboxPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkCheckboxPeer_gtkSetLabel): New method.

2004-03-19  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics.java (setColor): Default to
	black when color argument is null.

2004-03-19  Kim Ho  <kho@redhat.com>

	* java/awt/Container.java: Remove check
	for drag events.

2004-03-19  Kim Ho  <kho@redhat.com>

	* java/awt/Container.java: (visitChild):
	Remove candidate clip. Use the component
	clip to intersect.
	* gnu/java/awt/peer/gtk/GtkComponentPeer.java:
	(handleEvent): Use the PaintEvent's clip.

2004-03-19  Kim Ho  <kho@redhat.com>

	* gnu/java/awt/peer/gtk/GtkComponentPeer.java:
	(handleEvent): Don't set the clip for the
	Graphics object.

2004-03-19  Graydon Hoare  <graydon@redhat.com>

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGlyphVector.c: 
	Fix double <-> fixed macros, reset font transform.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkClasspathFontPeerMetrics.c:
	Likewise.

2004-03-19  Kim Ho  <kho@redhat.com>

	* java/awt/Container.java: (visitChild): Move
	the x and y coordinate of the component rectangle
	to correct position.
	(handleEvent): Forward drag events to the pressed
	component.
	* javax/swing/plaf/basic/BasicScrollBarUI.java:
	Fix comments.
	(ArrowButtonListener::mousePressed): Stop the
	existing timer.
	(mouseDragged): Implement.
	(TrackListener::mousePressed): Only react if
	the press doesn't occur on the thumb, otherwise
	just set the offset.
	(TrackListener::mouseReleased): Unset the isAdjusting
	value.
	(createIncreaseIcon): Switch icon.
	(createDecreaseIcon): Switch icon.
	(calculatePreferredSize): Use width.
	(getThumbBounds): Use the top as the lower value.
	(layoutVScrollBar): Switch the button locations.
	(paintIncreaseHighlight): Paint correct side of thumb.
	(paintDecreaseHighlight): ditto.
	(valueForYPosition): Use top as the lower value.
	* javax/swing/plaf/basic/BasicSliderUI.java:
	Fix comments.
	(mouseDragged): Implement.
	(mousePressed): Only react when the thumb isn't
	pressed, otherwise just set offset.
	(mouseReleased): Handle a release of the thumb.
	(scrollDueToClickInTrack): Stop the timer first.
	* javax/swing/JProgressBar.java:
	(setString): Fix change condition.
	* javax/swing/JSeparator.java:
	Remove println's.

2004-03-19  David Jee  <djee@redhat.com>

	* java/awt/image/AffineTransformOp.java:
	(filter): Use Graphics2D interface instead of directly using the
	GdkGraphics2D peer.

2004-03-19  David Jee  <djee@redhat.com>

	* gnu/java/awt/peer/gtk/GtkButtonPeer.java
	(handleEvent): Action events are generated upon MOUSE_RELEASED.
	* java/awt/Container.java
	(acquireComponentForMouseEvent): Fixed.
	(handleEvent): Fixed.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(state_to_awt_mods_with_button_states): New method.
	(pre_event_handler): Fixed mouse event generation.

2004-03-19  Olga Rodimina  <rodimina@redhat.com>

	gnu/java/awt/peer/gtk/GdkGraphics2D.java
	(GdkGraphics2D (BufferedImage)): Initialize
	pixmap associated with specified BufferedImage.
	(setPaint): Changed implementation of Texture
	Paint to use AffineTransformOp.
	* java/awt/image/AffineTransformOp.java
	(createCompatibleDestRaster): Throw RasterFormatException 
	if resulting width or height of raster is 0.

2004-03-19  Olga Rodimina  <rodimina@redhat.com>

	* java/awt/image/AffineTransformOp.java:
	Removed unnecessary field interpolationType.
	Formatted some of the lines to be consistent with 
	the GNU style.
	(AffineTransformOp): Create new RenderingHints 
	containing specified interpolation type.
	(createCompatibleDestImage): Implemented.
	(createCompatibleDestRaster): Implemented.
	(filter): Implemented.
	(getBounds2D(BufferedImage)): Implemented.
	(getBounds2D(Raster)): Implemented.
	(getInterpolationType): Get interpolation value from 
	rendering hints.

2004-03-19  David Jee  <djee@redhat.com>

	* gnu/java/awt/peer/gtk/GtkContainerPeer.java
	(setFont): Check if child peers are null.

2004-03-19  Graydon Hoare  <graydon@redhat.com>

	* testsuite/lib/libjava.exp (libjava_find_lib): Don't include
	.libs in -L option.
	(libjava_arguments): Add new libraries to argument list.

2004-03-19  Olga Rodimina  <rodimina@redhat.com>

	* Makefile.am: Added java/awt/image/AffineTransformOp.java
	* Makefile.in: Re-generated.
	* java/awt/image/AffineTransformOp.java: New Class.

2004-03-19  Olga Rodimina  <rodimina@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java
	(setPaint): Interpret correctly TexturePaint's
	anchor rectangle.
	(drawImage): Fixed scale factors of the affine
	transform.

2004-03-19  David Jee  <djee@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics.java
	(GdkGraphics(Component)): Inherit font from component.
	(drawString): Use font style.
	* gnu/java/awt/peer/gtk/GtkCheckboxPeer.java
	(gtkSetFont): New native method declaration.
	(setFont): New method.
	* gnu/java/awt/peer/gtk/GtkComponentPeer.java
	(gtkSetFont): New native method declaration.
	(setFont): Call new native method gtkSetFont.
	* gnu/java/awt/peer/gtk/GtkContainerPeer.java
	(setFont): For all child components who do not their fonts set,
        set their peers' fonts with this container's font.
	* gnu/java/awt/peer/gtk/GtkLabelPeer.java:
	Move all native method declarations to the top for readability.
	(gtkSetFont): New native method declaration.
	(setFont): New method.
	* java/awt/Component.java
	(setFont): Invalidate after setting the font.
	* java/awt/Container.java
	(invalidateTree): New method.
	(setFont): Invalidate the container tree after setting the font.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics.c
	(Java_gnu_java_awt_peer_gtk_GdkGraphics_drawString): Use font style.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkCheckboxPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkCheckboxPeer_gtkSetFont): New method.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_gtkSetFont): New method.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkLabelPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkLabelPeer_gtkSetFont): New method.

2004-03-19  Olga Rodimina <rodimina@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java
	(updateBufferedImage): New helper function.
	Updates BufferedImage in memory if it was changed.
	(draw): changed to update BufferedImage in memory after
	this drawing operation
	(fill): Ditto.
	(draw3DRect): Ditto.
	(fill3DRect): Ditto.
	(clearRect): Ditto.
	(drawRaster): Ditto.
	(drawImage) : Ditto. Update only in case of GtkOffScreenImage with 
	no affine transformation.
	(drawGlyphVector): Ditto.

2004-03-19  Olga Rodimina <rodimina@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java
	(isBufferedImageGraphics): New Helper function. 
	Returns true if this graphics2d can be used to draw 
	into buffered image and false otherwise.
	(updateImagePixels): New Helper function. 
	Updates pixels in the BufferedImage.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics2D.c
	(getImagePixels): New function. Returns pixels
	of the buffered image associated with 
	this Graphics2D.

2004-03-19  David Jee  <djee@redhat.com>

	* java/awt/BorderLayout.java
	(layoutContainer): Fix width and height calculations to ensure
	that they're non-negative.
	* java/awt/Component.java
	(setBackground): If c is null, inherit from closest ancestor whose
	background color is set.

2004-03-19  Kim Ho  <kho@redhat.com>

	* Makefile.am: Add new files.
	* Makefile.in: Re-generate.
	* javax/swing/JProgressBar.java: 
	(JProgressBar(int, int int)): Throw
	IllegalArgumentException if orientation is
	invalid.
	(JProgressBar(BoundedRangeModel)): Create
	ChangeListener and register it. UpdateUI.
	(getChangeListeners): Implement.
	(setModel): Reset ChangeListener.
	* javax/swing/JScrollBar.java: Implement.
	* javax/swing/JSeparator.java: Implement.
	* javax/swing/JSlider.java:
	(JSlider(int, int, int, int)): Throw 
	IllegalArgumentException if orientation
	is invalid.
	(getChangeListeners): Fix method name.
	* javax/swing/SwingUtilities.java:
	(layoutCompoundLabel): If there is no text,
	set the text rectangle dimensions to 0.
	* javax/swing/plaf/basic/BasicButtonUI.java:
	(paint): If there is no text, don't paint it.
	* javax/swing/plaf/basic/BasicScrollBarUI.java:
	Implement.
	* javax/swing/plaf/basic/BasicSeparatorUI.java:
	Implement.
	* javax/swing/plaf/basic/BasicSliderUI.java: 
	(propertyChange): If the model changes, change
	the listeners accordingly.

2004-03-19  Graydon Hoare  <graydon@redhat.com>

	* javax/swing/AbstractButton.java: Add "final" qualifiers.
	* javax/swing/JList.java: Reimplement.
	* javax/swing/DefaultListSelectionModel.java: Reimplement.
	* javax/swing/plaf/basic/BasicListUI.java: Reimplement.
	* javax/swing/plaf/basic/BasicLookAndFeel.java: Add "purple" values.
	* javax/swing/ListModel.java: Javadoc.
	* javax/swing/ListSelectionModel.java: Add missing methods.
	* javax/swing/AbstractListModel.java: Javadoc and corrections.
	* javax/swing/DefaultListModel.java: Javadoc and corrections.
	* javax/swing/ListModel.java: Javadoc and corrections.
	* javax/swing/DefaultListCellRenderer.java: Minor tidying.

2004-03-19  David Jee  <djee@redhat.com>

	* gnu/java/awt/peer/gtk/GtkFontPeer.java
	(GtkFontPeer): Change default size to 12.
	* gnu/java/awt/peer/gtk/GtkToolkit.java
	(getFontPeer): Change default size to 12.
	(getClasspathFontPeer): Likewise. Set default name to "Default".
	* java/awt/Font.java
	(Font(Map)): Call Font(String,Map).
	(Font(String,Map)): If attrs is null, initialize it as an empty
	HashMap, which will ensure that the Font will get default attributes.

2004-03-19  David Jee  <djee@redhat.com>

	* gnu/java/awt/peer/gtk/GtkFontPeer.java
	(GtkFontPeer(String,int)): Call the new constructor with size 1.
	(GtkFontPeer(String,int,int)): New constructor with size attribute.
	* gnu/java/awt/peer/gtk/GtkToolkit.java
	(getFontPeer(String,int)): Call the new overload method with size 1.
	(getFontPeer(String,int,int)): New method. Overloaded with size
	attribute.
	(getClasspathFontPeer): Set the size of the font.

2004-03-19  Olga Rodimina  <rodimina@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java
	(bimage): New field.
	(GdkGraphics2D): New Constructor. Constructs Graphics
	object that can be used to draw into the Buffered Image.
	* gnu/java/awt/peer/gtk/GdkGraphicsEnvironment.java:
	(GdkGraphicsEnvironment): Fixed to include public 
	keyword.
	(createGraphics): Implemented.
	* gnu/java/awt/peer/gtk/GtkToolkit.java
	(getLocalGraphicsEnvironment): Implemented.
	* java/awt/GraphicsEnvironment.java:
	(getLocalGraphicsEnvironment): Implemented.
	* java/awt/image/BufferedImage.java:
	(createGraphics): Implemented.
		
2004-03-19  David Jee  <djee@redhat.com>

	* java/awt/Component.java
	(eventTypeEnabled): Add MOUSE_MOVED and MOUSE_DRAGGED event types.
	* java/awt/Container.java
	(addNotifyContainerChildren): Fix event enabling.

2004-03-19  Olga Rodimina  <rodimina@redhat.com>

	* Makefile.am: Added 
	gnu/java/awt/peer/gtk/GdkGraphicsEnvironment.java
	* Makefile.in: Re-generated.
	* gnu/java/awt/peer/gtk/GdkGraphicsEnvironment.java:
	New Class. 
	
2004-03-19  Kim Ho  <kho@redhat.com>

	* Makefile.am: Add BasicProgressBarUI
	* Makefile.in: Regenerate.
	* javax/swing/JProgressBar.java: 
	Re-implement.
	* javax/swing/plaf/basic/BasicLookAndFeel.java
	Add constants for JProgressBar.
	* javax/swing/plaf/basic/BasicProgressBarUI.java
	Implement.
	* javax/swing/plaf/basic/BasicSliderUI.java
	Change comments.
	(calculateGeometry): New method
	(paint): Remove unnecessary size calculations.

2004-03-19  Olga Rodimina  <rodimina@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java
	(drawRaster): Fixed small error that caused
	imageToUser transformation to be set incorrectly.
	(toString): Implemented.

2004-03-19  David Jee  <djee@redhat.com>

	* java/awt/CardLayout.java
	(addLayoutComponent): Show the first component added as the default.
	(removeLayoutComponent): After removing, show the next component.
	(gotoComponent): If there is only one component, show it and return.

2004-03-19  Kim Ho  <kho@redhat.com>

	* javax/swing/JSlider.java: Re-order
	modifiers.
	* javax/swing/JLabel.java: Re-order
	modifiers.
	* javax/swing/JComponent.java: 
	(addPropertyChangeListener):
	Implement.
	(removePropertyChangeListener):
	ditto.
	(firePropertyChangeEvent):
	ditto.

2004-03-19  David Jee  <djee@redhat.com>

	* java/awt/Component.java
	(show): Dispatch ComponentEvent via system event queue.
	(hide): Likewise.
	(move): Likewise.
	(resize): Likewise.
	(reshape): Likewise.
	* java/awt/Window.java
	(setBoundsCallback): Likewise.

2004-03-19  David Jee  <djee@redhat.com>

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_setNativeBounds):
	Use gtk_widget_set_size_request() instead of the deprecated
	gtk_widget_set_usize().

2004-03-19  Kim Ho  <kho@redhat.com>

	* javax/swing/JSlider.java: Fix comments and
	make property strings constants.
	(createStandardLabels): Use the labels
	preferred size as bounds.
	* javax/swing/plaf/basic/BasicSliderUI.java
	Fix comments.
	(ScrollHandler::actionPerformed): Don't
	calculate the timer stop value. Let the
	MouseListeners find the stop location.
	(getPreferredHorizontalSize): Re-implement.
	(getPreferredVerticalSize): ditto.
	(getMinimumHorizontalSize): ditto.
	(getMinimumVerticalSize): ditto.
	(getPreferredSize): ditto.
	(getMinimumSize): ditto.
	(getMaximumSize): ditto.
	(paintTicks): Use doubles to find the
	tick location.
	(paintHorizontalLabel):  Use preferredSize
	as initial width and height.
	(paintVerticalLabel): ditto.

2004-03-19  Kim Ho  <kho@redhat.com>

	* javax/swing/JLabel.java: Changed 
	property strings to constants.
	(DISPLAYED_MNEMONIC_INDEX_CHANGED_PROPERTY):
	New property.
	(setText): Change mnemonic index if
	text is too short.
	(setDisplayedMnemonicIndex): Fire property
	change event.
	(getDisplayedMnemonicIndex): Remove check
	against short text.

2004-03-19 Olga Rodimina <rodimina@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java:
	(drawImage(img,xform,obs)): Invert xform before
	passing the xform to cairo.
	(drawImage(img,x,y,bgcolor,obs)): Implemented.
	(drawImage (img,x,y,w,h,bgcolor,obs)): Partly
	implemented.
	(drawImage (img,x,y,w,h,obs)): Implemented.
	(drawImage (img,dx1,dy1,dx2,dy2,sx1,sy1,sx2,sy2,
	bgcolor,obs)): Partly implemented.
	(drawImage (img,dx1,dy1,dx2,dy2,sx1,sy1,sx2,sy2,obs)):
	Implemented.
	* java/awt/image/BufferedImage.java:
	(copyData): if dest is null, create raster with same
	dimensions as the current image.

2004-03-19  Graydon Hoare  <graydon@redhat.com>

	* javax/swing/plaf/basic/BasicLabelUI.java 
	(getPreferredSize): Use layoutCL.
	* javax/swing/plaf/basic/BasicGraphicsUtils.java 
	(getPreferredButtonSize): Start with empty view rect, layout using
	component's preferred alignment.
	* javax/swing/plaf/basic/BasicLookAndFeel.java: Add some Label and
	List defaults.

2004-03-19  David Jee  <djee@redhat.com>

	* java/awt/Component.java
	(show): Dispatch COMPONENT_SHOWN ComponentEvent.
	(hide): Dispatch COMPONENT_HIDDEN ComponentEvent.
	(move): Erase old bounds and repaint new bounds. Dispatch
	COMPONENT_MOVED ComponentEvent.
	(resize): Erase old bounds and repaint new bounds. Dispatch
	COMPONENT_RESIZED ComponentEvent.
	(reshape): Dispatch COMPONENT_RESIZED and COMPONENT_MOVED
	ComponentEvents.
	* java/awt/Window.java
	(setBoundsCallback): Dispatch COMPONENT_RESIZED and COMPONENT_MOVED
	ComponentEvents.

2004-03-19  Olga Rodimina  <rodimina@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java:
	(setRenderingHint): Added implementation of 
	Interpolation rendering hints.
	(setRenderingHints): Ditto.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics2D.c:
	(drawPixels): fixed to allow user to choose type 
	of filtering that should be used when displaying images.
	(cairoSurfaceSetFilter): New method. Sets filter type for 
	interpolation of pixel values.

2004-03-19  David Jee  <djee@redhat.com>

	* java/awt/GridBagLayout.java
	(calcCellSizes): Rows or columns with zero sizes should still be
	considered for extra space distribution.

2004-03-19  Kim Ho  <kho@redhat.com>

	* javax/swing/JLabel.java: Re-implement.
	* javax/swing/plaf/basic/BasicLabelUI.java
	Re-implement.
	* javax/swing/plaf/basic/BasicLookAndFeel.java:
	Added constant.

2004-03-19  Kim Ho  <kho@redhat.com>

	* javax/swing/JSlider.java: Fix indentation and comments.
	(setModel): Remove null check to conform with Sun's.
	(setOrientation): Throw exception if not
	HORIZONTAL or VERTICAL.
	(getInverted): Use private variable instead of 
	ComponentOrientation.
	(setInverted): ditto.
	* javax/swing/plaf/basic/BasicSliderUI.java:
	Fix indentation and comments.
	(propertyChange): Remove check for inverted slider, handle
	in main paint.
	(getMinimumSize): Return preferred size.
	(getMaximumSize): ditto.
	(calculateFocusRect): Don't relocate rectangle.
	(drawInverted): Return XOR of the slider's inversion and 
	the component's orientation.
	(paint): Update leftToRightCache

2004-03-19  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/PlainDatagramSocketImpl.java:
	Some reformating to match libgcj's version better.
	* gnu/java/net/PlainSocketImpl.java:
	Some reformating to match libgcj's version better.
	(connect): Javadoc added.
	(SocketInputStream.impl): Not needed, removed.
	(SocketInputStream.SocketInputStream): Likewise.
	(SocketInputStream.mark): Likewise.
	(SocketInputStream.markSupported): Likewise.
	(SocketInputStream.reset): Likewise.
	(SocketInputStream.available): Use implicit pointer to outer class.
	(SocketInputStream.close): Likewise.
	(SocketInputStream.read): Javadoc refined, use implicit pointer to outer class.
	(SocketOutputStream.impl): Not needed, removed.
	(SocketOutputStream.SocketOutputStream): Likewise.
	(SocketOutputStream.close): Use implicit pointer to outer class.
	(SocketOutputStream.flush): Not needed, removed.
	(SocketOutputStream.write): Javadoc refined, use implicit pointer to outer class.

2004-03-19  Michael Koch  <konqueror@gmx.de>

	* java/util/Locale.java
	(getISO3Country): Added comment for string comparison optimization.
	(getISO3Language): Likewise.
2004-03-15  Mark Wielaard  <mark@klomp.org>

	* include/Makefile.am: Add java_io_VMObjectStreamClass.h generation.
	* include/java_io_VMObjectStreamClass.h: New file.
	* native/jni/java-io/Makefile.am (SOURCES): Add new file.
	* native/jni/java-io/java_io_VMObjectStreamClass.c: New file.

2004-03-15  Patrik Reali  <reali@acm.org>
	* doc/hacking.texinfo doc/www.gnu.org/benchmarks.wml: link to japitools
	fixed
	* doc/www.gnu.org/home.wml: short news moved to page top
	* doc/www.gnu.org/downloads/downloads.wml: release 0.08 added

2004-03-15  Patrik Reali  <reali@acm.org>
	* doc/www.gnu.org/announce/20040313.wml doc/www.gnu.org/Makefile
	doc/www.gnu.org/announce/Makefile doc/www.gnu.org/newsitems.txt:
	classpath 0.08 release news item
	* doc/www.gnu.org/home.wml: broken links to JDK comparison fixed
	* doc/www.gnu.org/events/fosdem04.wml: link to Tom's slides
	* doc/www.gnu.org/faq/faq.wml: entry on free java needs

2004-03-13  Jeroen Frijters  <jeroen@frijters.net>

	* java/lang/Class.java (resourcePath): If the resource path is
	absolute chop off the leading / and if it is relative, but the
	class doesn't have a package, don't prepend the /.

2004-03-13  Jeroen Frijters  <jeroen@frijters.net>

	* java/lang/Thread.java: Removed unnecessary initialization of
	static field.
	* java/lang/ThreadGroup.java (list): Changed print to println.

2004-03-12  Mark Wielaard  <mark@klomp.org>

	* configure.ac: Set version to 0.08+cvs.

2004-03-12  Mark Wielaard  <mark@klomp.org>

	* configure.ac: Set version to 0.08.
	* NEWS: Update with interesting items.
	* TODO: Point to http://www.gnu.org/software/classpath/tasks.html

2004-03-12  Mark Wielaard  <mark@klomp.org>

	* gnu/java/awt/peer/gtk/GtkFontPeer.java: Use fallback when
	MissingResourceException is thrown.

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextAreaPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkTextAreaPeer_getVScrollbarWidth):
	Don't access ws when it is null.
	(Java_gnu_java_awt_peer_gtk_GtkTextAreaPeer_getHScrollbarHeight):
	Likewise.

2004-03-12  Thomas Fitzsimmons  <fitzsim@redhat.com>
 
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(connectJObject): Replace printf calls with g_assert statements.
	Move property-notify-event signal connection to ...
	(connectSignals): Connect property-notify-event signal.  Iterate
	through the vbox's children to find layout.

2004-03-12  Mark Wielaard  <mark@klomp.org>

	* java/io/BufferedReader.java: Use &lt;=, not &lt;&eq; to make gjdoc
	happy.

2004-03-12  Mark Wielaard  <mark@klomp.org>

	Reported by Stephen Crawley
	* java/io/FilePermission.java (implies): Use String.length() -1 to
	access last char of String.

2004-03-11  Ito Kazumitsu  <ito.kazumitsu@hitachi-cable.co.jp>

	* java/net/URI.java (toURL): Implemented.

2003-03-11  Ito Kazumitsu  <ito.kazumitsu@hitachi-cable.co.jp>

	* java/net/URI.java
	(URI_REGEXP) updated to contain scheme specific part.
	(SCHEME_SPEC_PART_GROUP) new constant.
	(AUTHORITY_GROUP, PATH_GROUP, QUERY_GROUP, FRAGMENT_GROUP)
	updated to make room for SCHEME_SPEC_PART_GROUP.
	(parseURI) parse scheme specific part.
	(resolve, isAbsolute, isOpaque, getRawSchemeSpecificPart,
	getSchemeSpecificPart, getAuthority, getUserInfo, getPath,
	getQuery, getFragment) implemented.

2002-03-11  Dalibor Topic  <robilad@kaffe.org>

	* libraries/javalib/java/net/URI.java
	partially implemented using java.util.regex.
	(URI_REGEXP) new constant. Used to parse URIs.
	(SCHEME_GROUP) new constant representing index of scheme group
	in parsed URI.
	(AUTHORITY_GROUP) new constant representing index of authority
	group in parsed URI.
	(PATH_GROUP) new constant representing index of path group in
	parsed URI.
	(QUERY_GROUP) new constant representing index of query group in
	parsed URI.
	(FRAGMENT_GROUP) new constant representing index of fragment
	group in parsed URI.
	(getURIGroup) new static utility method.
	(parseURI) implemented.
	(quote) stub for new static utility method.
	(quoteAuthority) stub for new static utility method.
	(quoteHost) stub for new static utility method.
	(quotePath) stub for new static utility method.
	(quoteUserInfo) stub for new static utility method.
	(URI) implemented.
	(create) don't throw URISyntaxException. Implemented.
	(toString) implemented.

2004-03-11  Dalibor Topic  <robilad@kaffe.org>

	Reported by: Adam Heath <doogie@debian.org>
	* gnu/javax/rmi/CORBA/DelegateFactory.java (getInstance): Use context
	class loader.

2004-03-09  Guilhem Lavaux  <guilhem@kaffe.org>

	* java/io/BufferedInputStream.java (marktarget): New field for max
	mark limit.
	(CHUNKSIZE): New constant for incremental mark buffer allocation.
	(mark): Use new fields.
	(read): Likewise.
	(read(byte[],int,int)): Likewise.
	(skip): Likewise.
	(refill): Likewise.

2004-03-08  Dalibor Topic  <robilad@kaffe.org>

	* java/text/AttributedString.java
	(addAttribute(AttributedCharacterIterator.Attribute,Object,int,int)):
	Use HashMap instead of Hashtable since value can be null, and
	you can not store a null value in a Hashtable.

2004-03-08  Guilhem Lavaux  <guilhem@kaffe.org>

	* java/text/DateFormatSymbols.java: Fixed copyright notice.

2004-03-08  Mark Wielaard  <mark@klomp.org>

	* java/beans/BeanDescriptor.java (BeanDescriptor):
	Set the FeatureDescriptor programmatic name.

2004-03-07  Mark Wielaard  <mark@klomp.org>

	* configure.ac: Add gnu/regexp/Makefile and
	resource/gnu/regexp/Makefile
	* gnu/Makefile.am (SUBDIRS): Add regexp.
	* gnu/regexp/Makefile.am: New file.
	* gnu/regexp/CharIndexed.java: Imported.
	* gnu/regexp/CharIndexedCharArray.java: Likewise.
	* gnu/regexp/CharIndexedInputStream.java: Likewise.
	* gnu/regexp/CharIndexedString.java: Likewise.
	* gnu/regexp/CharIndexedStringBuffer.java: Likewise.
	* gnu/regexp/RE.java: Likewise.
	* gnu/regexp/REException.java: Likewise.
	* gnu/regexp/REFilterInputStream.java: Likewise.
	* gnu/regexp/REMatch.java: Likewise.
	* gnu/regexp/REMatchEnumeration.java: Likewise.
	* gnu/regexp/RESyntax.java: Likewise.
	* gnu/regexp/REToken.java: Likewise.
	* gnu/regexp/RETokenAny.java: Likewise.
	* gnu/regexp/RETokenBackRef.java: Likewise.
	* gnu/regexp/RETokenChar.java: Likewise.
	* gnu/regexp/RETokenEnd.java: Likewise.
	* gnu/regexp/RETokenEndSub.java: Likewise.
	* gnu/regexp/RETokenOneOf.java: Likewise.
	* gnu/regexp/RETokenPOSIX.java: Likewise.
	* gnu/regexp/RETokenRange.java: Likewise.
	* gnu/regexp/RETokenRepeated.java: Likewise.
	* gnu/regexp/RETokenStart.java: Likewise.
	* gnu/regexp/RETokenWordBoundary.java: Likewise.
	* gnu/regexp/UncheckedRE.java: Likewise.
	* java/util/regex/Matcher.java: Add gnu.regexp wrappers.
	* java/util/regex/Pattern.java: Likewise.
	* resource/gnu/Makefile.am (SUBDIRS): Add regexp.
	* resource/gnu/regexp/Makefile.am: New file.
	* resource/gnu/regexp/MessagesBundle.properties: Imported.
	* resource/gnu/regexp/MessagesBundle_fr.properties: Likewise.

2004-03-07  Mark Wielaard  <mark@klomp.org>

	* lib/Makefile.am (propertydirs, propertyfiles): New variables.
	(resources): Create dirs and install property files.

2004-03-03  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/PlainSocketImpl.java
	(SocketInputStream): Made final.
	(read(byte[] buf)): Removed, redundant.
	(SocketOutputStream): Made final.
	(write(byte[] buf)): Removed, redundant.

2004-03-03  Michael Koch  <konqueror@gmx.de>

	* java/io/File.java: Reformated.
	(isAbsolute): Simplified code.
	(isHidden): Likewise.
	(mkdir): Likewise.
	(compareTo): Handle case sensitiveness.

2004-02-28    Guilhem Lavaux <guilhem@kaffe.org>

	* java/text/AttributedStringIterator.java
	(getAllAttributesKey): Return only keys concerned
	by the current iterator.
	(getAttributes): Use strict inequality for
	end_index. 

2004-02-27  Michael Koch  <konqueror@gmx.de>

	* java/lang/Thread.java: Rearranged some methods. Renamed some
	variables.
	(runnable): Renamed from 'toRun'.
	(destroy): Just throw NoSuchMedthodError as Sun does.
	(setContextClassLoader): Made sychronized.

2004-02-27  Michael Koch  <konqueror@gmx.de>

	* javax/swing/AbstractButton.java: Made several constants final.

2004-02-27  Anthony Green  <green@redhat.com>

	* java/lang/StringBuffer.java: No need to NULL out remainder of
	buffer since ensureCapacity_unsynchronized will have done this for
	us.

2004-02-27  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/DatagramChannelImpl.java
	(send): Check if target address is resolved.
	* gnu/java/nio/FileLockImpl.java
	(finalize): Made protected.
	* java/nio/channels/FileChannel.java
	(MapMode.READ_ONLY): Made final.
	(MapMode.READ_WRITE): Made final.
	(MapMode.PRIVATE): Made final.
	* java/nio/channels/SocketChannel.java
	(open): Simplified code.
	* java/nio/channels/spi/AbstractSelectableChannel.java
	(registered): Unused, removed.
	(keyFor): Check channel is open, only locate key
	and not add a new one.
	(register): Don't delete attachments.

2004-02-27  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/jar/Handler.java
	(): Removed unneeded check for file != null. java.net.URL.getFile()
	returns an empty string but never null.

2004-02-27  Michael Koch  <konqueror@gmx.de>

	* java/net/URLConnection.java
	(dateFormat1, dateformat2, dateformat3): New fields.
	(dateformats_initialized): New field for lazy initialization of date
	format fields.
	(getHeaderFieldDate): Rewritten to use DateFormat.parse() instead of
	the deprecated Date(String) constructor. This implementation
	(initializeDateFormats): New method,

2004-02-27  Michael Koch  <konqueror@gmx.de>

	* gnu/java/awt/ComponentDataBlitOp.java
	(INSTANCE): Made final.
	* gnu/java/awt/image/ImageDecoder.java:
	Reworked imports.
	(cm): Unused, removed.

2004-02-25  Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/ObjectInputStream.java
	(readClassDescriptor): Keep elements of the mapping non null.
	(checkTypeConsistency): New method.
	(readFields): Fixed main loop and base logic. Small reindentation.

	* java/io/ObjectStreamField.java
	(lookupField): New method to update the field reference.
	(checkFieldType): New method.
	
	* java/io/ObjectStreamClass.java
	(setClass, setFields): Call lookupField when building the field
	database. Check the real field type.

2004-02-17  Per Bothner  <per@bothner.com>

	* java/nio/CharBufferImpl.java:  Inline super constructor.
	* java/nio/DoubleBufferImpl.java:  Likewise.
	* java/nio/FloatBufferImpl.java:  Likewise.
	* java/nio/IntBufferImpl.java:  Likewise.
	* java/nio/LongBufferImpl.java:  Likewise.
	* java/nio/ShortBufferImpl.java:  Likewise.
	* java/nio/CharBuffer.java:  Remove unused constructor.
	* java/nio/DoubleBuffer.java:  Likewise.
	* java/nio/FloatBuffer.java:  Likewise.
	* java/nio/IntBuffer.java:  Likewise.
	* java/nio/LongBuffer.java:  Likewise.
	* java/nio/ShortBuffer.java:  Likewise.
	* java/nio/CharViewBufferImpl.java:  New convenience constructor.
	Fix buggy call to super constructor.
	* java/nio/DoubleViewBufferImpl.java:  Likewise.
	* java/nio/FloatViewBufferImpl.java:  Likewise.
	* java/nio/IntViewBufferImpl.java:  Likewise.
	* java/nio/LongViewBufferImpl.java:  Likewise.
	* java/nio/ShortViewBufferImpl.java:  Likewise.
	
	* java/nio/ByteBuffer.java (endian):  Make non-private so other
	java.nio classes can inherit it.
	(<init>):  Don't bother clearing array_offset.
	* java/nio/ByteBuffer.java (allocate):  Re-implement using wrap.
	* java/nio/ByteBuffer.java (get(byte[],int,int)):  Check underflow.
	Remove redundant test.

	* java/nio/ByteBufferImpl.java (asCharBuffer, asShortBuffer,
	asIntBuffer, asLongBuffer, asFloatBuffer, asDoubleBuffer):
	Use new XxxViewBufferImpl constructors.
	* java/nio/MappedByteBufferImpl.java:  Likewise.
	* java/nio/DirectByteBufferImpl.java:  Likewise.

	* java/nio/ByteBufferImpl.java:  Remove one constructor.
	Inline super in remaining constructor.
	* java/nio/ByteBuffer.java:  Remove unused constructor.

	* java/nio/ByteBufferImpl.java (shiftDown):  New optimized method.

	* java/nio/ByteBufferImpl.java (get, put):  Add array_offset.

2004-02-17  Per Bothner  <per@bothner.com>

	* java/nio/channels/spi/AbstractInterruptibleChannel.java (close):
	Set closed before calling implCloseChannel, as in the spec.

2004-02-14  Mark Wielaard  <mark@klomp.org>

	* javax/swing/Makefile.am (EXTRA_DIST): Remove ToggleButtonModel.java.
	* javax/swing/plaf/basic/Makefile.am (EXTRA_DIST): Remove
	BasicDefaults.java. Add BasicButtonListener.java and
	BasicRootPaneUI.java.

2004-02-14  Mark Wielaard  <mark@klomp.org>

	* javax/swing/AbstractButton.java (getSelectedIcon): Make public
	(getRolloverSelectedIcon): Likewise.

2004-02-14  Graydon Hoare  <graydon@redhat.com>

	* javax/swing/ToggleButtonModel.java: Remove dead class.
	* javax/swing/plaf/basic/BasicDefaults.java: Remove dead class.
	* javax/swing/plaf/basic/BasicButtonListener.java: New class.
	* javax/swing/plaf/basic/BasicRootPaneUI.java: New class.
	* Makefile.am: Update for new and removed files.
	* Makefile.in: Regenerate.

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java: Initialize default hints.
	* javax/swing/AbstractButton.java 
	(AbstractButton): Initialize fields correctly in ctor.
	* javax/swing/JCheckbox.java 
	(JCheckBox): Override painting flags.
	* javax/swing/DefaultButtonModel.java: Conform to sun.
	* javax/swing/JComponent.java (paint): Fill with background color
	if available.
	(processComponentKeyEvent)
	(processFocusEvent)
	(processKeyEvent)
	(processMouseMotionEvent): Remove event-consuming empty methods.
	(getUIClassID): Return "ComponentUI" not "JComponent"
	* javax/swing/JFrame.java: Remove some debugging chatter.
	(JFrame): Subscribe to window events.
	* javax/swing/JRadioButton.java 
	(JRadioButton): Override painting flags.
	* javax/swing/JRootPane.java 
	(JRootPane): Set background from UIDefaults.
	* javax/swing/JToggleButton.java 
	(ToggleButtonModel): New inner class.
	(JToggleButton): Override layout alighment.
	* javax/swing/SwingUtilities.java:
	(getLocalBounds): Return width and height, not x and y.
	(calculateInnerArea): Use local bounds, not bounds.
	(layoutCompoundLabel): Provide overridden form.
	(layoutCompoundLabel): Correct bugs.
	* javax/swing/UIDefaults.java: Correct comment.
	* javax/swing/plaf/basic/BasicButtonUI.java: 
	Move most logic into defaults, external listener.
	(paintIcon): Implement icon painting.
	(paint): Fix state painting to conform to changes in model.
	* javax/swing/plaf/basic/BasicCheckBoxUI.java:
	Remove most dead/wrong methods.
	(getDefaultIcon): Return defaults.getIcon("CheckBox.icon").
	* javax/swing/plaf/basic/BasicIconFactory.java:
	(DummyIcon): New class.
	(getMenuItemCheckIcon)
	(getMenuItemArrowIcon) 
	(getMenuArrowIcon)
	(getCheckBoxMenuItemIcon)
	(getRadioButtonMenuItemIcon)
	(createEmptyFrameIcon): Return DummyIcons, not null.
	(getCheckBoxIcon): Implement an icon that looks like sun's.
	(getRadioButtonIcon): Implement an icon that looks like sun's.
	* javax/swing/plaf/basic/BasicLookAndFeel.java 
	(initComponentDefaults): Fix impossible values, add some missing.
	* javax/swing/plaf/basic/BasicPanelUI.java (gap): Remove field.
	* javax/swing/plaf/basic/BasicRadioButtonUI.java:
	Remove most dead/wrong methods.
	(icon): New field.
	(getDefaultIcon): New method.
	* javax/swing/plaf/basic/BasicToggleButtonUI.java:
	Remove most dead/wrong methods.
	* javax/swing/plaf/metal/MetalLookAndFeel.java
	(getDefaults): Return super.getDefaults(), not BasicDefaults.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics.c
	(Java_gnu_java_awt_peer_gtk_GdkGraphics_clearRect):
	Implement "clearing" as drawing, when on pixmap drawables.

	* javax/swing/JButton.java (getUIClassID): 
	* javax/swing/JCheckBox.java (getUIClassID):
	* javax/swing/JEditorPane.java (getUIClassID):
	* javax/swing/JLabel.java (getUIClassID): 
	* javax/swing/JList.java (getUIClassID): 
	* javax/swing/JOptionPane.java (getUIClassID): 
	* javax/swing/JPanel.java (getUIClassID): 
	* javax/swing/JPasswordField.java (uiClassID): 
	* javax/swing/JRadioButton.java (getUIClassID): 
	* javax/swing/JRootPane.java (getUIClassID): 
	* javax/swing/JScrollPane.java (getUIClassID): 
	* javax/swing/JTabbedPane.java (getUIClassID): 
	* javax/swing/JToggleButton.java (getUIClassID): 
	* javax/swing/JTree.java (getUIClassID): 
	* javax/swing/JViewport.java (getUIClassID): 
	* javax/swing/text/JTextComponent.java (getUIClassID):
	Return "fooUI" not "Jfoo"

2004-02-14  Michael Koch  <konqueror@gmx.de>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEmbeddedWindowPeer.c:
	New file. Forgot this to add in a previous commit.

2004-02-12  Michael Koch  <konqueror@gmx.de>

	* gnu/java/awt/EmbeddedWindow.java,
	gnu/java/awt/EmbeddedWindowSupport.java,
	gnu/java/awt/peer/EmbeddedWindowPeer.java,
	gnu/java/awt/peer/gtk/GtkEmbeddedWindowPeer.java,
	include/gnu_java_awt_EmbeddedWindow.h,
	include/gnu_java_awt_peer_gtk_GtkEmbeddedWindowPeer.h,
	native/jni/java-awt/gnu_java_awt_EmbeddedWindow.c,
	native/jni/java-awt/Makefile.am,
	native/jni/java-awt/.cvsignore: New files.
	* gnu/java/awt/peer/gtk/GtkToolkit.java
	* configure.ac (AC_OUTPUT_FILES): Added native/jni/java-awt/Makefile
	* gnu/java/awt/Makefile.am
	(EXTRA_DIST): Added EmbeddedWindow.java and
	EmbeddedWindowSupport.java.
	* gnu/java/awt/peer/Makefile.am
	(EXTRA_DIST): Added EmbeddedWindowPeer.java.
	* gnu/java/awt/peer/gtk/Makefile.am
	(EXTRA_DIST): Added GtkEmbeddedWindowPeer.java.
	* include/Makefile.am: Generate gnu_java_awt_EmbeddedWindow.h and
	gnu_java_awt_peer_gtk_GtkEmbeddedWindowPeer.h.
	* native/jni/Makefile.am: Added subdir java-awt.
	* native/jni/gtk-peer/Makefile.am: Added
	gnu_java_awt_EmbeddedWindow.c.

2004-02-12  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramSocket.java
	(setReuseAddress): Use Boolean.valueOf() instead of creating a new
	Boolean object.
	(setBroadcast): Likewise.
	* java/net/MulticastSocket.java
	(setLoopbackMode): Likewise.
	* java/net/ServerSocket.java
	(setReuseAddress): Likewise.
	* java/net/Socket.java
	(setTcpNoDelay): Likewise.
	(setSoLinger): Likewise.
	(setOOBInline): Likewise.
	(setKeepAlive): Likewise.
	(setReuseAddress): Likewise.
	* java/net/URLStreamHandler.java
	(hostSEquals): Fix checking host addresses.
	(toExternalForm): Dont check protocol for null. We know already its
	not null.

2004-02-11  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/Connection.java:
	Reformated copyright boilerplate.

2004-02-11  Per Bothner  <per@bothner.com>

	* java/nio/ByteBuffer.java (shiftDown):  New helper method.
	* java/nio/ByteBufferImpl.java (compact):  Use new shiftDown method.
	* sava/nio/ByteBufferHelper.java:  Remove redundant 'final' specifiers.
	Pass ByteOrder parameter to most methods, since the underlying
	ByteBuffer's order isn't always what we should use.
	* java/nio/ByteBufferImpl.java:  Pass byte-order various places.
	* java/nio/DirectByteBufferImpl.java:  Likewise.
	Use ByteBufferHelper methods.
	* java/nio/MappedByteBufferImpl.java:  Likewise.
	(compact):  Use shiftDown.
	* java/nio/CharViewBufferImpl.java (<init>):  Pass byte-order.
	(get, put):  Use ByteBufferHelper.
	(compact):  Use new shiftDown method.
	(duplicate(boolean)):  New helper method.
	(duplicate, asReadOnlyBuffer):  Use it.
	(order):  Return endian field.
	* java/nio/DoubleViewBufferImpl.java:  Likewise.
	* java/nio/FloatViewBufferImpl.java:  Likewise.
	* java/nio/IntViewBufferImpl.java:  Likewise.
	* java/nio/LongViewBufferImpl.java:  Likewise.
	* java/nio/ShortViewBufferImpl.java:  Likewise.
	* java/nio/CharViewBufferImpl.java (subsequence):  Redundant test.
	* java/nio/DirectByteBufferImpl.java (shiftDown):  New native method.
	(compact):  Re-implement using shiftDown.

2004-02-11  Michael Koch  <konqueror@gmx.de>

	* include/java_nio_DirectByteBufferImpl.h: Regenerated.
	* native/jni/java-nio/java_nio_DirectByteBufferImpl.c
	(shiftDown): New method.

2004-02-11  Michael Koch  <konqueror@gmx.de>

	* java/lang/ref/Reference.java
	(Reference): Fixed typo.

2004-02-11  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/undo/UndoManager.java: Re-written from scratch.

2004-02-10  David Jee  <djee@redhat.com>

	* java/awt/BorderLayout.java
	(calcCompSize): Invisible components get zero dimensions.
	* java/awt/Button.java
	(setLabel): Set actionCommand.
	* java/awt/Component.java
	(show): Invalidate component and parent container.
	(hide): Likewise.

2004-02-10  David Jee  <djee@redhat.com>

	* java/awt/GridBagLayout.java
	(GridBagLayout): New private field, internalcomptable.
	(lookupInternalConstraints): New method.
	(ArrangeGrid): Use components' MINSIZE. Use internalcomptable.
	(GetLayoutInfo): Reimplement.
	(calcCellSizes): Ignore rows/columns with size 0.

2004-02-10  David Jee  <djee@redhat.com>

	* gnu/java/awt/peer/gtk/GtkButtonPeer.java
	(gtkSetLabel): New native method definition.
	(setLabel): Use gtkSetLabel.
	* include/gnu_java_awt_peer_gtk_GtkButtonPeer.h: Regenerated.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkButtonPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkButtonPeer_gtkSetLabel): New method.

2004-02-10  Ito Kazumitsu  <kaz@maczuka.gcd.org>

	* java/io/ObjectInputStream.java (readClassDescriptor): Avoid the
        overflow of fieldmapping.

2004-02-06  Mohan Embar  <gnustuff@thisiscool.com>

	* java/io/BufferedReader.java (sbuf): New field.
	(readLine): Use String.valueOf instead of new String() as per
	Per Bothner's suggestion. Use instance sbuf field instead of a
	local StringBuffer instance.

2004-02-06  Scott Gilbertson  <scottg@mantatest.com>

	* gnu/java/awt/peer/ClasspathFontPeer.java (getTransform): Never
	return null. 

2004-02-06  Graydon Hoare  <graydon@redhat.com>

	* javax/swing/SwingUtilities.java: Many new functions.
	* java/awt/Container.java (LightweightDispatcher): Reimplement.
	* javax/swing/basic/BasicGraphicsUtils.java 
	(getPreferredButtonSize): Start layout from top-left corner.

2004-02-06  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/NIOServerSocket.java
	(impl): Unused, removed.
	* gnu/java/nio/SocketChannelImpl.java
	(finnishConnect): Don't throw NoConnectionPendingException if not
	connected or no connection pending.

2004-02-06  Mohan Embar  <gnustuff@thisiscool.com>

	* gnu/java/nio/DatagramChannelImpl.java
	(inChannelOperation): New field.
	(isInChannelOperation): New accessor.
	(setInChannelOperation): New modifier.
	(receive): Use capacity() - position() of destination
	buffer instead of remaining(). Set and reset our "in
	channel operation indicator" before and after delegating
	the receive to our datagram socket. Removed testing code.
	Update destination buffer's current position if it is
	backed by a byte array (hasArray() is true).
	(send): Set and reset our "in channel operation indicator"
	before and after delegating the send to our datagram socket.
	Removed testing code. Update source buffer's current position
	if it is backed by a byte array (hasArray() is true).
	* gnu/java/nio/SocketChannelImpl.java (read(ByteBuffer)):
	Use capacity() - position() of destination buffer instead
	of remaining().
	* java/net/DatagramSocket.java (receive): Don't throw an
	IllegalBlockingModeException if we have a non-blocking
	channel which initiated this operation.
	(send): Likewise.

2004-02-06  Mohan Embar  <gnustuff@thisiscool.com>

	* gnu/java/net/PlainSocketImpl.java 
	(inChannelOperation): New field.
	(isInChannelOperation): New accessor.
	(setInChannelOperation): New modifier.
	* gnu/java/nio/ServerSocketChannelImpl.java
	(accept): Set and reset our server socket's PlainSocketImpl's
	"in channel operation" indicator before and after delegating
	the accept to our server socket.
	* gnu/java/nio/SocketChannelImpl.java
	(connect): Set and reset our socket's PlainSocketImpl's "in channel
	operation" indicator before and after delegating the operation to
	our socket.
	(read): Likewise.
	(write): Likewise.
	* java/net/ServerSocket.java (implAccept): Don't throw an
	IllegalBlockingModeException if we have a non-blocking
	channel which initiated this accept operation.
	* java/net/Socket.java (connect): Don't throw an
	IllegalBlockingModeException if we have a non-blocking
	channel which initiated this connect operation.
	* java/nio/channels/spi/AbstractSelectableChannel.java
	(configureBlocking): Only call implConfigureBlocking() if
	the desired blocking mode is different from our current one.

2004-02-06  Michael Koch  <konqueror@gmx.de>

	* java/awt/Scrollbar.java
	(setBlockIncrement): Fixed.

2004-02-06  Michael Koch  <konqueror@gmx.de>

	* java/awt/datatransfer/DataFlavor.java
	(imageFlavor): Javadoc added.
	(javaJVMLocalObjectType): Fixed.

2004-02-06  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/GenericBuffer.cpp,
	* gnu/java/nio/GenericMappedByteFileBuffer.cpp:
	Removed.

2004-02-05  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* java/awt/Component.java (getFont): Return a default font
	instead of null.

2004-02-05  Olga Rodimina <rodimina@redhat.com>

	* java/awt/geom/AffineTransform.java:
	Corrected comments on the field definitions 
	for m11 and m10
	(shear): Fixed few errors that caused shear 
	transformation to be performed incorrectly.
	(createInverse): Fixed to return correct inverse
	of the given matrix.

2004-02-05  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* java/awt/Scrollbar.java (next_scrollbar_number): New field.
	(Scrollbar (int, int, int, int, int)): Make default page
	increment 10.
	(setValues): Only call peer.setValues if one of the values has
	changed.
	(generateName): New method.
	(getUniqueLong): New method.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkScrollBarPeer.c
	(range_scrollbar): Remove structure.
	(post_adjustment_event): Remove function.
	(post_change_event): Accept jobject argument.
	(create): Cast jints to gdoubles.  Round scrollbar values to the
	nearest integer.  Clamp min, max and value settings.
	(connectJObject): Connect hook to widget->window.
	(connectSignals): Remove range_scrollbar structure variables.
	Remove "move-slider" connection.  Pass global peer reference to
	"value-changed" callback.
	(setLineIncrement): Cast jint value to gdouble.
	(setPageIncrement): Likewise.
	(setValues): Likewise.  Clamp min, max and value settings.

2004-02-05  Michael Koch  <konqueror@gmx.de>

	* javax/swing/AbstractCellEditor.java
	(getCellEditorValue): Removed.
	* javax/swing/Box.java: Reformated.
	(serialVersionUID): New field.
	* javax/swing/ButtonGroup.java:
	Removed some weird whitespace.
	* javax/swing/CellEditor.java: Reformated.
	* javax/swing/CellRendererPane.java
	(serialVersionUID): New field.
	(AccessibleCellRendererPaneserialVersionUID): New field.
	* javax/swing/DefaultListModel.java
	(serialVersionUID): New field.
	* javax/swing/JEditorPane.java
	(serialVersionUID): New field.
	(setPage): Throws IOException.
	(addHyperlinkListener): Implemented.
	(removeHyperlinkListener): Implemented.
	(getHyperlinkListener): New method.
	* javax/swing/JFileChooser.java
	(serialVersionUID): New field.
	(AccessibleJFileChooser.serialVersionUID): New field.
	(addActionListener): Implemented.
	(removeActionListener): Implemented.
	(getActionListeners): New method.
	* javax/swing/JFormattedTextField.java
	(serialVersionUID): New field.
	(AbstractFormatter.serialVersionUID): New field.
	(clone): Throws CloneNotSupportedException
	(setEditValid): Add missing argument.
	(stringToValue): Throws ParseExcpetion.
	(valueToString): Throws ParseException.
	(commitEdit): Throws ParseException.
	* javax/swing/JLabel.java
	(serialVersionUID): New field.
	* javax/swing/JList.java
	(serialVersionUID): New field.
	(addListSelectionListener): Reformated.
	(removeListSelectionListener): Reformated.
	(getListSelectionListeners): New method.
	* javax/swing/colorchooser/AbstractColorChooserPanel.java:
	Reformated.
	(serialVersionUID): New field.
	* javax/swing/table/AbstractTableModel.java
	(getValueAt): Removed.
	(getColumnCount): Removed.
	(getRowCount): Removed.

2004-02-05  Michael Koch  <konqueror@gmx.de>

	* javax/naming/directory/Makefile.am,
	javax/naming/event/Makefile.am,
	javax/naming/ldap/Makefile.am,
	javax/naming/spi/Makefile.am,
	javax/rmi/CORBA/Makefile.am,
	javax/rmi/Makefile.am,
	javax/security/auth/x500/Makefile.am,
	javax/transaction/Makefile.am,
	javax/transaction/xa/Makefile.am
	(EXTRA_DIST): Added package.html.
	* javax/naming/directory/package.html,
	javax/naming/event/package.html,
	javax/naming/ldap/package.html,
	javax/naming/spi/package.html,
	javax/rmi/CORBA/package.html,
	javax/rmi/package.html,
	javax/security/auth/x500/package.html,
	javax/transaction/package.html,
	javax/transaction/xa/package.html: New files.

2004-02-04  Michael Koch  <konqueror@gmx.de>

	* pkg.m4: New file.

2004-02-04  Michael Koch  <konqueror@gmx.de>

	* configure.ac: Fixed little bug (s/gthread/gthread-2.0/).
	* doc/hacking.texinfo (API COmpatibility): Added menu to make makeinfo silent.

2004-02-04  Michael Koch  <konqueror@gmx.de>

	* java/lang/Thread.java
	(Thread): Merged extensive javadoc from libgcj.
	(setName): Do explicit null pointer check.
	(toString): Reformated. Simplified javadoc.

2004-02-04  Michael Koch  <konqueror@gmx.de>

	* configure.ac: No need to call AC_PROG_MAKE_SET explicitely.
	Define conditiional for building glibj.zip. Simplified GTK checks.
	* lib/Makefile.am: Build glibj.zip conditionally.
	* native/jni/gtk-peer/Makefile.am: Removed references of GTHREAD_*
	and LIBART_*, all is now in GTK_*.

2004-02-04  Michael Koch  <konqueror@gmx.de>

	* java/util/zip/Deflater.java,
	java/util/zip/DeflaterOutputStream.java,
	java/util/zip/GZIPInputStream.java,
	java/util/zip/GZIPOutputStream.java:
	Merged class head with libgcj.

2004-02-03  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkListPeer.java,
	java/awt/BorderLayout.java, java/awt/CardLayout.java,
	java/awt/CheckboxGroup.java, java/awt/Choice.java,
	java/awt/Component.java, java/awt/Container.java,
	java/awt/FontMetrics.java, java/awt/GridBagLayout.java,
	java/awt/LayoutManager2.java, java/awt/List.java,
	java/awt/Menu.java, java/awt/MenuBar.java,
	java/awt/MenuItem.java, java/awt/Polygon.java,
	java/awt/Rectangle.java, java/awt/ScrollPane.java,
	java/awt/Scrollbar.java, java/awt/TextArea.java,
	java/awt/TextField.java,
	java/awt/image/renderable/RenderContext.java,
	javax/swing/JApplet.java: Fix handling of alias methods, where a
	method has been deprecated in favour of a new one with the same
	funtion but a different name.  Put the method implementation in
	the deprecated method and have the new method call the
	deprecated one.  Make all other code call the new method.

2004-02-03  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* doc/hacking.texinfo (Serialization): Add section header.
	(Deprecated Methods): New section.

2004-02-02  Jeroen Frijters  <jeroen@frijters.net>

	* java/lang/Thread.java (setDaemon): Allow daemon state to be
	changed for dead threads.

2004-02-02  Jeroen Frijters  <jeroen@frijters.net>

	* java/io/ObjectInputStream.java: Made all calls
	to dumpElement[ln] conditional on dump flag. (readObject): Changed to
	use cached info from ObjectStreamClass. (readClassDescriptor):
	Cache more information in ObjectStreamClass. (processResolution,
	readFields): Use cached info from ObjectStreamClass.
	(newObject): Throw exception instead of returning null for failure.
	(getField, getMethod, callReadMethod, setBooleanField, setByteField,
	setCharField, setDoubleField, setFloatField, setIntField,
	setLongField, setShortField, setObjectField, readObjectParams):
	Removed. (dumpElement, dumpElementln): Removed dump flag condition
	check.
	* java/io/ObjectStreamField.java (hasReadMethod): Removed.
	(setClass): Added call to cacheMethods() (findMethod): New method.
	(cacheMethods): New method. (ObjectStreamClass): Added call to
	cacheMethods(). (setFields): Cache fields. (getClassUID): Use
	AccessController.doPrivileged to invoke setAccessible.
	(readObjectMethod, readResolveMethod, realClassIsSerializable,
	realClassIsExternalizable, fieldMapping, firstNonSerializableParent):
	New fields.
	* java/io/ObjectStreamField.java (ObjectStreamField): New constructor.
	(ObjectStreamField): Removed FIXME workaround. (getTypeString,
	isPrimitive): Made safe for cases where type == null.
	(setBooleanField, setByteField, setCharField, setShortField,
	setIntField, setLongField, setFloatField, setDoubleField,
	setObjectField): New methods.

2004-02-02  Jeroen Frijters  <jeroen@frijters.net>

	* gnu/java/net/protocol/file/Handler.java (parseURL): Fixed support
	for relative file: urls.

2004-02-01  Mark Wielaard  <mark@klomp.org>

	* configure.ac: Add PKG_CHECK_MODULES check for GTHREAD.
	* native/jni/gtk-peer/Makefile.am (libgtkpeer_la_LDFLAGS): Remove
	GLIB_LIBS, add GTHREAD_LIBS.
	(INCLUDES): Add GTHREAD_CFLAGS.

2004-02-01  Mark Wielaard  <mark@klomp.org>

	* doc/hacking.texinfo (Programming Standards): Escape { and } with @
	in examples.

2004-01-31  Michael Koch  <konqueror@gmx.de>

	* resource/java/security/Makefile.am: Removed comment that does not
	apply anymore.

2004-01-30  Tom Tromey  <tromey@redhat.com>

	* doc/hacking.texinfo (Programming Standards): Added more
	guidelines.

2004-01-30  Michael Koch  <konqueror@gmx.de>

	* java/util/logging/Makefile.am: Include logging.properties in dist
	tarball.
	* native/jni/Makefile.am: Reworked subdir handling.
	* native/Makefile.am: Likewise.
	* resource/java/security/Makefile.am: Simplified classpath.security
	handling.

2004-01-30  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/http/Connection.java
	(getOutputStream): Fixed typo.

2004-01-30  Michael Koch  <konqueror@gmx.de>

	* configure.ac (AC_CONFIG_FILES): Removed lib/gen_nio.sh and fixed
	quotation.
	* java/nio/GenericBuffer.cpp: Removed.
	* lib/gen_nio.sh.in: Removed.
	* lib/Makefile.am: Removed rule to regenerate NIO buffer classes.

2004-01-29  Kim Ho  <kho@redhat.com>

	* gnu/java/awt/peer/gtk/GtkFramePeer.java
	(gtkLayoutSetVisible): New method
	(setMenuBar): Hide layout before setting MenuBar
	and reshow it after.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(gtkLayoutSetVisible): Hide or show the Gtk Layout.
	* include/gnu_java_awt_peer_gtk_GtkFramePeer.h:
	Regenerated.

2004-01-28  Michael Koch  <konqueror@gmx.de>

	* java/lang/Thread.java: Reordered methods to match libgcj.

2004-01-28  Michael Koch  <konqueror@gmx.de>

	* javax/swing/JComponent.java
	(listenerList): Initalize globally.
	(ancestor_list): Removed.
	(veto_list): Removed.
	(change_list): Removed.
	(get_veto_list): Removed.
	(get_change_list): Removed.
	(get_ancestor_list): Removed.
	(removeAncestorListener): Reimplemented.
	(removePropertyChangeListener): Likewise.
	(removeVetoableChangeListener): Likewise.
	(addAncestorListener): Likewise.
	(addPropertyChangeListener): Likewise.
	(addVetoableChangeListener): Likewise.
	(getListeners): New method.
	(getAncestorListeners): Likewise.
	(getVetoableChangeListeners): Likewise.
	(fireVetoableChange): Throws PropertyVetoException.
	* javax/swing/JEditorPane.java
	(JEditorPane): Throws IOException.

2004-01-28  David Jee  <djee@redhat.com>

	* gnu/java/awt/peer/gtk/GtkFramePeer.java
	(create): Set the default foreground color to
	java.awt.SystemColor.windowText.

2004-01-28  Kim Ho  <kho@redhat.com>

	* include/gnu_java_awt_peer_gtk_GtkMenuComponentPeer.h:
	New file.
	* include/Makefile.am: Updated.

2004-01-28  Michael Koch  <konqueror@gmx.de>

	* gnu/java/awt/peer/gtk/GtkFramePeer.java:
	Merged formating with libgcj.

2004-01-27  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkFramePeer.java (setResizable):
	Override GtkWindowPeer's setResizable method to account for menu
	bar height when setting the frame's size.

2004-01-27  Michael Koch  <konqueror@gmx.de>

	* java/awt/Container.java: Merged formating with libgcj.

2004-01-27  Kim Ho  <kho@redhat.com>

	* gnu/java/awt/peer/gtk/GtkFileDialogPeer.java
	(gtkWidgetGetDimensions): Remove.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(gtkWidgetGetDimensions): Remove.
	
	* gnu/java/awt/peer/gtk/GtkComponentPeer.java (GtkComponentPeer): If
	it is a FileDialog and has dimensions of 0 by 0, then the initial
	size is set to size request plus insets.
	* gnu/java/awt/peer/gtk/GtkFileDialogPeer.java
	(gtkWidgetGetDimensions): Override method.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(gtkWidgetGetDimensions): Override method. Returns size request plus
	insets.

2004-01-27  Michael Koch  <konqueror@gmx.de>

	* gnu/java/awt/peer/gtk/GtkFileDialogPeer.java: Merged copyright year.

2004-01-27  Kim Ho  <kho@redhat.com>

	* gnu/java/awt/peer/gtk/GtkFramePeer.java (moveLayout): New
	method.
	(setMenuBar): Shift the Gtk layout up/down by the MenuBar
	height and let the Layout Managers readjust anything that
	needs to move.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(moveLayout): New method. Shift everything in the Gtk
	layout in the Y direction by an offset.

	* gnu/java/awt/peer/gtk/GtkFramePeer.java
	(removeMenuBarPeer): Remove MenuBarPeer argument.
	* gnu/java/awt/peer/gtk/GtkMenuComponentPeer.java
	(dispose): Call native method.
	* java/awt/Frame.java (setMenuBar): Create and remove
	MenuBar peers only if the Frame has a peer.
	(addNotify): Create the MenuBar peer if one exists.
	(removeNotify): Remove MenuBar peer if one exists.
	* java/awt/Menu.java: Fix imports.
	(addNotify): Don't use full class name.
	(removeNotify): Call removeNotify on all children.
	* java/awt/MenuBar.java (removeNotify): Call
	removeNotify on all children.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(removeMenuBarPeer): Remove MenuBarPeer argument.
	Iterate through children to find the Frame's MenuBar.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMenuComponentPeer.c
	New file.
	(dispose): Remove references to the MenuComponent.

	* gnu/java/awt/peer/gtk/GtkFramePeer.java (menuBarHeight): Mark
	private.
	(setMenuBar): Grab MenuBar height and change insets.
	(setBounds): Account for MenuBar height.
	(postInsetsChangedEvent): Ditto.
	(postSizeAllocateEvent): Remove.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(menubar_resize_cb): Remove
	(setMenuBarPeer): Remove callback.
	(getMenuBarHeight): Use size requisition instead of
	allocation.

	* gnu/java/awt/peer/gtk/GtkFramePeer.java (postConfigureEvent):
	Fix comments.
	(removeMenuBarPeer): Make package private.
	(setMenuBarPeer): Make package private.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(menubar_resize_cb): Mark attributes unused.
	(getMenuBarHeight): Ditto.

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(connectJObject): Iterate through the vbox's children to find layout.
	And fixed date on last Changelog entry.

2004-01-27  Michael Koch  <konqueror@gmx.de>

	* HACKING, INSTALL, configure.ac, doc/hacking.texinfo:
	Updated to depend on autoconf 2.59 and automake 1.7.
	Also depend on GCJ 3.3 in all files.

2004-01-27  David Jee  <djee@redhat.com>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(addExposeFilter): Handle GtkFramePeer separately.
	(removeExposeFilter): Likewise.

2004-01-27  Kim Ho  <kho@redhat.com>

	* gnu/java/awt/peer/gtk/GtkFramePeer.java (getMenuBarHeight): Added
	MenuBarPeer parameter.
	(removeMenuBarPeer): New native method.
	(setMenuBar): Call remove if menu bar is null. Adjust insets
	appropriately.
	(postSizeAllocateEvent): New method. Called when menu bar size is
	allocated. Adjust insets and redo layout.
	(GtkFramePeer): Set menu bar during frame creation.
	(postConfigureEvent): Adjust position and size to accomodate
	menu bar.
	* java/awt/Frame.java (setMenuBar): addNotify to create menu bar.
	* java/awt/Menu.java (addSeparator): Use peer's addSeparator.
	(addNotify): Create the peer if it doesn't exist and call addNotify
	for the menu's items.
	* java/awt/MenuBar.java (addNotify): Create this menu bar's menus.
	* java/awt/MenuItem.java (addNotify): Create the peer if it
	doesn't exist.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(removeMenuBarPeer): New method. Remove menu bar on the current
	frame.
	(setMenuBarPeer): Add the menu bar to the current frame and the
	callback for size-allocate events on the menu bar.
	(getMenuBarHeight): Add menu bar parameter.
	(menubar_resize_cb): New callback method for postSizeAllocate events.

2004-01-27  Michael Koch  <konqueror@gmx.de>

	* native/target/generic/target_generic_file.h:
	Include fcntl.h

2004-01-27  Michael Koch  <konqueror@gmx.de>

	* javax/swing/AbstractAction.java: Reformated.

2004-01-27  Michael Koch  <konqueror@gmx.de>

	* include/gnu_java_awt_peer_gtk_GtkFileDialogPeer.h: Updated with
	current gnu.java.awt.peer.gtk.GtkFileDialogPeer class.

2004-01-27  Michael Koch  <konqueror@gmx.de>

	* javax/swing/AbstractAction.java: Reformated.
	(getPropertyChangeListeners): New method.
	* javax/swing/AbstractCellEditor.java: Reformated.
	(getCellEditorListeners): New method.
	* javax/swing/DefaultListSelectionModel.java
	(listenerList): New field.
	(listeners): Removed.
	(get_listeners): Removed.
	(addListSelectionListener): Rewritten.
	(removeListSelectionListener): Rewritten.
	(getListSelectionListeners): New method.
	(getListeners): New method.
	* javax/swing/JComboBox.java: Imports reworked.
	(addActionListener): Implemented.
	(removeActionListener): Implemented.
	(addItemListener): Implemented.
	(removeItemListener): Implemented.
	(addPopupMenuListener): Implemented.
	(removePopupMenuListener): Implemented.
	(getActionListeners): New method.
	(getItemListeners): New method.
	(getPopupMenuListeners): New method.

2004-01-27  Andrew Haley  <aph@redhat.com>

	* javax/swing/table/JTableHeader.java: Extend JComponent

2004-01-27  David Jee  <djee@redhat.com>

	* gnu/java/awt/peer/gtk/GtkComponentPeer.java
	(handleEvent): Implemented. Handles PaintEvents.
	(paint): Implemented. Use GTK native methods to queue updates
        for this heavyweight peer.
	* gnu/java/awt/peer/gtk/GtkContainerPeer.java
	(handleEvent): Removed.
	* include/gnu_java_awt_peer_gtk_GtkComponentPeer.h: Regenerated.
	* java/awt/Component.java
	(paint): Implemented. Explictly paint the heavyweight peer.
	(update): Clear the background for heavyweight components.
	(paintAll): No need to call peer.paint() anymore.
	(processEvent): Don't process PaintEvents here. It's now done in
	the peer's handleEvent().
	(processPaintEvent): Removed.
	* java/awt/Container.java
	(paint): No need to call super.paint(). Visit heavyweight
	children as well.
	(update): Don't clear the background here.  It's done in
	Component.update().
	(visitChildren): Added check to not recurse into Containers.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(filter_expose_event_handler): New method.  Filter unwanted
	expose events while painting heavyweight peers.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_addExposeFilter):
	New method. Connect filter and block pre_event_handler.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_removeExposeFilter):
	New method. Disconnect filter and unblock pre_event_handler.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_gtkWidgetQueueDrawArea):
	New method. Invalidate and update given area.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(pre_event_handler): Add checks for unwanted expose events.

2004-01-22  Graydon Hoare  <graydon@redhat.com>

	* gnu/java/awt/peer/gtk/GdkClasspathFontPeer.java: 
	* gnu/java/awt/peer/gtk/GdkGlyphVector.java:
	Predicate static initialization on GtkToolkit.useGraphics2D().
	* java/awt/Component.java (processPaintEvent): Consume event.
	* javax/swing/AbstractButton.java: Reimplement, document.
	* javax/swing/DefaultButtonModel.java: Reimplement, document.
	* javax/swing/JComponent.java (paint): Use double buffer.
	(listenerList): Enable member.
	* javax/swing/ToggleButtonModel.java: Remove incorrect constructor.
	* javax/swing/JToggleButton.java 
	(JToggleButton): Modify model constructor.
	* javax/swing/SwingUtilities.java 
	(layoutCompoundLabel): Adjust arithmetic.
	* javax/swing/plaf/basic/BasicButtonUI.java: Reimplement, document.
	* javax/swing/plaf/basic/BasicGraphicsUtils.java 
	(getPreferredButtonSize): Include margins in calculation.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkWindowPeer_connectSignals):
	Receive up events from subordinate layout component.

2004-01-12  Graydon Hoare  <graydon@redhat.com>

	* gnu/java/awt/gtk/GdkGraphics2D.java
	(static): Check GtkToolkit before initializing static state.
	(Graphics2D): Don't construct transform with 0.5 unit offset.

2004-01-26  David Jee  <djee@redhat.com>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(find_bg_color_widget): For GtkButton, return its child.

2004-01-26  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/EventQueue.java (invokeAndWait): Use list-aware
	isDispatchThread method to replace wrong test condition.
	(pop): Prevent racing condition to add events to the queue out of order
	by acquiring locks in the proper order and not by releasing one before
	acquiring the other.
	(getCurrentEvent): Consider that system events may be handled by any
	queue in the stack.

2004-01-26  Fernando Nasser  <fnasser@redhat.com>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(pre_event_handler): Discard GDK_ENTER_NOTIFY related to ungrabs.

2004-01-26  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/EventQueue.java (pop): Prevent breaking the chain if pop
	is called for an intermediate queue.

2004-01-26  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/EventDispatchThread.java (run): Stop running when
	interrupted.
	* java/awt/EventQueue.java (pop): Stop dispatch thread when done.
	Reset the queue after transferring its contents.
	(push): Start a new dispatch thread if none is running.

2004-01-26  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/EventQueue.java (isDispatchThread): Do check on top of stack.
	(push): Make sure push is performed at the top of the thread stack.

2004-01-26  Fernando Nasser  <fnasser@redhat.com>

	* gnu/java/awt/peer/gtk/TestAWT.java (DialogWindow): Make text not
	visible so that dialog can be reused.

2004-01-26  Fernando Nasser  <fnasser@redhat.com>
 
	* gnu/java/awt/peer/gtk/TestAWT.java (DialogWindow): Add WindowAdapter
	to handle Window "Closing" events.
 
2004-01-26  Fernando Nasser  <fnasser@redhat.com>

	* gnu/java/awt/peer/gtk/TestAWT.java: Fix test program so that it does
	not show modal dialogs twice and so that it allows showing a modal
	dialog from another modal dialog.

2004-01-26  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/Dialog.java (show): Enable blocking for all modal dialogs
	and run secondary dispatch thread to process event queue while this
	thread is blocked.

2004-01-26  Fernando Nasser  <fnasser@redhat.com>

	* gnu/java/awt/peer/gtk/GtkFileDialogPeer.java (nativeSetFile):
	New name for the former setFile native method.
	(setFile): New method.
	(setDirectory): Implemented.
	(connectSignals): New native method.
	(setFilenameFilter): Improve comment.
	(getGraphics): Comment.
	(gtkHideFileDialog): New method.
	(gtkDisposeFileDialog): New method.
	(gtkSetFilename): New method.
	* java/awt/Dialog.java (show): Block on modal dialogs, but only
	for FileDialog for now.
	(hide): New method.
	(dispose): New method.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkFileDialogPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkFileDialog_create): Replace
	deprecated creation functions.  Make dialog modal.  Add it to the
	window group.
	(Java_gnu_java_awt_peer_gtk_GtkFileDialog_connectSignals): New
	function.
	(Java_gnu_java_awt_peer_gtk_GtkFileDialogPeer_gtkFileSelectionSetFilename):
	Rename to...
	(Java_gnu_java_awt_peer_gtk_GtkFileDialogPeer_nativeSetFile): New
	name.
	(window_closed): New function.
	(ok_clicked): New function.
	(cancel_clicked): New function.

2004-01-25  Tom Tromey  <tromey@redhat.com>

	* java/lang/Class.java (internalGetMethod): Now private.

2004-01-25  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* java/awt/Component.java (show): Set visible to true before
	showing the peer.

	* java/awt/TextArea.java: Fix indentation.  Flesh out javadocs.
	(getMinimumSize (int, int)): Fix FIXME -- return Dimension (0,0)
	when peer is null.
	(setColumns): Remove FIXME -- peer will retrieve number of
	columns by calling getColumns.
	(setRows): Likewise for number of rows.
	(next_text_number): New field.
	(paramString): Fix param string.
	(generateName): New method.
	(getUniqueLong): New method.

	* gnu/java/awt/peer/gtk/GtkToolkit.java (checkImage): Inform
	image observer of image loading status.
	(getImage (String)): Start image production.
	(getImage (URL)): Likewise.

2004-01-25  Michael Koch  <konqueror@gmx.de>

	* java/lang/Class.java
	(getInterfaces): Change html tags to lower case.
	(getPackagePortion): Made private, moved around.

2004-01-25  Michael Koch  <konqueror@gmx.de>

	* java/lang/Class.java
	(getDeclaredMethod): Renamed argument "name" to "methodName".
	(getField): Renamed argument "name" to "fieldName".
	(getResource): Renamed argument "name" to "resourceName".
	Call resourcePath() instead of doing the work here.
	(getResourceAsStream): Renamed argument "name" to "resourceName".
	Call resourcePath() instead of doing the work here.
	(resourcePath): New method.

2004-01-25  Michael Koch  <konqueror@gmx.de>

	* java/lang/Class.java: Moved all methods to get it in order with
	libgcj.

2004-01-25  Michael Koch  <konqueror@gmx.de>

	* gnu/java/lang/ClassHelper.java
	(getPackagePortion): Moved to java.lang.Class.
	* java/lang/Class.java: Merged more with libgcj, renamed some
	variables.
	(toString): Moved.
	(getPackagePortion): New method.
	
2004-01-25  Michael Koch  <konqueror@gmx.de>

	* java/net/URLConnection.java
	(fileNameMap): Don't initialize. Initialization should be lazy.
	(guessContentTypeFromName): Get filename map from getFileNameMap().
	(getFileNameMap): Made it synchronized. Initialize fileNameMapa if
	needed.

2004-01-25  Michael Koch  <konqueror@gmx.de>

	* java/io/FileDescriptor.java
	(open): Javadoc added.
	(close): Likewise.
	(write): Likewise.
	(read): Likewise.
	(available): Likewise.
	(seek): Likewise.
	(getFilePointer): Likewise.
	(getLength): Likewise.
	(setLength): Likewise.

2004-01-25  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/FileLockImpl.java:
	Fixed filename in copyright.
	(released): Removed.
	(finalize): New method.

2004-01-23  Michael Koch  <konqueror@gmx.de>

	* java/io/FileDescriptor.java: Reformated.

2004-01-22  Michael Koch  <konqueror@gmx.de>

	* java/util/logging/logging.properties: New file.
	* java/util/logging/Makefile.am: Install logging.properties.

2004-01-21  David Jee  <djee@redhat.com>

	* java/awt/Container.java
	(LightweightDispatcher.handleEvent): Add an extra check to avoid
	dispatching MOUSE_ENTERED event twice. Translate the point for
	the mouse event target before dispatching the event.

2004-01-21  Jeroen Frijters  <jeroen@frijters.net>

	* gnu/java/io/PlatformHelper.java (isRootDirectory): Fixed, by
	delegating to beginWithRootPathPrefix.

2004-01-20  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* include/gnu_java_awt_peer_gtk_GtkTextFieldPeer.h: Regenerate.

	* gnu/java/awt/peer/gtk/GtkComponentPeer.java (setBounds):
	Calculate proper offsets for heavyweight components packed in
	lightweight containers.

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(window_property_changed_cb): Set id_set.

2004-01-20  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkTextFieldPeer.java,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextFieldPeer.c
	(native create): Add width parameter.
	(create): Calculate text entry width based on current font's
	metrics and number of columns.  Set TextField's font if not
	already set.  Call native create.
	(gtkEntryGetBorderWidth): New native method.
	(gtkEntryGetSize): Remove method.
	(getMinimumSize): Call minimumSize.
	(getPreferredSize): Call preferredSize.
	(minimumSize): Calculate minimum size based on backing
	GtkEntry's borders, font metrics and number of columns.
	(preferredSize): Likewise for preferred size.
	(get_border_width): New static function.

2004-01-18  Michael Koch  <konqueror@gmx.de>

	* scripts/classpath-build,
	scripts/classpath-daily: New files for regular classpath
	compilation/testing.

2004-01-18  Michael Koch  <konqueror@gmx.de>

	* configure.in: Removed.
	* configure.ac: New file.

2004-01-18  Michael Koch  <konqueror@gmx.de>

	* configure.in: Fix AC_CONFIG_FILES usage and use AC_OUTPUT_COMMANDS.

2004-01-18  Michael Koch  <konqueror@gmx.de>

	* HACKING: Updated autoconf and automake prerequisite descriptions.
	* acinclude.m4 (CLASSPATH_ENABLE_GJDOC): Use AS_HELP_STRING,
	fix quotation.
	* configure.in: Rewrote AC_ARG_ENABLE usage to use AC_HELP_STRING and
	to use a correct quotation. Use pkgconfig to search for glib, gtk and
	libart. Ported AC_OUTPUT() to new AC_CONFIG_FILES()/AC_OUTPUT.

2004-01-16  Tom Tromey  <tromey@redhat.com>

	* java/awt/Container.java: Typo and indentation fixes.

2004-01-16 Olga Rodimina <rodimina@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java:
	(doPolygon): set fill rule of polygon to
	WIND_EVEN_ODD by default.
                                                                                
2004-01-16  Michael Koch  <konqueror@gmx.de>

	* acinclude.m4: Fixed quotation to get rid of warnings with
	automake 1.8.x.

2004-01-15  Olga Rodimina <rodimina@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java:
	Implemented rendering hints related methods.
	(getDefaultHints): New helper method. Returns
	default rendering hints.
	(walkPath): changed to normalize path if
	the KEY_STROKE_CONTROL key is in "normalize" mode.
	(draw3DRect): changed coordinates of rectangle by +0.5
	if in "normalize" mode.

2004-01-15  Michael Koch  <konqueror@gmx.de>

	* java/io/File.java
	(list): Return null in error case.
	* native/jni/java-io/java_io_File.c
	(Java_java_io_File_listInternal): release local reference.
	This fixes classpath bug #6898.

2004-01-14  Michael Koch  <konqueror@gmx.de>

	* java/text/MessageFormat.java:
	Added descriptions to exceptions.
	This fixes PR libgcj/2429.

2004-01-13  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkTextAreaPeer.java,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextAreaPeer.c
	(native	create): Add width and height parameters.  Set text
	view's size request according to new parameters.
	(create): Calculate text view size based on current font's
	metrics and number of rows and columns.  Set TextArea's font if
	not already set.  Call native create.
	(getMinimumSize): Call minimumSize.
	(getPreferredSize): Call preferredSize.
	(getHScrollbarHeight): New method.
	(getVScrollbarWidth): New method.
	(minimumSize): Calculate minimum size based on scrollbar
	visibility, scrollbar sizes, font metrics and number of rows and
	columns.
	(preferredSize): Likewise for preferred size.
	(gtkTextGetSize): Remove method.

2004-01-13  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkComponentPeer.java
	(initializeInsets): Remove method.
	(GtkComponentPeer): Initialize insets field.  Remove call to
	initializeInsets.
	* gnu/java/awt/peer/gtk/GtkDialogPeer.java (initializeInsets):
	Remove method.
	* gnu/java/awt/peer/gtk/GtkFramePeer.java (initializeInsets):
	Remove method.
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c:
	(latestInsets): Remove field.
	(native create): Add insets parameter.  Call
	window_get_frame_extents.  Set the window's default size and
	size request based on its frame extents.
	(create): Initialize insets.
	(postInsetsChangedEvent): New method.
	(postConfigureEvent): Remove parameters top, left, bottom,
	right.  Remove insets-related logic.
	(connectJObject): Handle property-notify-event.
	(window_get_frame_extents, request_frame_extents,
	property_notify_predicate, window_property_changed_cb): New
	static functions.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(pre_event_handler): Remove insets-related logic for configure
	events.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMainThread.c (gtkInit):
	Update postConfigureEvent signature.

2004-01-13  David Jee  <djee@redhat.com>

	* gnu/java/awt/peer/gtk/GtkContainerPeer.java
	(setBackground): New method. Children with no explicitly-set
	background will be repainted with the parent container's new
	background color.

2004-01-12  David Jee  <djee@redhat.com>

	* gnu/java/net/protocol/http/Connection.java
	(sendRequest): Fix a small typo.
	* java/awt/Container.java
	(update): Clear only the clipped region, instead of clearing the
	entire Container.
	(visitChildren): Visit children in descending order.

2004-01-12  Michael Koch  <konqueror@gmx.de>

	* javax/swing/table/DefaultTableCellRenderer.java:
	Compile fixes.

2004-01-12  Arnaud Vandyck  <arnaud.vandyck@ulg.ac.be>
            Michael Koch  <konqueror@gmx.de>

	* javax/swing/table/DefaultTableCellRenderer.java
	(DefaultTableCellRenderer): Added javadoc for the class and for
	the constructor, Border instance, create an EmptyBorder.
	(UIResource): Removed the comment at the end of the class
	(setForeground): New method.
	(setBackground): New method.
	(updateUI): New method.
	(getTableCellRendererComponent): Rewritten with the help of
	dvholten and Stephane Meslin-Weber.
	(validate): New method.
	(repaint): New method.
	(firePropertyChange): New method.
	(setValue): New method.

2004-01-12  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/http/Connection.java
	(connect): Dont initialize bufferedOutputStream.
	(sendRequest): Handle case when bufferedOutputStream is null.
	(getOutputStream): Throw exception if called after it got connected.
	Initialize bufferedOutputStream.

2004-01-11  Graydon Hoare  <graydon@redhat.com>

	* javax/swing/JLayeredPane.java: Rewrite to accomodate
	djee@redhat.com's recent inverse ordering of Container
	elements.

2004-01-11  Michael Koch  <konqueror@gmx.de>

	* javax/swing/undo/StateEditable.java
	(RCSID): Removed redundant modifiers.

2004-01-10  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkToolkit.java: Don't import
	ClasspathFontPeer twice.

2004-01-10  Michael Koch  <konqueror@gmx.de>

	* javax/print/attribute/EnumSyntax.java
	(getStringTable): Made protected.
	(getEnumValueTable): Likewise.
	* javax/print/attribute/standard/JobKOctetsProcessed.java
	(JobKOctetsProcessed): Don't implement PrintRequestAttribute.
	* javax/print/attribute/standard/JobMediaSheetsCompleted.java
	(JobMediaSheetsCompleted): Made class final.
	* javax/print/attribute/standard/OutputDeviceAssigned.java
	(getName): Fixed typo.
	* javax/print/attribute/standard/RequestingUserName.java
	(serialVersionUID): Fixed value.

2004-01-10  Michael Koch  <konqueror@gmx.de>

	* javax/swing/plaf/basic/BasicButtonUI.java,
	javax/swing/plaf/basic/BasicCheckBoxUI.java,
	javax/swing/plaf/basic/BasicListUI.java,
	javax/swing/plaf/basic/BasicOptionPaneUI.java,
	javax/swing/plaf/basic/BasicPanelUI.java,
	javax/swing/plaf/basic/BasicRadioButtonUI.java,
	javax/swing/plaf/basic/BasicScrollPaneUI.java,
	javax/swing/plaf/basic/BasicToggleButtonUI.java,
	javax/swing/plaf/basic/BasicViewportUI.java:
	Fixed import statements.

2004-01-10  Michael Koch  <konqueror@gmx.de>

	* javax/swing/JRadioButtonMenuItem.java,
	javax/swing/JSeparator.java,
	javax/swing/JSplitPane.java,
	javax/swing/JTextPane.java,
	javax/swing/JToolBar.java,
	javax/swing/ListCellRenderer.java,
	javax/swing/ListModel.java,
	javax/swing/MenuElement.java,
	javax/swing/OverlayLayout.java,
	javax/swing/ProgressMonitor.java,
	javax/swing/ProgressMonitorInputStream.java,
	javax/swing/Renderer.java,
	javax/swing/RootPaneContainer.java,
	javax/swing/Scrollable.java,
	javax/swing/SingleSelectionModel.java,
	javax/swing/ToolTipManager.java,
	javax/swing/ViewportLayout.java,
	javax/swing/event/DocumentEvent.java,
	javax/swing/event/SwingPropertyChangeSupport.java,
	javax/swing/event/TreeSelectionEvent.java,
	javax/swing/event/UndoableEditEvent.java,
	javax/swing/text/AbstractDocument.java,
	javax/swing/text/AttributeSet.java,
	javax/swing/text/Caret.java,
	javax/swing/text/ComponentView.java,
	javax/swing/text/DefaultCaret.java,
	javax/swing/text/DefaultEditorKit.java,
	javax/swing/text/Document.java,
	javax/swing/text/EditorKit.java,
	javax/swing/text/GapContent.java,
	javax/swing/text/Keymap.java,
	javax/swing/text/MutableAttributeSet.java,
	javax/swing/text/PlainEditorKit.java,
	javax/swing/text/Segment.java,
	javax/swing/text/Style.java,
	javax/swing/text/StyledDocument.java,
	javax/swing/text/StyledEditorKit.java,
	javax/swing/text/TextAction.java,
	javax/swing/text/View.java: Fixed import statements.

2004-01-09  Tom Tromey  <tromey@redhat.com>

	* doc/hacking.texinfo (Programming Standards): Added some more
	standards.

2004-01-09  Michael Koch  <konqueror@gmx.de>

	* javax/print/attribute/standard/DocumentName.java,
	javax/print/attribute/standard/JobHoldUntil.java,
	javax/print/attribute/standard/JobMessageFromOperator.java,
	javax/print/attribute/standard/JobName.java,
	javax/print/attribute/standard/JobOriginatingUserName.java,
	javax/print/attribute/standard/OutputDeviceAssigned.java,
	javax/print/attribute/standard/PrinterInfo.java,
	javax/print/attribute/standard/PrinterLocation.java,
	javax/print/attribute/standard/PrinterMakeAndModel.java,
	javax/print/attribute/standard/PrinterMessageFromOperator.java,
	javax/print/attribute/standard/PrinterName.java,
	javax/print/attribute/standard/RequestingUserName.java: New files.
	* Makefile.am (javax_source_files): Added new files.
	* Makefile.in: Regenerated.

2004-01-09  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/undo/CompoundEdit.java (serialVersionUID): Made private.

2004-01-09  Michael Koch  <konqueror@gmx.de>

	* javax/swing/AbstractAction.java,
	javax/swing/AbstractSet.java,
	javax/swing/Action.java,
	javax/swing/ActionMap.java,
	javax/swing/BoundedRangeModel.java,
	javax/swing/ButtonModel.java,
	javax/swing/CellEditor.java,
	javax/swing/CellRendererPane.java,
	javax/swing/ComboBoxEditor.java,
	javax/swing/DebugGraphics.java,
	javax/swing/DefaultCellEditor.java,
	javax/swing/DefaultCellRenderer.java,
	javax/swing/DefaultComboBoxModel.java,
	javax/swing/DefaultDesktopManager.java,
	javax/swing/DefaultFocusManager.java,
	javax/swing/DefaultListCellRenderer.java,
	javax/swing/Icon.java,
	javax/swing/JButton.java,
	javax/swing/JCheckBoxMenuItem.java,
	javax/swing/JDesktopPane.java,
	javax/swing/JEditorPane.java,
	javax/swing/JMenu.java,
	javax/swing/JPanel.java,
	javax/swing/JPasswordField.java,
	javax/swing/JPopupMenu.java,
	javax/swing/JProgressBar.java: Reworked imports.

2004-01-09  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/undo/CompoundEdit.java (serialVersionUID): Added.

2004-01-09  Michael Koch  <konqueror@gmx.de>

	* java/awt/geom/PathIterator.java
	(WIND_EVEN_ODD): Removed redundant modifiers.
	(WIND_NON_ZERO): Likewise.
	(SEG_MOVETO): Likewise.
	(SEG_LINETO): Likewise.
	(SEG_QUADTO): Likewise.
	(SEG_CUBICTO): Likewise.
	(SEG_CLOSE): Likewise.
	* java/awt/image/SinglePixelPackedSampleModel.java:
	Removed redundant semicolon.
	* java/io/ObjectInputStream.java
	(inputGetObjectStreamClasses): Removed unused variable "ret_val".
	* java/util/logging/Filter.java
	(isLoggable): Removed redundant modifier.
	* java/util/logging/LogManager.java:
	Removed redundant semicolon.
	* java/util/logging/XMLFormatter.java
	(format): Removed unused variable "key".

2004-01-08  Tom Tromey  <tromey@redhat.com>

	* doc/hacking.texinfo (Programming Standards): Added note about
	NullPointerException.

2004-01-08  Michael Koch  <konqueror@gmx.de>

	* javax/swing/JLayeredPane.java: Revert changes to standard
	boilerplate, reworked imports.

2004-01-08  Graydon Hoare  <graydon@redhat.com>

	* javax/swing/JLayeredPane.java: Fix semantics, add javadocs.

2004-01-08  Mohan Embar  <gnustuff@thisiscool.com>

	* gnu/java/nio/SelectorImpl.java
	(selectThreadMutex): New field.
	(selectThread): New field.
	(unhandledWakeup): New field.
	(implCloseSelector): Added skeleton code which
	synchronizes as per Sun JRE JavaDoc.
	(keys): Throw ClosedSelectorException if selector
	is closed.
	(selectNow): Added comment that we're faking out
	an immediate select with a one-microsecond-timeout one.
	(select): Use 0 instead of -1 for infinite timeout.
	(implSelect): Changed comment in declaration.
	(select): Added synchronized to method declaration.
	Added synchronization and wakeup support as per Sun
	JRE JavaDoc.
	(selectedKeys): Throw ClosedSelectorException if selector
	is closed.
	(wakeup): Implemented.
	(deregisterCancelledKeys): Synchronize on cancelled key
	set before deregistering.
	(register): Synchronize on key set before registering.

2004-01-08  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/DatagramChannelImpl.java
	(blocking): Removed.
	(DatagramChannelImpl): Call configureBlocking().
	(implConfigureBlocking): Don't initialize blocking.
	* gnu/java/nio/PipeImpl.java
	(SourceChannelImpl): New inner class.
	(SinkChannelImpl): New inner class.
	(sink): New member variable.
	(source): New member variable.
	(PipeImpl): Add SelectorProvider argument, implemented.
	(nativeInit): New method.
	(sink): Return sink channel.
	(source): Return source channel.
	* gnu/java/nio/ServerSocketChannelImpl.java
	(serverSocket): Made private.
	(connected): Made private, don't re-initialize with default value.
	(blocking): Removed.
	(ServerSocketChannelImpl): Call configureBlocking().
	(implConfigureBlocking): Don't initialize blocking.
	* gnu/java/nio/SocketChannelImpl.java
	(blocking): Removed.
	(connectionPending): Don't re-initialize with default value.
	(SocketChannelImpl): Call configureBlocking().
	(implConfigureBlocking): Dont initialize blocking.
	(connect): Use isBlocking().
	* java/nio/channels/spi/AbstractSelectableChannel.java
	(configureBlocking): Use blockingLock() instead of LOCK.
	Set blocking after successfully called implConfigureBlocking().
	(register): Use blockingLock() instead of LOCK.

2004-01-08  Michael Koch  <konqueror@gmx.de>

	* java/text/CollationElementIterator.java
	(setText): Fixed argument name in documentation.
	* java/text/CollationKey.java
	(equals): Directly compare parent collators.

2004-01-06  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/Dialog.java (constructor): Accept null title as per spec.
	* java/awt/FileDialog.java (constructor): Throw exception on invalid
	argument as per spec.

2004-01-07  Michael Koch  <konqueror@gmx.de>

	* java/net/ServerSocket.java (isBound): Fixed documentation.

2004-01-07  Michael Koch  <konqueror@gmx.de>

	* javax/print/attribute/standard/DateTimeAtCompleted.java,
	javax/print/attribute/standard/DateTimeAtCreation.java,
	javax/print/attribute/standard/DateTimeAtProcessing.java,
	javax/print/attribute/standard/JobImpressionsCompleted.java,
	javax/print/attribute/standard/JobKOctets.java,
	javax/print/attribute/standard/JobKOctetsProcessed.java,
	javax/print/attribute/standard/JobMediaSheetsCompleted.java,
	javax/print/attribute/standard/JobPrioritySupported.java:
	New files.
	* javax/print/attribute/standard/Makefile.am (EXTRA_DIST):
	Added new files.

2004-01-07  Michael Koch  <konqueror@gmx.de>

	* java/text/CollationElementIterator.java
	(collator): Made package-private.
	(text): Likewise.
	(index): Likewise.
	(textIndex): Likewise.
	(setText): Fixed documentation.
	(setText): Renamed some variables to match libgcj's version.
	(getOffset): Added @since tag to documentation.
	* java/text/CollationKey.java
	(hashCode): Reimplemented.
	* java/text/RuleBasedCollator.java:
	Some Reformating to match libgcj's version more.

2004-01-07  Michael Koch  <konqueror@gmx.de>

	* java/lang/reflect/Array.java:
	Reformated to match libgcj's version more.

2004-01-07  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/undo/UndoableEditSupport.java (UndoableEditSupport):
	Set realSource field. Improve documentation.
	(_postEdit): Iterate over cloned listener vector.
	
	Fix for Classpath bug #7119.
	* javax/swing/undo/UndoableEditSupport.java (toString): Don't emit
	realSource.

2004-01-06  Graydon Hoare  <graydon@redhat.com>

	* configure.in: Add --enable-gtk-cairo check.
	* configure: Regenerate.
	* Makefile.am: Conditionally link against cairo.
	* Makefile.in: Regenerate.
	* acinclude.m4: Include PKG_CHECK_MODULES.
	* aclocal.m4: Regenerate.
	* gnu/java/awt/peer/gtk/GtkToolkit.java (useGraphics2D): New method.
	(getFontMetrics, getClasspathFontPeer):
	* gnu/java/awt/peer/gtk/GtkCanvasPeer.java (getGraphics):
	* gnu/java/awt/peer/gtk/GtkComponentPeer.java (createImage):
	* gnu/java/awt/peer/gtk/GtkContainerPeer.java (getGraphics):
	* gnu/java/awt/peer/gtk/GtkFramePeer.java (getGraphics):
	Switch behavior depending on GtkToolkit.useGraphics2D().
	* gnu/java/awt/peer/gtk/GtkFontPeer.java: Extend ClasspathFontPeer.
	* java/awt/Font.java: Switch to peer model.
	* jni/gtk-peer/gtkcairopeer.h: Definitions of cairo stuff.
	* jni/gtk-peer/gdkfont.h: Include gtkcairopeer.h.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics2D.c: Include gtkcairopeer.h.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkClasspathFontPeerMetrics.c: Un-include gtkpeer.h.

2004-01-06  Fernando Nasser  <fnasser@redhat.com>

	* gnu/java/awt/peer/gtk/GtkListPeer.java (handleEvent): Fix generation
	of ActionEvents for mouse double-clicks.

2004-01-06  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/Choice.java (add): Leave posting of ItemEvents to peer.
	(insert): Ditto.
	(remove): Ditto.  Also, Check for valid argument.
	(removeAll): Use peer interface method.
	* gnu/java/awt/peer/gtk/GtkChoicePeer.java (nativeAdd): New name for
	native add function.
	(nativeRemove): New name for native remove function.
	(getHistory): New native function.
	(constructor): Generate ItemEvent.
	(add): Ditto, if selection is changed.
	(remove): Ditto, ditto.
	(removeAll): Add implementation.
	(handleEvent): Remove.  Dead code.
	(choicePostItemEvent): Add comment.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkChoicePeer.c
	(Java_gnu_java_awt_peer_gtk_GtkChoicePeer_append): Add comments.
	(Java_gnu_java_awt_peer_gtk_GtkChoicePeer_add): Rename to...
	(Java_gnu_java_awt_peer_gtk_GtkChoicePeer_nativeAdd): New name.  Add
	comments and fix condition to change selection.
	(Java_gnu_java_awt_peer_gtk_GtkChoicePeer_remove): Rename to...
	(Java_gnu_java_awt_peer_gtk_GtkChoicePeer_nativeRemove): New name.  Add
	remove all capability.
	(Java_gnu_java_awt_peer_gtk_GtkChoicePeer_getHistory): New function.
	(item_activate): Add cast to remove compiler warning.

2004-01-06  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(pre_event_handler): Set all insets to 0 when a Configure event
	is received for a GtkPlug.

	* gnu/java/awt/peer/gtk/GtkScrollPanePeer.java,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkScrollPanePeer.c
	(create(int, int)): New method.
	(create): Call new create method.
	(gtkScrolledWindowNew, gtkScrolledWindowSetSize): Remove
	methods.
	(childResized): Remove native implementation.  Implement in
	Java.
	(getHScrollbarHeight, getVScrollbarWidth): Call
	gtk_widget_size_request to get scrollbar dimensions.
	* java/awt/ScrollPane.java (getViewportSize): Reimplement.  Only
	call getVScrollbarWidth and getHScrollbarHeight when vertical
	and horizontal scrollbars respectively are needed.
	(doLayout): Enlarge child if it is smaller than the viewport.

	* gnu/java/awt/peer/gtk/GtkComponentPeer.java,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(getPreferredSize): Call preferredSize.
	(preferredSize): Call gtkWidgetGetPreferredDimensions.
	(getMinimumSize): Call minimumSize.
	(minimumSize): Call gtkWidgetGetPreferredDimensions.
	(gtkWidgetGetDimensions): Return the peer widget's current size
	request.
	(gtkWidgetGetPreferredDimensions): Return the peer widget's
	natural size request.

2004-01-06  Fernando Nasser  <fnasser@redhat.com>

	* gnu/java/awt/peer/gtk/GtkChoicePeer.java (postItemEvent): Rename to...
	(choicePostItemEvent): Change signature to more specific String object.
	* java/awt/Choice.java (add): Generate ItemEvent for the first item
	added.
	(insert): Generate ItemEvent if insertion caused
	selection to change.
	(remove): Generate ItemEvent if removal cause selection to change.
	(removeAll): Change algorithm to prevent generation of ItemEvents.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkChoicePeer.c
	(connect_choice_item_selectable_hook): Change argument type.
	Fix argument value.
	Make sure resources are feed by registering callback.
	(Java_gnu_java_awt_peer_gtk_GtkChoicePeer_append): Adjust call to the
	above function.
	(Java_gnu_java_awt_peer_gtk_GtkChoicePeer_add): Ditto.
	(item_activate): Ditto.
	(Java_gnu_java_awt_peer_gtk_GtkChoicePeer_remove): Destroy removed
	menuitem.
	(item_removed): New function.  Free resources.
	* jni/gtk-peer/gtkpeer.h (item_event_hook_info): Change member type and
	name.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMainThread.c
	(Java_gnu_java_awt_peer_gtk_GtkMainThread_gtkInit): Obtain MethodID for
	choicePostItemEvent.

2004-01-06  Kim Ho  <kho@redhat.com>

	Fix for Checkbox states.
	* gnu/java/awt/peer/gtk/GtkCheckboxPeer.java:
	(currentState): New field.
	(nativeCreate): Add initial state parameter.
	(create): Changed to reflect new parameter.
	(setState): Fire only on changed states.
	(postItemEvent): Fire only on changed states. Also change the 
	Java Checkbox to reflect new state.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkCheckboxPeer.c:
	(nativeCreate): Add parameter and set active state.

2004-01-06  Fernando Nasser  <fnasser@redhat.com>

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c (awt_event_handler):
	Most coded moved to pre_event_handler, with the modifications
	mentioned below.
	(pre_event_handler): New function.  Called on the Gtk "event" signal.
	Do not retrieve the jobject from the window property as it is already
	available as user data in the signal.
	Do not try and find the grab widget as it is already done by Gtk at
	this point.
	Do not search for Window ancestor as Gtk already sends the signal to it.
	Do not meddle with the activation state of peer widgets on each
	key press or release.
	Add CList to the special handling when looking for the focused widget.
	* jni/gtk-peer/gtkpeer.h: Add declaration for pre_event_handler.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkButtonPeer.c (connectJObject):
	New function.
	(connectSignals): New function.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkCheckboxPeer.c (connectHooks):
	Rename to...
	(connectSignals): New name.  Get rid of NewGlobalRef call.
	Use g_signal_connect instead of deprecated gtk_signal_connect.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkChoicePeer.c
	(connect_choice_item_selectable_hook): Use g_signal_connect instead of
	deprecated gtk_signal_connect.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkClipboard.c
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMenuItemPeer.c
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMenuPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkClipboard_initNativeState): Ditto.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectHooks): Remove
	function.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectJObject): New
	function.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectSignals): New
	function.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkFileDialogPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectHooks): Remove
	function.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectJObject): New
	function.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkListPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectHooks): Remove
	function.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectJObject): New
	function.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectSignals): New
	function.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_old_create): Remove dead
	code.
	(item_select): Remove indirection.
	(item_unselect): Ditto.
	(connect_selectable_hook): Folded into connectSignals.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkPanelPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectHooks): Remove
	function.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectJObject): New
	function.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectSignals): New
	function.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkScrollBarPeer.c: Ditto.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextComponentPeer.c
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectHooks): Remove
	function.
	(Java_gnu_java_awt_peer_gtk_GtkComponentPeer_connectSignals): New
	function.
	* gnu/java/awt/peer/gtk/GtkComponentPeer.java: Declare  and call
	connectJObject and connectSignals instead of connectHooks.
	* gnu/java/awt/peer/gtk/GtkButtonPeer.java: Declare connectJObject and
	connectSignals.
	* gnu/java/awt/peer/gtk/GtkCheckboxPeer.java: Declare connectSignals
	and not connectHooks.
	* gnu/java/awt/peer/gtk/GtkTextComponentPeer.java: Ditto.
	* gnu/java/awt/peer/gtk/GtkFileDialogPeer.java: Declare connectJObject
	and not connectHooks.
	* gnu/java/awt/peer/gtk/GtkListPeer.java: Declare connectJObject and
	connectSignals instead of connectHooks.
	* gnu/java/awt/peer/gtk/GtkPanelPeer.java: Ditto.
	* gnu/java/awt/peer/gtk/GtkScrollbarPeer.java: Ditto.
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java: Ditto. 

2004-01-06  Michael Koch  <konqueror@gmx.de>

	* java/text/CollationElementIterator.java:
	Renamed "char_seq" to "key" all over.
	* java/text/RuleBasedCollator.java:
	Fixed class documentation, reordered methods to match libgcj's
	version.
	(CollationElement.key): Renamed from char_seq.

2004-01-06  Sascha Brawer  <brawer@dandelis.ch>

	Fix for Classpath bug #7109.
	* javax/swing/undo/UndoableEditSupport.java: Re-format, document.
	(beginUpdate, endUpdate): Support nested updates.
	(postEdit): Use compound edit if present.
	
2004-01-06  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/event/EventListenerList.java (toString): Implemented.

2004-01-06  Sascha Brawer  <brawer@dandelis.ch>

	Fix for Classpath bug #7107.
	* javax/swing/DefaultBoundedRangeModel.java: Documented API.
	(changeEvent): Create event object on demand.
	(DefaultBoundedRangeModel, toString, setValue, setExtent,
	setMinimum, setMaximum, setValueIsAdjusting, setRangeProperties,
	fireStateChanged): Re-written.
	* NEWS: Mention fixed bug.
	
2004-01-06  Michael Koch  <konqueror@gmx.de>

	* include/Makefile.am: Generate gnu_java_nio_NIOServerSocket.h.
	* include/gnu_java_nio_NIOServerSocket.h,
	native/jni/java-nio/gnu_java_nio_NIOServerSocket.c: New files.
	* native/jni/java-nio/Makefile.am: Compile
	gnu_java_nio_NIOServerSocket.c.
	
2004-01-06  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/event/EventListenerList.java: Document typical usage.
	(getListeners): Re-written.

2004-01-06  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/Connection.java
	(Connection): Don't re-initialize doOutput with the default value.
	* java/net/JarURLConnection.java
	(JarURLConnection): Initialize entryName with null if no entry
	present, fixed off by one error.
	* java/net/URLConnection.java: Reformating.
	(getHeaderFields): Return empty map.
	(getPermission): Don't use package in class name.

2004-01-06  Michael Koch  <konqueror@gmx.de>

	* java/lang/SecurityManager.java
	(currentClassLoader): Use VMSecurityManager to get current class
	loader.
	(checkPackageList): Put array length into local variable.

2004-01-06  Per Bothner  <per@bothner.com>

	* java/util/Date.java (parse):  Fix a number of problems.
	(skipParens):  Remove no-longer-needed method.

2004-01-06  Sascha Brawer  <brawer@dandelis.ch>

	Fix for Classpath bug #7105.
	* javax/swing/event/EventListenerList.java (remove): Re-written.
	* NEWS: Mention fixed bug.

2004-01-06  Sascha Brawer  <brawer@dandelis.ch>

	Fix for Classpath bug #7104.
	* javax/swing/event/EventListenerList.java (add): Re-written.
	* NEWS: Mention fixed bug.

2004-01-06  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/event/EventListenerList.java (NO_LISTENERS): New
	singleton field.
	(listenerList): Declare as transient; document.
	(serialVersionUID): Document.
	
2004-01-06  Sascha Brawer  <brawer@dandelis.ch>

	Fix for Classpath bug #7099.
	* javax/swing/event/EventListenerList.java (getListenerCount(Class)):
	More efficient implementation, also accepts null argument.
	Improve Javadoc.
	* NEWS: Mention fixed bug.
	
	* javax/swing/event/EventListenerList.java (getListenerCount()):
	Remove unnecessary cast; docfix.

2004-01-06  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/event/EventListenerList.java: Reformatted.

2004-01-05  Sascha Brawer  <brawer@dandelis.ch>

	Fix for Classpath bug #6095
	Thanks to Brian Gough <bjg@network-theory.com>
	* java/awt/geom/CubicCurve2D.java (solveCubic): Implemented.
	* java/awt/geom/QuadCurve2D.java (solveQuadratic): Re-written.
	* NEWS: Mention the new capability for solving equations.
	* THANKYOU: Add Brian Gough.

2004-01-04  Michael Koch  <konqueror@gmx.de>

	* java/net/JarURLConnection.java
	(jarFileURLConnection): New field.
	* gnu/java/net/protocol/jar/Connection.java
	(Connection): Made class final.
	(Connection): Made constructor protected.
	(getJarFile): Check doInput.
	(getInputStream): Likewise.

2004-01-04  Michael Koch  <konqueror@gmx.de>

	* java/util/HashMap.java (HashMap(Map)): As above.
	(putAllInternal): As above.
	* java/util/Hashtable.java (Hashtable(Map)): Use putAll, not
	putAllInternal.
	(putAllInternal): Correct comment.
	(internalContainsValue): Removed.
	(containsValue): Don't delegate to internalContainsValue.

2003-12-31  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/Choice.java
	(add): Generate ItemEvent for the first item added.
	(insert): Generate ItemEvent if insertion caused selection to change.
	(remove): Generate ItemEvent if removal cause selection to change.
	(removeAll): Change algorithm to prevent generation of ItemEvents.

2003-12-31 Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/ObjectOutputStream.java
	(putFields): Removed redundant code.
	(writeFields): Check for multiple call to writeFields.
	(markFieldsWritten): Fixed exception message.

2003-12-30 Guilhem Lavaux <guilhem@kaffe.org>

	* java/net/URLStreamHandler.java,
	java/net/URL.java
	(URL): Change context path to "/" if it is empty.

2003-12-30  Michael Koch  <konqueror@gmx.de>

	* java/nio/channels/Channels.java
	(newInputStream): Implemented.
	(newOuputStream): Implemented.
	(newChannel): Implemented.
	* gnu/java/nio/ChannelInputStream.java,
	gnu/java/nio/ChannelOutputStream.java,
	gnu//java/nio/InputStreamChannel.java,
	gnu/java/nio/OutputStreamChannel.java: New files.
	* gnu/java/nio/Makefile.am (EXTRA_DIST): Added new files.

2003-12-30  Michael Koch  <konqueror@gmx.de>

	* java/io/ObjectStreamClass.java
	(getSerialPersistentFields): Little reformating.

2003-12-30  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/http/Connection.java
	(outputStream): New field.
	(bufferedOutputStream): New field.
	(connect): Initialize outputStream and bufferedOutputStream.
	(sendRequest): Create PrintWriter object from outputStream,
	support HTTP 1.1, send missing HTTP headers and buffered output data
	for POST method.
	(getOutputStream): Set request method to POST if output stream is
	used, return bufferedOutputStream.
	(setRequestMethod): Allow HEAD and POST methods.
	This fixes libgcj PR/6302 and libgcj PR/7752.

2003-12-30  Michael Koch  <konqueror@gmx.de>

	* java/net/URLConnection.java
	(req_props): Removed.
	(getHeaderField): Do nothing here. Implementation has to be in
	subclass.
	(setRequestProperty): Likewise.
	(addRequestProperty): Likewise.
	(getRequestProperty): Likewise.
	(getRequestProperties): Likewise.
	(setDefaultRequestProperty): Likewise.
	(getDefaultRequestProperty): Likewise.

2003-12-29 Guilhem Lavaux <guilhem@kaffe.org>

	* java/text/RuleBasedCollator.java,
	java/text/CollationElementIterator.java:
	Parser rewritten. All but one feature implemented.

2003-12-29 Guilhem Lavaux <guilhem@kaffe.org>

	* java/net/URLStreamHandler.java
	(parseURL): Change a relative path into an
	absolute if the original URL does not have any path.

	* java/util/GregorianCalendar.java
	(computeFields): Reported by Ito Kazumitsu <kaz@maczuka.gcd.org>.
	Fixed the computation of DAY_OF_WEEK_IN_MONTH.

2003-12-29 Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/ObjectStreamClass.java: Reindented.

2003-12-29 Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/ObjectInputStream.java: Use if instead of catching
	NullPointerException.

2003-12-28  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/HeaderFieldHelper.java
	(getHeaderFieldValueByKey): New method.
	(getHeaderFields): New method.
	* gnu/java/net/protocol/http/Connection.java
	(connect): Lowercase key before adding to HeaderFieldHelper object.
	(getHeaderField): New method.
	(getHeaderFields): New method.

2003-12-28  Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/ObjectOutputStream.java,
	java/io/ObjectInputStream.java,
	java/io/ObjectStreamClass.java: Reindented. Some exception message
	has been added.

2003-12-28  Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/ObjectOutputStream.java
	(writeClassDescriptor): Externalizable class must also write their
	hierarchy.
	(putFields): Added some text message for an exception.

	* java/io/ObjectInputStream.java
	(readClassDescriptor): Documented. Better field checking.
	(defaultReadObject): Readjusted messages in exceptions.
	(currentLoader): Documented.
	(inputGetObjectStreamClasses): Changed indentation.
	(readFields): Documented. Changed logic to improve error reporting and
	behaviour compared to the JDK.
	(readFields): Fixed behaviour.
	(getField): Documented. Fixed behaviour.
	(callReadMethod): Invalidate read fields.

	* java/io/ObjectStreamClass.java
	(setFields): Fix to avoid a NullPointerException.
	(getSerialPersistentFields): Documented. Improved modifier checking.

2003-12-28  Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/LineNumberReader.java
	(countLines): Removed.
	(fill): New private method.
	(mark): Changed logic to use savedLineNumber and matchedNewLine.
	(reset): Likewise.
	(read): Likewise.
	(skipRedundantLF): Likewise.

2003-12-28  Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/LineNumberReader.java
	(mark): Improved error checking.
	(read): Likewise.
	(skip): Likewise. Skip is now really eating the specified number of
	characters.
	
2003-12-28  Michael Koch  <konqueror@gmx.de>

	* java/nio/channels/FileChannelImpl.java
	(implRead): Only put data into buffer when data was read.

2003-12-27  Michael Koch  <konqueror@gmx.de>

	* java/io/ObjectStreamField.java
	(isShared): Documentation added.

2003-12-27  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/http/Connection.java
	(getRequestProperty): Removed.
	(setRequestProperty): Removed.

2003-12-27  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/http/Connection.java
	(setRequestProperty): New method.
	(getRequestProperty): New method.
	(getHeaderField): Reformated.
	(getHeaderFieldKey): Reformated.

2003-12-27  Mark Wielaard  <mark@klomp.org>

	* include/Makefile.am: Add java_lang_VMRuntime.h generation rule.
	* include/java_lang_VMRuntime.h: Regenerated.
	* java/lang/Makefile.am (EXTRA_DIST): Add Runtime.java.
	* vm/reference/java/lang/Makefile.am: Remove Runtime.java, add
	VMRuntime.java.

2003-12-27  Guilhem Lavaux <guilhem@kaffe.org>

	* gnu/java/net/protocol/http/Connection.java
	(receiveReply): Add the null header containing the reply of the server.
	(getHeaderField, getHeaderFieldKey): Check whether the connection has
	already been established.

2003-12-27  Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/CharArrayReader.java (read): It should throw
	IndexOutOfBoundsException and not ArrayIndexOutOfBoundsException (see
	mauve).
	
2003-12-27  Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/BufferedReader.java (readLine): Make readLine() really block
	until either EOF is reached or a true error happens.

2003-12-27  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/http/Connection.java
	(outputWriter): Removed.
	(connect): Always initialize inputStream, don't initialize
	outputWriter.
	(sendRequest): Create PrintWriter object locally.
	(receiveReply): Made private.
	(getInputStream): Return inputStream confitionally.
	(getOuputStream): Documentation added.
	(setRequestMethod): Reordered.
	(getHeaderField): Reordered.
	(getHeaderFieldKey): Reordered.

2003-12-27  Jeroen Frijters  <jeroen@frijters.net>

	* java/lang/System.java (mapLibraryName): Changed to call
	VMRuntime.nativeGetLibname.
	* java/lang/Runtime.java: New file.
	* vm/reference/java/lang/Runtime.java: Removed.
	* vm/reference/java/lang/VMRuntime.java: New file.
	* include/java_lang_VMRuntime.h: New file.
	* include/java_lang_Runtime.h: Removed.


2003-12-27  Michael Koch  <konqueror@gmx.de>

	* javax/print/attribute/standard/Copies.java,
	javax/print/attribute/standard/JobImpressions.java,
	javax/print/attribute/standard/JobMediaSheets.java,
	javax/print/attribute/standard/JobPriority.java,
	javax/print/attribute/standard/NumberOfDocuments.java,
	javax/print/attribute/standard/NumberOfInterveningJobs.java,
	javax/print/attribute/standard/NumberUp.java,
	javax/print/attribute/standard/PagesPerMinuteColor.java,
	javax/print/attribute/standard/PagesPerMinute.java,
	javax/print/attribute/standard/QueuedJobCount.java,
	javax/print/attribute/standard/Makefile.am,
	javax/print/attribute/standard/package.html: New files

2003-12-27  Michael Koch  <konqueror@gmx.de>

	* java/nio/channels/spi/AbstractSelector.java:
	Added import for java.nio.channels.ClosedSelectorException.
	(close): Added synchronized to method declaration.
	(cancelledKeys): Throw ClosedSelectorException if is closed.
	(cancelKey): Synchronize on cancelled key set before key.

2003-12-27  Michael Koch  <konqueror@gmx.de>

	* java/util/SimpleTimeZone.java
	(setStartRule): Reformated documentation.
	(setEndRule): Reworked documentation.
	(getDSTSavings): Fixed @since tag.
	(setDSTSavings): New method.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/util/Calendar.java,
	java/util/IdentityHashMap.java:
	Import used classes explicitely.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/util/prefs/Preferences.java:
	Import used classes explicitely.
	* java/util/prefs/AbstractPreferences.java
	(cachedChildren): New method.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/text/MessageFormat.java
	(MessageFormat): New constructor.
	* java/text/NumberFormat.java
	(getCurrency): New method.
	(setCurrency): New method.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/text/Format.java (serialVersionUID): Fixed value.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramPacket.java
	(length): Made package-private to make it accessible via CNI.
	(maxlen): New field.
	(DatagramPacket): Cleaned up.
	(setSocketAddress): Add message to exception.
	(setData): Call other setData().
	(setData): Call setLength().
	(setLength): Initialize maxlen too.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramSocket.java
	(close): Directly return if socket is closed.
	* java/net/ServerSocket.java bind():
	If InetSocketAddress.getAddress() returns "null" use "0.0.0.0" as
	address to bind to.
	(close): Directly return if socket is closed.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/util/TimeZone.java (getOffset): New method.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* javax/naming/event/EventDirContext.java: Jalopied.
	(addNamingListener): Fixed typo in method name.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* javax/naming/directory/Attribute.java,
	javax/naming/directory/Attributes.java,
	javax/naming/directory/DirContext.java,
	javax/naming/directory/InitialDirContext.java,
	javax/naming/directory/SearchResult.java,
	javax/naming/event/EventContext.java,
	javax/naming/event/EventDirContext.java,
	javax/naming/event/NamingEvent.java,
	javax/naming/event/NamingExceptionEvent.java,
	javax/naming/ldap/ControlFactory.java,
	javax/naming/ldap/ExtendedRequest.java,
	javax/naming/ldap/HasControls.java,
	javax/naming/ldap/InitialLdapContext.java,
	javax/naming/ldap/LdapContext.java,
	javax/naming/ldap/LdapReferralException.java,
	javax/naming/ldap/UnsolicitedNotification.java,
	javax/naming/ldap/UnsolicitedNotificationListener.java,
	javax/naming/spi/DirObjectFactory.java,
	javax/naming/spi/DirStateFactory.java,
	javax/naming/spi/DirectoryManager.java,
	javax/naming/spi/NamingManager.java,
	javax/naming/spi/ObjectFactoryBuilder.java,
	javax/naming/spi/ResolveResult.java,
	javax/naming/spi/Resolver.java,
	javax/naming/spi/StateFactory.java:
	Import used classes explicitely.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* gnu/java/lang/reflect/TypeSignature.java: Reformatted.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/io/FilePermission.java:
	Import used classes explicitely.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/beans/BeanDescriptor.java,
	java/beans/EventSetDescriptor.java,
	java/beans/FeatureDescriptor.java,
	java/beans/IndexedPropertyDescriptor.java,
	java/beans/Introspector.java,
	java/beans/MethodDescriptor.java,
	java/beans/PropertyDescriptor.java,
	java/beans/SimpleBeanInfo.java: Explicitely import used classes.
	* java/beans/beancontext/BeanContextServicesSupport.java
	(serialVersionUID): New field.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/awt/image/PixelGrabber.java: Removed assert() statements added
	in last commit as this breaks compilation with jikes.

2003-12-26  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/datatransfer/DataFlavor.java (getParameter):
	Fix off-by-one error which was clipping off the first character of a
	parameter value.
	* java/awt/datatransfer/StringSelection.java (getTransferData):
	Return object of type expected by specified DataFlavor.

2003-12-26  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* java/awt/image/PixelGrabber.java:
	Fix implementation and update javadocs.
2003-12-26  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* java/awt/FlowLayout.java (layoutContainer): Let components
	assume their preferred height.  Centre components vertically.

2003-12-26  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/List.java (replaceItem): Prevent selection to move with
	replace and minimize flickering.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* native/target/generic/target_generic_file.h
	(TARGET_NATIVE_FILE_FILEFLAG_SYNC): Define to O_FSYNC on systems where
	O_SYNC doesnt exist but O_FSYNC does (like FreeBSD).

2003-12-26  Olga Rodimina <rodimina@redhat.com>

	* java/awt/Polygon.java (translate):
	Fixed error that caused polygon to move right/left
	when up/down translation was required.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* java/awt/MenuComponent.java: Import java.io.Serialization.
	* java/awt/MenuItem.java: Likewise.
	* java/awt/TextComponent.java: Likewise.
	* java/awt/image/ImagingOpException.java
	(serialVersionUID): Fixed.

2003-12-26  Michael Koch  <konqueror@gmx.de>

	* javax/print/attribute/AttributeSetUtilities.java,
	javax/print/attribute/DateTimeSyntax.java,
	javax/print/attribute/DocAttribute.java,
	javax/print/attribute/DocAttributeSet.java,
	javax/print/attribute/EnumSyntax.java,
	javax/print/attribute/HashAttributeSet.java,
	javax/print/attribute/HashDocAttributeSet.java,
	javax/print/attribute/HashPrintJobAttributeSet.java,
	javax/print/attribute/HashPrintRequestAttributeSet.java,
	javax/print/attribute/HashPrintServiceAttributeSet.java,
	javax/print/attribute/IntegerSyntax.java,
	javax/print/attribute/PrintJobAttribute.java,
	javax/print/attribute/PrintJobAttributeSet.java,
	javax/print/attribute/PrintRequestAttribute.java,
	javax/print/attribute/PrintServiceAttribute.java,
	javax/print/attribute/PrintServiceAttributeSet.java,
	javax/print/attribute/ResolutionSyntax.java,
	javax/print/attribute/SetOfIntegerSyntax.java,
	javax/print/attribute/Size2DSyntax.java,
	javax/print/attribute/SupportedValuesAttribute.java,
	javax/print/attribute/TextSyntax.java,
	javax/print/attribute/URISyntax.java,
	javax/print/attribute/UnmodifiableSetException.java: New files
	* javax/print/attribute/Makefile.am (EXTRA_DIST): Added new files.

2003-12-26  Guilhem Lavaux  <guilhem@kaffe.org>

	* java/util/GregorianCalendar.java (computeTime): 12:00 midnight is AM
	and 12:00 noon is PM.

2003-12-26  Guilhem Lavaux  <guilhem@kaffe.org>

	* java/rmi/Naming.java (lookup): Check if the first character of the
	filename returned by URL.getFile() is a '/', only if it is the case
	we cut this first character and call the registry with the good name.
	(bind): Likewise.
	(rebind): Likewise.

2003-12-26  Dalibor Topic <robilad@kaffe.org>

	* java/net/Socket.java (close): Allow a Socket to be closed
	multiple times without throwing an exception.

2003-12-26  Guilhem Lavaux  <guilhem@kaffe.org>

	* java/io/FileInputStream.java (FileInputStream(String)): Call
	FileInputStream(File).
	(FileInputStream(File)): Check whether the argument is a directory.

2003-12-26  Guilhem Lavaux  <guilhem@kaffe.org>
            Mark Wielaard  <mark@klomp.org>

	* java/io/BufferedReader.java (BufferedReader): Throw
	IllegalArgumentException when size <= 0.
	(mark): Document and better exception message for negative readLimit
	IllegalArgumentException.
	(read(char[],int,int)): Throw IndexOutOfBoundsException if offset and
	count are not valid regarding buf.
	(skip): Throw IllegalArgumentException when count is negative.

2003-12-25  Guilhem Lavaux  <guilhem@kaffe.org>
            Mark Wielaard  <mark@klomp.org>

	* gnu/java/rmi/server/UnicastConnectionManager.java
	(startScavenger): Set the client connection manager to daemon
	state because it may block clients until TIMEOUT is reached
	when they are exiting.

	* gnu/java/rmi/RMIVoidValue.java: New file for a class representing
	a void return.

	* gnu/java/rmi/server/UnicastRemoteCall.java
	(DummyOutputStream): Add a boolean before each written field to
	know whether it is a primitive.
	(releaseOutputStream): Flush parameters at write time.

	* gnu/java/rmi/server/UnicastServerRef.java
	(incomingMessageCall): Return a RMIVoidValue if no value is to be
	returned.

	* gnu/java/rmi/server/UnicastServer.java
	(incomingMessageCall): Do not write a returned object if it is
	a RMIVoidValue.

	* gnu/java/rmi/server/Makefile.am (EXTRA_DIST): Add RMIVoidValue.java.

2003-12-25  Mark Wielaard  <mark@klomp.org>

	* include/Makefile.am (ARG_CLASSPATH_JAVAH): Use -bootclasspath.
	* include/gnu_java_awt_peer_gtk_GdkPixbufDecoder.h: Regenerated.
	* include/gnu_java_awt_peer_gtk_GtkComponentPeer.h: Likewise.
	* include/gnu_java_awt_peer_gtk_GtkToolkit.h: Likewise.
	* include/java_lang_VMSystem.h: Likewise.

2003-12-25  Guilhem Lavaux <guilhem@kaffe.org>

	* gnu/java/net/URLParseError.java: New file.
	* gnu/java/net/protocol/jar/Handler.java
	(parseURL): Throw URLParseError if needed, fix '/' handling.
	* java/net/URL.java (URL): Catch URLParseError and
	transform it into a MalformedURLException.

	* gnu/java/net/Makefile.am (EXTRA_DIST): Add URLParseError.java.

2003-12-24  Mark Wielaard  <mark@klomp.org>

	* configure.in: Set version to 0.07+cvs.

2003-12-03  Fernando Nasser  <fnasser@redhat.com>

	* java/awt/List.java (getSelectedIndex):
	Return -1 if no list element is selected.

2003-12-02  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkFontMetrics.c
	(initState): Mark obj parameter as unused.
	(stringWidth): Mark obj parameter as unused.  Initialize
	font_name properly.

2003-12-02  Graydon Hoare  <graydon@redhat.com>

	* Container.java (LightweightDispatcher): Expand implementation.
	(visitChild): Use existing graphics object, rather than clone.
	(dispatchEventImpl): Call LightweightDispatcher if it exists.
	(addNotifyContainerChildren): Build LightweightDispatcher.

2003-12-02  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* include/gnu_java_awt_peer_gtk_GdkPixbufDecoder.h,
	include/gnu_java_awt_peer_gtk_GtkComponentPeer.h,
	include/gnu_java_awt_peer_gtk_GtkToolkit.h: Regenerate.
	* native/jni/gtk-peer/Makefile.am: Add
	gnu_java_awt_peer_gtk_GdkPixbufDecoder.c.
	* gnu/java/awt/image/ImageDecoder.java (ImageDecoder(byte[],int,int)):
	New constructor.
	(startProduction): Create ByteArrayInputStream when url and filename are
	null.
	(produce): Declare stream parameter as InputStream.
	* gnu/java/awt/image/XBMDecoder.java (produce): Declare stream parameter
	as InputStream.
	* gnu/java/awt/peer/gtk/GdkPixbufDecoder.java
	(GdkPixbufDecoder(byte[],int,int)): New constructor.
	(produce): Declare stream parameter as InputStream.
	* gnu/java/awt/peer/gtk/GtkComponentPeer.java (prepareImage): Throw NPE
	if image is null.  Set image's observer before running PrepareImage
	thread.  Pass image to startProduction.
	* gnu/java/awt/peer/gtk/GtkImage.java: Add null checks before calls to
	source's member functions.
	(observer): New field.
	(setObserver): New method.
	(setDimensions, setPixels, imageComplete): Call observer's imageUpdate.
	* gnu/java/awt/peer/gtk/GtkToolkit.java (checkImage, getImage): Return
	new GtkImage.
	(prepareImage): Implement.
	* java/awt/Component.java: Add static fields incrementalDraw and
	redrawRate.
	(imageUpdate): Implement.
	(createImage): Call Toolkit's createImage if peer is null.
	(prepareImage): Throw NPE if image is null.
	* java/awt/MediaTracker.java: Fix return value.

2003-12-02  Guilhem Lavaux <guilhem@kaffe.org>

	* java/io/ObjectInputStream.java:
	(setBooleanField): Throw an InvalidClassException if the field hasn't 
	the required type.
	(setByteField): Likewise.
	(setCharField): Likewise.
	(setDoubleField): Likewise.
	(setFloatField): Likewise.
	(setIntField): Likewise.
	(setShortField): Likewise.
	(setLongField): Likewise.
	(setObjectField): Likewise.

2003-12-02  Guilhem Lavaux <guilhem@kaffe.org>
	
	* java/io/ObjectStreamField.java: A few methods were added
	in prevision of the upcoming upgrade of the serialization code.
	(ObjectStreamField): We should throw a NullPointerException when
	'name' is null.

2003-12-02  Guilhem Lavaux <guilhem@kaffe.org>, Helmer Kraemer <hkraemer@freenet.de>

	* gnu/java/lang/reflect/TypeSignature.java
	(getClassForEncoding): Splitted the method so we can specify an
	explicit boot loader.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* gnu/java/io/PlatformHelper.java: Reformated.

2003-12-02  Graydon Hoare  <graydon@redhat.com>

	* javax/swing/JLayeredPane.java: Implement.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramSocket.java
	(close): Close associated DatagramChannel object.
	* java/net/Socket.java
	(close): Reset impl and bound before calling getChannel().close() to
	prevent from loops.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* java/nio/channels/spi/AbstractInterruptibleChannel.java
	(opened): Removed.
	(closed): New field.
	(close): Check of channel is closed already.
	(isOpen): Return !closed.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramSocket.java
	(DatagramSocket): Call other sister constructor.
	(connect): Revised exception message.
	(setBroadcast): Renamed on to enable.
	(getLocalAddress): Completed documentation.
	(getChannel): Likewise.
	(isBound): Likewise.
	(isConnected): Likewise.
	(getRemoteSocketAddress): Likewise.
	(getLocalSocketAddress): Likewise.
	(getReuseAddress): Likewise.
	(setBroadcast): Likewise.
	(getTrafficClass): Likewise.
	* java/net/ServerSocket.java
	(getLocalSocketAddress): Simplified.
	(accept): Renamed s to socket.
	(implAccept): Likewise.
	(toString): Made it compliant to SUNs JDK.
	* java/net/Socket.java
	(impl): Make private.
	(getInetAddress): Check if socket is connected.
	(getPort): Likewise.
	(getInputStream): Likewise.
	(getOutputStream): Likewise.
	(getLocalPort): Check if socket is bound.
	(shutdownOutput):
	Readd accidently removed "getImpl().shutdownOutput()".
	(connect): Completed documentation.
	(getOOBInline): Likewise.
	(getReuseAddress): Likewise.
	(getTrafficClass): Likewise.
	(isConnected): Likewise.
	(isBound): Likewise.
	(isClosed): Likewise.
	(isInputShutdown): Likewise.
	(isOutputShutdown): Likewise.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramSocket.java
	(impl): Made private.
	(bound): New private member variable.
	(DatagramSocket): Fixed documentation, use getImpl().
	(getImpl): New package-private method.
	(isClosed): Use getImpl().
	(getLocalAddress): Completed documentation, use getImpl().
	(getLocalPort): Use getImpl().
	(getSoTimeout): Likewise.
	(setSoTimeout): Likewise.
	(getSendBufferSize): Likewise.
	(setSendBufferSize): Likewise.
	(getReceiveBufferSize): Likewise.
	(setReceiveBufferSize): Likewise.
	(connect): Likewise.
	(disconnect): Likewise.
	(receive): Likewise.
	(send): Likewise.
	(setReuseAddress): Likewise.
	(setTrafficClass): Likewise.
	(bind): Added message to exception.
	(isClosed): Completed documentation.
	(getChannel): Likewise.
	(connect): Added missing exception, refined exception message.
	(isBound): Completed documentation, just return bound.
	(isConnected): Completed documentation.
	(getRemoteSocketAddress): Likewise.
	(getReuseAddress): Completed documentation, use getImpl().
	(setSoBroadcast): Likewise.
	(getSoBroadcast): Likewise.
	(getTrafficClass): Likewise.
	(getLocalSocketAddress): Simplified.
	* java/net/MulticastSocket.java
	(MulticastSocket): Removed comment not applying anymore.
	(getInterface): Use getImpl().
	(getTTL): Likewise.
	(getTimeToLive): Likewise.
	(setInterface): Likewise.
	(setNetworkInterface): Likewise.
	(getNetworkInterface): Likewise.
	(setLoopback): Likewise.
	(getLoopback): Likewise.
	(setTTL): Likewise.
	(setTimeToLive): Likewise.
	(joinGroup): Likewise.
	(leaveGroup): Likewise.
	(send): Likewise.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* java/net/Socket.java
	(implCreated): Dont set default value explicitely, added
	documentation.
	(inputShutdown): Likewise.
	(outputShutdown): Likewise.
	(bound): New private member variable.
	(bind): Set bound to true.
	(close): Set bound to false.
	(isBound): Return bound.
	* java/net/ServerSocket.java
	(bound): New private member variable.
	(bind): Set bound to true.
	(close): Set bound to false.
	(isBound): Return bound.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramSocket.java
	(factory): Made private.
	(closed): Removed.
	(DatagramSocket): Check impl argument, use constructor with
	SocketAddress argument.
	(close): Set impl to null, use isClosed().
	(isClosed): Check for impl == null.
	(getLocalAddress): Use isClosed().
	(getLocalPort): Check if socket is closed.
	(getSoTimeout): Likewise.
	(setSoTimeout): Likewise.
	(getSendBufferSize): Likewise.
	(setSendBufferSize): Likewise.
	(getReceiveBufferSize): Likewise.
	(setReceiveBufferSize): Likewise.
	(receive): Likewise.
	(send): Likewise.
	(bind): Likewise.
	(connect): Likewise.
	(setReuseAddress): Likewise.
	(getReuseAddress): Likewise.
	(setBroadcast): Likewise.
	(getBroadcast): Likewise.
	(setTrafficClass): Likewise.
	(getTrafficClass): Likewise.
	* java/net/MulticastSocket.java
	(getInterface): Check if socket is closed.
	(getTTL): Likewise.
	(getTimeToLive): Likewise.
	(setInterface): Likewise.
	(setNetworkInterface): Likewise.
	(getNetworkInterface): Likewise.
	(setLoopbackMode): Likewise.
	(setTTL): Likewise.
	(setTimeToLive): Likewise.
	(joinGroup): Likewise.
	(leaveGroup): Likewise.
	(send): Likewise.
	* java/net/ServerSocket.java
	(closed): Removed.
	(close): Check if socket is closed, set impl to null.
	(isClosed): Check impl == null;
	(ServerSocket): Check impl argument.
	(getInetAddress): Check if socket is bound.
	(getLocalPort): Likewise.
	(getLocalSocketAddress): Likewise.
	(bind): Check if socket is closed.
	(implAccept): Likewise.
	(setSoTimeout): Likewise.
	(getSoTimeout): Likewise.
	(setReuseAddress): Likewise.
	(getReuseAddress): Likewise.
	(setReceiveBufferSize): Likewise.
	(getReceiveBufferSize): Likewise.
	* java/net/Socket.java
	(closed): Removed.
	(Socket): Fixed documentation.
	(connect): Check if socket is closed, changed exception text,
	fixed documentation.
	(getInputStream): Check of socket is closed  and connected.
	(getOutputStream): Likewise.
	(bind): Check if socket is closed.
	(setTcpNoDelay): Likewise.
	(getTcpNoDelay): Likewise.
	(setSoLinger): Likewise.
	(getSoLinger): Likewise.
	(sendUrgentData): Likewise.
	(setOOBInline): Likewise.
	(getOOBInline): Likewise.
	(setSoTimeout): Likewise.
	(getSoTimeout): Likewise.
	(setSendBufferSize): Likewise.
	(getSendBufferSize): Likewise.
	(setReceiveBufferSize): Likewise.
	(getReceiveBufferSize): Likewise.
	(setKeepAlive): Likewise.
	(getKeepAlive): Likewise.
	(close): Likewise.
	(shutdownInput): Likewise.
	(shutdownOutput): Likewise.
	(getReuseAddress): Likewise.
	(getTrafficClass): Likewise.
	(setTrafficClass): Likewise.
	(isClosed): Check impl == null.
	(toString): Added missing ']'.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramSocket.java
	(DatagramSocket): Move binding code to bind(), simplify constructors.
	* java/net/MulticastSocket.java
	(MulticastSocket): Call parent constructor with null argument,
	bind socket after setReuseAddress is called, simplify constructors.
	* java/net/Socket.java
	(various): Some more getImpl() fixes.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* java/net/Socket.java
	(implCreated): New variable that indicates created impl.
	(getImpl): New method.
	(toString): Return more SUN compliant string representation.
	(various): Use getImpl() instead of impl.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* java/text/DateFormat.java:
	Explicitely import used classes.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* include/gnu_java_awt_peer_gtk_GdkFontMetrics.h: Regenerated.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/Handler.java:
	(openConnection): Handle case when host part of file: URL is set.
	* gnu/java/net/protocol/http/Connection.java: Reformated.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* gnu/java/lang/ClassLoaderHelper.java:
	Explicitly import used classes.
	* gnu/java/lang/SystemClassLoader.java
	(systemFindResource): Fixed typo.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/Connection.java: Reformated.
	(inputStream): Made an InputStream.
	(outputStream): Made an OutputStream.
	(connect): Don't throw FileNotFoundException directly. FileInputStream
	constructor does this for us.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/jar/Connection.java:
	Reformated.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/jar/Handler.java:
	Reformated.

2003-12-02  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/Handler.java:
	Reformated.

2003-12-01  Kim Ho <kho@redhat.com>

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextAreaPeer.c (create):
	Disable wrapping if TextArea has horizontal scroll bars.

2003-12-01  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(awt_event_handler): Hard-code inset values.

	* gnu/java/awt/peer/gtk/GdkFontMetrics.java (GdkFontMetrics):
	Pass font name, not XLFD, to initState.
	(stringWidth(String, int, String)): New method.
	(stringWidth(String)): Call new stringWidth.
	(getLeading): Always return 0.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkFontMetrics.c
	(initState): New Pango implementation.
	(stringWidth): Likewise.

2003-12-01  Graydon Hoare  <graydon@redhat.com>

	* java/awt/Container.java (swapComponents): New method.
	* (visitChild): Handle null clip bounds.
	* javax/swing/JLayeredPane.java: Conform to mauve test, javadoc.

2003-12-01  Olga Rodimina <rodimina@redhat.com>

	* java/awt/TextComponent.java:
	(getSelectionStart): Updated javadocs.
	(getSelectionEnd): Ditto.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextComponentPeer:
	(getSelectionStart): Changed to return caret position if no
	text is selected
	(getSelectionEnd): Ditto.

2003-12-01  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkImage.java (setDimensions,
	setProperties): Check that io is not null before calling
	io.imageUpdate.
	* java/awt/image/ImageConsumer.java (setPixels, imageComplete):
	Update javadocs.
	* java/awt/image/PixelGrabber.java: Fix implementation and
	update javadocs.

2003-11-30  Mark Wielaard  <mark@klomp.org>

	* configure.in: Set version to 0.07.
	* NEWS: Set release date to today.

2003-11-30  Mark Wielaard  <mark@klomp.org>

	* java/security/Security.java: Don't use &nbsp; in the api doc.

2003-11-30  Mark Wielaard  <mark@klomp.org>

	* doc/api/Makefile.am (packages, create_html): Only generate api doc
	for the core packages, not the external ones.

2003-11-29  Mark Wielaard  <mark@klomp.org>

	Reported by Etienne Gagnon <gagnon.etienne_m@uqam.ca>
	* doc/www.gnu.org/stories: Updated SableVM blurb and add extra
	publications link.

2003-11-29  Mark Wielaard  <mark@klomp.org>

	* doc/hacking.texi: Clearify jikesrvm link (www, not www-124).
	* doc/www.gnu.org/stories.wml: Likewise.
	* doc/www.gnu.org/home.wml: Update Open Tasks savannah link.

2003-11-28  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/PlainDatagramSocketImpl.java
	(sendTo): Added offset argument.
	* include/gnu_java_net_PlainDatagramSocketImpl.h: Regenerated.
	* native/jni/java-net/gnu_java_net_PlainDatagramSocketImpl.c
	(receive0): Use completely available space in buffer array.
	(sendTo): Use offset.

2003-11-28  Ito Kazumitsu  <kaz@maczuka.gcd.org>

	* java/text/SimpleDateFormat.java (compileFormat):
	isLowerCase() and isUpperCase() allow too many characters.
	Just use >= 'A' && <= 'Z' || >= 'a' && <= 'z'.

2003-11-28  Mark Wielaard  <mark@klomp.org>

	Reported by Archie Cobbs:
	* java/security/DigestInputStream.java (read(byte[], int, int): Call
	digest.update() with temp, not len as lenght.

2003-11-28  Mark Wielaard  <mark@klomp.org>

	Reported by Michael Hind <hindm@us.ibm.com>:
	* doc/www.gnu.org/stories: Updated Jikes RVM blurb.
	Fixed Joas and SableVM publication links.

2003-11-28  Mark Wielaard  <mark@klomp.org>

	* NEWS: Update with new 0.07 items.

2003-11-28  Dalibor Topic  <robilad@kaffe.org>

        Reported by: Jim Pick <jim@kaffe.org>

        * libraries/javalib/java/util/Hashtable.java
        (internalcontainsValue): New method.
        (contains) Delegate to internalContainsValue.

        Reported by: Mark Wielaard  <mark@klomp.org>

        * libraries/javalib/java/util/Hashtable.java
        (contains): Improved comment.

        Reported by: Jeroen Frijters  <jeroen@frijters.net>

        * libraries/javalib/java/util/Hashtable.java
        (containsValue): Delegate to contains(Object) to make sure older
        code overwriting it continues to work.

2003-11-27  Michael Koch  <konqueror@gmx.de>

	* doc/www.gnu.org/downloads/tools.wml: Add GNU.xml style definition
	file.

2003-11-27  Mark Wielaard  <mark@klomp.org>

	New setup from Patrik Reali <reali@acm.org>
	* Makefile: New setup.
	* README: Describe new setup.
	* benchmarks.wml: New file.
	* external.wml: New file.
	* home.wml: Use new setup.
	* license.wml: New file.
	* stories.wml: New file.
	* docs/Makefile: New setup.
	* docs/docs.wml: Use new setup.
	* downloads/.cvsignore: New file.
	* downloads/19990206.wml: New file.
	* downloads/20001120.wml: New file.
	* downloads/20010106.wml: New file.
	* downloads/20020208.wml: New file.
	* downloads/Makefile: New file.
	* downloads/downloads.wml: New file.
	* downloads/tools.wml: New file.
	* faq/.cvsignore: New file.
	* faq/Makefile: New file.
	* faq/faq.wml: New file.
	* include/layout.wml: New file.
	* include/macros.wml: New setup.

2003-11-27  Mark Wielaard  <mark@klomp.org>

	* configure.in: Removed AC_CYGWIN and AC_MINGW32.

2003-11-27  Dalibor Topic <robilad@kaffe.org>

	* java/text/FieldPosition.java (equals): Fixed comment.

2003-11-27  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/http/Connection.java
	(connect): Always create outputStream, its needed to send request to
	remote server. Set connected to true after request was sent and reply
	received.

2003-11-27  Michael Koch  <konqueror@gmx.de>

	* java/net/URLStreamHandler.java
	(parseURL): Added comment in catch statement.
	(canonicalizeFilename): Add documentation.
	(sameURL): Completed documentation.
	(equals): Likewise.
	(hostsEqual): Likewise.
	(getDefaulPort): Likewise.
	(hashCode): Likewise.
	(toExternalForm): Likewise.
	(getHostName): Fix empty hostname check, completed documentation.

2003-11-26  Tom Fitzsimmons  <fitzsim@redhat.com>

        * java/awt/GridBagLayout.java (getLayoutDimensions): Return array of
	two zero-length int arrays when layoutInfo is null.
	(getLayoutWeights): Return array of two zero-length double arrays when
	layoutInfo is null.

2003-11-26  Michael Koch  <konqueror@gmx.de>

	* javax/swing/BoxLayout.java
	(serialVersionUIR): New member variable.
	(X_AXIS, Y_AXIS): Documentation added.
	(LINE_AXIS, PAGE_AXIS): New constants.
	(grid): Renamed from gridbag.
	(BoxLayout): Use new constants, throw exception if invalid value for
	way, added documentation.
	(BoxLayout): Removed.
	(addLayoutComponent): Use new constants, added documentation.
	(removeLayoutComponent): Likewise.
	(addLayoutContainer): Added documentation.
	(preferredLayoutSize): Added documentation, check given argument.
	(minimumLayoutSize): Likewise.
	(layoutContainer): Likewise.
	(getLayoutAlignmentX): Likewise.
	(getLayoutAlignmentY): Likewise.
	(invalidateLayout): Likewise.
	(maximumLayoutSize): Likewise.

2003-11-26  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/DatagramChannelImpl.java
	(getNativeFD): Use getPlainDatagramSocketImpl().
	* gnu/java/nio/NIODatagramSocket.java
	(getPlainDatagramSocketImpl): Renamed from getImpl().
	* gnu/java/nio/NIOSocket.java
	(getPlainSocketImpl): Renamed from getImpl().
	(setChannel): Use getPlainSocketImpl().
	* gnu/java/nio/SocketChannelImpl.java
	(SocketChannelImpl): Use getPlainSocketImpl().
	(getPlainSocketImpl): Renamed from getImpl().
	(getNativeFD): Use getPlainSocketImpl().

2003-11-26  Michael Koch  <konqueror@gmx.de>

	* java/net/URL.java
	(URL): Fixed documentation to be HTML compliant.
	(getContent): Completed documentation.
	(getFile): Likewise.
	(getPath): Likewise.
	(getAuthority): Likewise.
	(getHost): Likewise.
	(getDefaultPort): Likewise.
	(getProtocol): Likewise.
	(hashCode): Likewise.
	(openConnection): Likewise.
	(openStream): Likewise.
	(set): Likewise.
	(getURLStreamHandler): Wrapped lines to fit into our 79 chars rule.

2003-11-26  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramPacket.java
	(DatagramPacket): Fixed documentation to become legal HTML.

2003-11-26  Michael Koch  <konqueror@gmx.de>

	* java/net/InetSocketAddress.java
	(hostname): Made private, added documentation.
	(addr): Likewise.
	(port): Likewise.
	(equals): Completed documentation.
	(getAddress): Likewise.
	(getHostName): Likewise.
	(getPort): Likewise.
	(hashCode): Likewise.
	(isUnresolved): Likewise.
	(toString): Likewise.

2003-11-26  Michael Koch  <konqueror@gmx.de>

	* java/net/URLStreamHandler.java
	(getHostName): Fix empty hostname check.
	(toExternalForm): Add port number only when host is present and port
	was specified in spec.

2003-11-25  David Belanger  <dbelan2@cs.mcgill.ca>

	* java/util/zip/ZipFile (Zipfile(File)): Set file path as name.
	(ZipFile(File,int)): Likewise.

2003-11-25  Mark Wielaard  <mark@klomp.org>

	Thanks to Sascha Brawer
	* NEWS: Update new features, vm-interface changes and bug fixes.

2003-11-25  Ito Kazumitsu  <kaz@maczuka.gcd.org>

	* java/util/GregorianCalendar.java (getLinearTime): Avoid counting
	the leap day of the leap year twice.
	(computeFields): First week of month is 1 not 0.

2003-11-23  Guilhem Lavaux <guilhem@kaffe.org>

	* java/text/NumberFormat.java:
	(getIntegerInstance) Added the java version in the comments.

	* java/text/FormatCharacterIterator.java: Documented the class and
	its methods.

2003-11-23  Mark Wielaard  <mark@klomp.org>

	* java/text/NumberFormat.java: Import java.io.InvalidObjectException.
	(readResolve): Reformat.

2003-11-23  Mark Wielaard  <mark@klomp.org>

	* native/jni/java-net/javanet.c: Plain[Datagram]SocketImpl moved from
	java/net to gnu/java/net.

2003-11-22  Guilhem Lavaux <guilhem@kaffe.org>

	* java/text/NumberFormat.java
	(NumberFormat.Field): New implemented class to match Java 1.4. 
	(getIntegerInstance): Two new Java 1.4 methods.o

	* java/text/DecimalFormatSymbols.java (locale): New field.
	(DecimalFormatSymbols (Locale)): Set locale.
	(serialVersionOnStream): Upgraded to number 2.
	(readObject): Assign locale if it wasn't by the serializer.

	* java/text/FormatCharacterIterator.java: Fixed some typos.

2003-11-18  Graydon Hoare  <graydon@redhat.com>

	* javax/swing/JLayeredPane.java: Implement.
	* javax/swing/JFrame.java (getContentPane): Make public
	* javax/swing/javax/swing/JRootPane.java (setContentPane): 
	Use JLayeredPane.FRAME_CONTENT_LAYER.

2003-11-21  Jeroen Frijters  <jeroen@frijters.net>
	* vm/reference/java/lang/Runtime.java (exit): Fixed bug introduced
	earlier today that caused exit() calls during finalization for exit
	to get lost.

2003-11-21  Mark Wielaard  <mark@klomp.org>

	* configure.in: Depend on gtk+ 2.2.x.
	* HACKING, NEWS: Document.

2003-11-21  Mark Wielaard  <mark@klomp.org>

	* vm/reference/java/lang/Runtime.java (exit): Add extra comments.

2003-11-21  Mark Wielaard  <mark@klomp.org>

	* gnu/java/awt/peer/gtk/Makefile.am (EXTRA_DIST): Add
	GdkClasspathFontPeerMetrics.java.

2003-11-21  Jeroen Frijters  <jeroen@frijters.net>

	* java/lang/Thread.java (start): Throw IllegalThreadStateException
	instead of IllegalStateException.
        * vm/reference/java/lang/Runtime.java (exit): Moved shutdown hook
        processing to new method.
        (runShutdownHooks): New method.

2003-11-21  Mark Wielaard  <mark@klomp.org>

	* java/io/InputStreamReader.java (getEncoding): Handle closed stream
	(in == null) case.

2003-11-21  Mark Wielaard  <mark@klomp.org>

	* javax/swing/plaf/basic/BasicDefaults.java (BasicDefaults): Put
	AbstractUndoableEdit.undoText and AbstractUndoableEdit.redoText.

2003-11-18  Graydon Hoare  <graydon@redhat.com>

	* java/awt/font/TextLayout.java: Implement simple layouts
	using attributed strings and glyph vectors.

2003-11-17  Graydon Hoare  <graydon@redhat.com>

	* gnu/java/awt/peer/gtk/GdkClasspathFontPeerMetrics.java: New file.
	* gnu/java/awt/peer/gtk/GdkClasspathFontPeer.java 
	(GdkFontLineMetrics): New inner class.
	(getLineMetrics): Return new GdkFontLineMetrics.
	(getFontMetrics): Return new GdkClasspathFontPeerMetrics.
	(layoutGlyphVector): Create GdkGlyphVector.
	* gnu/java/awt/peer/gtk/GdkGraphics2D.java (stateStack): New member.
	(GdkGraphics2D): Initialize state via mathod calls.
	(cairoSetMatrix, cairoShowGlyphs): Simplify native calls.
	(cairoTranslate, cairoScale, cairoRotate): Remove.
	(various methods): use setTransform for special transform cases.
	(DrawState): New inner class.
	(stateSave): New method.
	(stateRestore): New method.
	(various methods): use stateSave, stateRestore.
	(getClipInDevSpace): New method.
	(clip, clipRect, setClip, getClip, getClipBounds): 
	Follow spec more closely.
	(getTransform): Return clone of transform.
	(setStroke): Set linewidth to passed width / 2.0.
	(setPaintMode): Set SrcOver rather than Xor.
	(setColor): Set paint to passed color.
	(drawRaster, drawImage, PainterThread, drawPixels): Take affine
	transform from image to user space.
	(drawRenderedImage, drawRenderableImage): Implement.
	(getFontRenderContext, getFontMetrics, drawString, getFont): 
	Implement
	(drawArc, drawOval, drawRoundRect, fillArc, fillOval, fillRoundRect): 
	Implement.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics2D.c: 
	Match changes to java side.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkClasspathFontPeer.c: 
	Release resources.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGlyphVector.c: 
	Don't use pango for metrics.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkClasspathFontPeerMetrics.c: 
	New file.

2003-11-19  Dalibor Topic <robilad@kaffe.org>

	* java/text/FieldPosition.java (equals): Adapted to handle
	field_attribute. Added fast-circuit check for comparison to self.
	Replaced use of instanceof by getClass to fix symmetry for derived
	types.
	(toString): Adapted to handle field_attribute. Improved readability.
	(hashCode): New method.

2003-11-19  Guilhem Lavaux <guilhem@kaffe.org>

	* java/text/FieldPosition.java (field_attribute): New field.
	(FieldPosition (Format.Field), FieldPosition(Format.Field, int),
	getFieldAttribute): New methods.

2003-11-18  Ingo Proetel  <proetel@aicas.com>

	* native/target/generic/target_generic.h: Fixed extern-C declaration.
	* native/target/generic/target_generic_io.h: Likewise.
	* native/target/generic/target_generic_math_float.h: Likewise.
	* native/target/generic/target_generic_math_int.h: Likewise.
	* native/target/generic/target_generic_misc.h: Likewise.
	* native/target/Linux/target_native.h: Likewise.
	* native/target/Linux/target_native_file.h: Likewise.
	* native/target/Linux/target_native_io.h: Likewise.
	* native/target/Linux/target_native_math_float.h: Likewise.
	* native/target/Linux/target_native_math_int.h: Likewise. 
	* native/target/Linux/target_native_misc.h: Likewise.
	* native/target/Linux/target_native_network.h: Likewise.

2003-11-17  Jeff Sturm  <jsturm@one-point.com>

	* java/io/ByteArrayOutputStream.java (resize):
	Fix off-by-one error.

2003-11-17  Graydon Hoare  <graydon@redhat.com>

	* javax/swing/plaf/basic/BasicDefaults.java: Rewrite to spec.
	* javax/swing/UIDefaults.java: Modify to reflect rewrite.

2003-11-17  Graydon Hoare  <graydon@redhat.com>

	* gnu/classpath/Configuration.java.in (default_awt_peer_toolkit):
	Change GTK -> Gtk.

2003-11-17  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/undo/StateEdit.java (getPresentationName): Docfix.
	* javax/swing/undo/AbstractUndoableEdit.java (canUndo, canRedo,
	isSignificant): Likewise.

2003-11-17  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/undo/CompoundEdit.java: Re-format, document.
	(inProgress): Set initial value to true.
	(undo, redo, die, canUndo, canRedo): Also call inherited
	implementation; simplify code structure.
	(getPresentationName, getUndoPresentationName,
	getRedoPresentationName): Make behavior dependent on lastEdit.
	(addEdit, isSignificant): Completely re-written.

2003-11-16  Tom Tromey  <tromey@redhat.com>

	* java/io/StreamTokenizer.java (commentChar): Clear other
	attributes for character.
	(quoteChar): Likewise.

2003-11-15  Michael Koch  <konqueror@gmx.de>

	* java/awt/Font.java,
	java/awt/datatransfer/DataFlavor.java,
	java/math/BigInteger.java,
	java/net/Inet4Address.java,
	java/net/Inet6Address.java,
	java/rmi/MarshalledObject.java,
	java/rmi/server/RMIClassLoader.java,
	java/security/cert/CertStore.java,
	java/sql/Timestamp.java,
	java/text/SimpleDateFormat.java,
	javax/naming/CompoundName.java (equals):
	Removed some redundant obj == null checks.

2003-11-15  Guilhem Lavaux <guilhem@kaffe.org>
	    Jim Pick  <jim@kaffe.org>

	* java/text/DecimalFormat.java (getCurrency, setCurrency): New
	methods.

2003-11-15  Guilhem Lavaux  <guilhem@kaffe.org>

	* java/text/DecimalFormatSymbols.java (getCurrency,
	setCurrency): New methods.

2003-11-14  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/undo/StateEdit.java: Re-format, document.
	(undo, redo): Also call inherited implementation.

2003-11-14  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/undo/StateEditable.java: Re-format, document.

2003-11-14  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/undo/AbstractUndoableEdit.java: Re-format, document.
	(AbstractUndoableEdit): Initialize hasBeenDone to true.
	(canUndo, canRedo): Simplify.
	(getUndoPresentationName, getRedoPresentationName): Support
	localized message; call getPresentationName() only once.

2003-11-14  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/UIManager.java (getDefaults, getDimension,
	getIcon, getInsets, getInstalledLookAndFeels, getInt,
	getLookAndFeel, getString, getSystemLookAndFeelClassName):
	Declare as public.

2003-11-13  Guilhem Lavaux  <guilhem@kaffe.org>
	    Mark Wielaard  <mark@klomp.org>

	* java/net/URLStreamHandler (parseUrl): Fixed URL parsing
	('@' should be checked to distinguish port from userinfo).
	(toExternalForm): Add @ userInfo if necessary.

2003-11-13  Guilhem Lavaux <guilhem@kaffe.org>

	* java/net/ServerSocket.java (close): Check if server socket has
	already been released, before attepting to close it.

2003-11-13  Dalibor Topic <robilad@kaffe.org>

	* gnu/java/net/protocol/file/Connection.java (permission): New field.
	(DEFAULT_PERMISSION): New constant.
	(Connection): Create a FilePermission with permission to read file.
	(getPermission): Overwrite getPermission to return a FilePermission.

2003-11-13  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/undo/CannotRedoException.java: Re-format, document.
	* javax/swing/undo/CannotUndoException.java: Likewise.

2003-11-12  Tom Tromey  <tromey@redhat.com>

	* include/gnu_java_awt_peer_gtk_GtkLabelPeer.h: Rebuilt.

2003-11-12  Michael Koch  <konqueror@gmx.de>

	* external/jaxp/source/gnu/xml/pipeline/XIncludeFilter.java
	(Scrubber.Scrubber): Call methods of super class.
	* external/jaxp/source/org/xml/sax/helpers/XMLReaderFactory.java
	(createXMLReader): Catch RuntimeException not Exception.

2003-11-11  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkLabelPeer.java (create()): Call new create.
	(create(String, float)): New method.
	(setText): Make native.
	(nativeSetAlignment): New method.
	(setAlignment): Call nativeSetAlignment.
	(getArgs): Remove method.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(find_fg_color_widget, find_bg_color_widget): New functions.
	(gtkWidgetSetForeground): Call find_fg_color_widget.
	(gtkWidgetSetBackground): Call find_bg_color_widget.  Modify active and
	prelight colors.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkLabelPeer.c (create): Wrap label
	widget in event box.
	(setText, setAlignment): Implement new native methods.

2003-11-11  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/geom/FlatteningPathIterator.java: Entirely re-written.
	* java/awt/geom/doc-files/FlatteningPathIterator-1.html:
	Describe how the implementation works.

2003-11-10  Gary Benson  <gbenson@redhat.com>

	* java/sql/Timestamp.java (valueOf): Correctly handle
	nanoseconds.

2003-11-09  Tom Tromey  <tromey@redhat.com>

	* java/net/Inet4Address.java (serialVersionUID): Updated.

2003-11-07  Stuart Ballard <stuart.ballard@corp.fast.net>

	* java/util/HashMap.java (putAll): Use Iterator hasNext() method.
	(putAllInternal): Likewise.
	* java/util/Hashtable.java (putAll): Use Iterator hasNext() method.
	(putAllInternal): Likewise.

2003-11-06  Sascha Brawer  <brawer@dandelis.ch>

	* gnu/java/awt/BitwiseXORComposite.java: New file.
	* gnu/java/awt/doc-files: New directory.
	* gnu/java/awt/doc-files/BitwiseXORComposite-1.png: New image.
	* gnu/java/awt/Makefile.am (EXTRA_DIST):
	Added BitwiseXORComposite.java.

2003-11-04  Michael Koch  <konqueror@gmx.de>

	* gnu/java/awt/ClasspathToolkit.java: New file.
	* gnu/java/awt/Makefile.am
	(EXTRA_DIST): Added ClasspathToolkit.java.
	* gnu/java/awt/image/GdkPixbufDecoder.java,
	gnu/java/awt/image/GtkOffScreenDecoder.java: Removed.
	* gnu/java/awt/image/ImageDecoder.java
	(produce): Made public.
	* gnu/java/awt/image/Makefile.am
	(EXTRA_DIST): Removed GdkPixbufDecoder.java and
	GtkOffScreenDecoder.java.
	* gnu/java/awt/peer/ClasspathFontPeer.java,
	gnu/java/awt/peer/gtk/GdkClasspathFontPeer.java,
	gnu/java/awt/peer/gtk/GdkGlyphVector.java,
	gnu/java/awt/peer/gtk/GdkGraphics2D.java,
	gnu/java/awt/peer/gtk/GdkPixbufDecoder.java: New files.
	* gnu/java/awt/peer/Makefile.am
	(EXTRA_DIST): Added ClasspathFontPeer.java.
	* gnu/java/awt/peer/gtk/Makefile.am
	(EXTRA_DIST): Added GdkClasspathFontPeer.java, GdkGlyphVector.java,
	GdkGraphics2D.java and GdkPixbufDecoder.java.
	* gnu/java/awt/peer/gtk/GtkToolkit.java:
	Import gnu.java.awt.peer.gtk.GdkPixbufDecoder.
	* include/Makefile.am: Generate and install new file
	gnu_java_awt_peer_gtk_GdkPixbufDecoder.h.
	* include/gnu_java_awt_image_GdkPixbufDecoder.h: Removed.
	* include/gnu_java_awt_peer_gtk_GdkPixbufDecoder.h: New file.
	* native/jni/gtk-peer/gnu_java_awt_image_GdkPixbufDecoder.c: Removed.

2003-11-04  Michael Koch  <konqueror@gmx.de>

	* java/net/SocketPermission.java
	(equals): Removed unneeded obj == null check.
	* java/net/URL.java
	(equals): Removed unneeded obj == null check.
	(getURLStreamHandler): Removed unneeded ph == null check.

2003-11-04  Michael Koch  <konqueror@gmx.de>

	* java/util/zip/Checksum.java,
	java/util/zip/ZipConstants.java:
	Removed redundant modifiers.
	* java/util/zip/InflaterInputStream.java:
	Merged copyright with libgcj's version.

2003-11-04  Michael Koch  <konqueror@gmx.de>

	* java/nio/ByteBuffer.java
	(equals): Removed unneeded obj != null check.

2003-11-02  Mark Wielaard  <mark@klomp.org>

	* configure.in (AC_CHECK_FUNC): Add ftruncate, fsync and select.

	* native/target/generic/target_generic_file.h
	(TARGET_NATIVE_FILE_OPEN): Check filedescriptor >= 0 before calling
	fcntl.

2003-10-30  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextAreaPeer.c (create): Turn on
	word wrapping.

2003-10-29  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkListPeer.c (getSize): Return
	scrolled window's size request.

2003-10-26  Mark Wielaard  <mark@klomp.org>

	Reported by Helmer Kraemer <hkraemer@freenet.de>
	* java/util/jar/JarInputStream.java (readManifest): Don't call
	closeEntry().

2003-10-26  Bryce McKinlay  <bryce@mckinlay.net.nz>

	* java/lang/reflect/AccessibleObject.java (secureSetAccessible):
	Don't check for AccessibleObject. Update javadocs.

	* java/util/TreeMap.java: Doc fixes. HashMap -> TreeMap.

2003-10-24  Julian Dolby  <dolby@us.ibm.com>

	* javax/naming/spi/NamingManager.java (getContinuationContext): Call
	getObjectInstance() with Object, Name, Context and environment
	Hashtable from exception. Call fillInStackTrace() on exception when
	rethrown.

2003-10-24  Julian Dolby  <dolby@us.ibm.com>

	* javax/naming/InitialContext.java (lookup(Name)): When a
	CannotProceedException is thrown use the ContinuationContext.
	(lookup(String)): Likewise.
	(close): Clear myProps and defaultInitCtx.

2003-10-24  Ito Kazumitsu <kaz@maczuka.gcd.org>

	* java/text/DecimalFormat.java
	(scanFormat) corrected so that '%' may appear in a pattern.

2003-10-24  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkDialogPeer.java (handleEvent):
	Remove method.
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java (postWindowEvent):
	New method.
	* java/awt/Window.java (Window(Window,GraphicsConfiguration),
	show, hide, dispose, getOwnedWindows): Synchronize on tree lock.
	(dispose): Post WINDOW_CLOSED event.
	(addWindowFocusListener, addWindowStateListener): Assign result
	of multicaster add back to window listener.
	(removeWindowFocusListener, removeWindowStateListener): Assign
	result of multicaster remove back to window listener.
	(dispatchEventImpl): Add null checks for focus and state
	listeners.
	(processWindowEvent): Handle case where windowListener is null
	but state or focus listeners exist.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMainThread.c: Add JNI
	glue for postWindowEvent.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(window_delete_cb, window_destroy_cb, window_show_cb,
	window_focus_in_cb, window_focus_out_cb, window_window_state_cb,
	window_get_new_state): New functions.
	* jni/gtk-peer/gtkpeer.h: Define window event and frame state
	macros.  Declare postWindowEventID.

2003-10-24  Mark Wielaard  <mark@klomp.org>

	From Guilhem Lavaux  <guilhem.lavaux@free.fr>
	* java/text/DateFormat.java (Field): New public static inner class.
	* java/text/Format.java (Field): Likewise.
	(formatToCharacterIterator): New method.
	* java/text/FormatCharacterIterator.java: New file.
	* java/text/Makefile.am (EXTRA_DIST): Add
	FormatCharacterIterator.java.

2003-10-24  Dalibor Topic  <robilad@kaffe.org>

	* gnu/java/beans/IntrospectionIncubator.java (addMethod): Add public
	static methods.

2003-10-24  Mark Wielaard  <mark@klomp.org>

	From Guilhem Lavaux  <guilhem.lavaux@free.fr>
	* java/util/Currency.java: New file.
	* java/util/Makefile.am (EXTRA_DIST): Add Currency.java.

2003-10-23  Mark Wielaard  <mark@klomp.org>

	* gnu/java/net/protocol/file/Makefile.am (EXTRA_DIST): Renamed
	FileURLConnection.java to Connection.java.
	* gnu/java/net/protocol/http/Makefile.am (EXTRA_DIST): Renamed
	HttpURLConnection.java to Connection.java.
	* gnu/java/net/protocol/jar/Makefile.am (EXTRA_DIST): Renamed
	JarURLConnection.java to Connection.java.

2003-10-23  Sascha Brawer  <brawer@dandelis.ch>

        * java/awt/geom/CubicCurve2D.java (contains): Docfix for URL of embedded drawing.
        * java/awt/geom/QuadCurve2D.java: Likewise.

2003-10-23  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/geom/CubicCurve2D.java: Added documentation.
	* java/awt/geom/QuadCurve2D.java: Likewise.

	* java/awt/geom/doc-files/QuadCurve2D-4.png,
	java/awt/geom/doc-files/QuadCurve2D-5.png,
	java/awt/geom/doc-files/CubicCurve2D-4.png,
	java/awt/geom/doc-files/Cubicurve2D-5.png: New illustrations.

2003-10-22  Tom Tromey  <tromey@redhat.com>

	* java/lang/Class.java: Indentation fixes.

2003-10-22  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/geom/CubicCurve2D.java (getFlatnessSq): Implement.
	(subdivide(CubicCurve2D, CubicCurve2D)): Avoid useless object allocation.
	(subdivide(double[],int,double[],int,double[],int)): Implement.

2003-10-22  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/geom/doc-files/CubicCurve2D-1.png,
	java/awt/geom/doc-files/CubicCurve2D-2.png,
	java/awt/geom/doc-files/CubicCurve2D-3.png: New illustrations.

2003-10-22  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/geom/QuadCurve2D.java (subdivide): Added documentation.
	java/awt/geom/doc-files/QuadCurve2D-3.png: New illustration.

2003-10-22  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/geom/QuadCurve2D.java: Reformatted, wrote Javadoc.
	* java/awt/geom/doc-files: New directory.
	* java/awt/geom/doc-files/QuadCurve2D-1.png,
	java/awt/geom/doc-files/QuadCurve2D-2.png: New illustrations.
	
2003-10-22  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/geom/QuadCurve2D.java (subdivide): Implement.

2003-10-21  Michael Koch  <konqueror@gmx.de>

	* java/text/CollationKey.java
	(compareTo): Simplified implementation.
	(equals): Reoved redundant obj == null check.
	* java/text/RuleBasedCollator.java
	(RuleBasedCollator): Throw ParseException instead of
	IllegalArgumentException.

2003-10-21  Michael Koch  <konqueror@gmx.de>

	* java/io/File.java
	(equals): Removed redundant obj == null check.

2003-10-21  Michael Koch  <konqueror@gmx.de>

	* native/target/generic/target_generic_file.h
	(TARGET_NATIVE_OPEN_FILE): Set close-on-exec flag.
	* native/target/generic/target_generic_network.h
	(TARGET_NATIVE_NETWORK_SOCKET_OPEN_STREAM): Set close-on-exec flag.
	(TARGET_NATIVE_NETWORK_SOCKET_OPEN_DATAGRAM): Likewise.

2003-10-21  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/geom/QuadCurve2D.java (getFlatness, getFlatnessSq): Implement.

2003-10-21  Sascha Brawer  <brawer@dandelis.ch>

	Fix for Classpath bug #6076.
	* java/awt/geom/GeneralPath.java (append): Re-written.

2003-10-21  Sascha Brawer  <brawer@dandelis.ch>

	Fix for Classpath bug #6089.
	* java/awt/geom/GeneralPath.java (curveTo): Set correct segment type.
	(getPathIterator, GeneralPathIterator): Re-written from scratch.

2003-10-21  Sascha Brawer  <brawer@dandelis.ch>

	Fix for bug #2944, reported by David Holmes <dholmes@dltech.com.au>
        * java/util/logging/ErrorManager.java (everUsed): Made volatile.
        (error): Synchronize on instance, not class.

2003-10-20  Mark Wielaard  <mark@klomp.org>

	Reported by M.Negovanovic
	* java/beans/Introspector.java (getBeanInfo(ClassLoader, String)): New
	method.
	(reallyFindExplicitBeanInfo): Use new getBeanInfo() method.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/PipeImpl.java
	(PipeImpl): New constructor implementation which takes
	SelectorProvider argument.
	* gnu/java/nio/SelectorProviderImpl.java
	(openPipe): Give SelectorProvider argument to PipeImpl.
	* gnu/java/nio/SocketChannelImpl.java
	(read): Fixed reading into ByteBuffer objects which are backed by an
	array.
	(write): Likewise.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/FileLockImpl.java,
	gnu/java/nio/SelectorImpl.java,
	java/nio/ByteOrder.java,
	java/nio/DirectByteBufferImpl.java,
	java/nio/channels/FileChannelImpl.java:
	Added code to load library with native methods in it.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/SelectorImpl.java: Reformated.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/SocketChannelImpl.java
	(connected): Removed. Use socket.isConnected() instead.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/Connection.java,
	gnu/java/net/protocol/http/Connection.java:
	Some reformating.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/Connection.java
	(inputStream): Made it a BufferedInputStream.
	(outputStream): Made it a BufferedOutputStream.
	(connect): Initialize inputStream and outputStream correctly.
	* gnu/java/net/protocol/http/Connection.java
	(proxyHost): New class variable.
	(proxyPort): Likewise.
	(proxyInUse): Likewise.
	(static): New method to initialize proxy variables.
	(connect): connect to proxy if proxy is used.
	(sendRequest): Fixed handling of "Host" request property.
	(usingProxy): Return true if proxy is used.
	* gnu/java/net/protocol/jar/Connection.java
	(Connection): Removed IOException from throws clause. Moved
	initialization if jar_url to connect().

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* java/text/RuleBasedCollator.java: Some more reformating.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/http/Connection.java:
	Reformated. Renamed some variables to match libgcj's version.

2003-10-20  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/geom/GeneralPath.java (getCurrentPoint): Return last
	point, not start of subpath.  Fixes Classpath bug #6075.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/Connection.java:
	Reformated, renamed some in_stream to inputStream in out_stream to
	outputStream.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/PlainDatagramSocketImpl.java
	(native_fd): Made package-private.
	(finalize): New method.
	(getTTL): Call getTimeToLive.
	(setTTL): Call setTimeToLive.
	* gnu/java/net/PlainSocketImpl.java
	(native_fd): Made package-private.
	(finalize): New method.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/HeaderFieldHelper.java: Reformated.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/jar/Handler.java,
	gnu/java/net/protocol/http/Handler.java,
	gnu/java/net/protocol/file/Handler.java:
	Some reformating, edited ChangeLog and authors to merge with libgcj.

2003-10-20  Michael Koch  <konqueror@gmx.de>

	* java/text/RuleBasedCollator.java:
	Renamed some variables, some reformating.
	(RuleBasedCollator): Throw ParseException instead of
	IllegalArgumentException.

2003-10-18  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/FileURLConnection.java,
	gnu/java/net/protocol/http/HttpURLConnection.java,
	gnu/java/net/protocol/jar/JarURLConnection.java:
	Removed.
	* gnu/java/net/protocol/file/Connection.java,
	gnu/java/net/protocol/http/Connection.java,
	gnu/java/net/protocol/jar/Connection.java:
	New files.
	* gnu/java/net/protocol/jar/Handler.java,
	gnu/java/net/protocol/http/Handler.java,
	gnu/java/net/protocol/file/Handler.java,
	gnu/java/lang/SystemClassLoader.java:
	Use new files.

2003-10-18  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/FileURLConnection.java,
	gnu/java/net/protocol/http/HttpURLConnection.java,
	gnu/java/net/protocol/jar/JarURLConnection.java:
	Reformated.

2003-10-18  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/protocol/file/Handler.java,
	gnu/java/net/protocol/http/Handler.java,
	gnu/java/net/protocol/jar/Handler.java:
	Reformated.

2003-10-18  Ralph Loader  <rcl@ihug.co.nz>

	* java/lang/StringBuffer.java (getChars): Fix array index checks.
	(append, substring, insert): Likewise.

2003-10-17  Tom Tromey  <tromey@redhat.com>

	* java/lang/reflect/Proxy.java (generate): Pass protection domain
	to VMClassLoader.defineClass.

2003-10-15  Mark Wielaard  <mark@klomp.org>

	Reported by M.Negovanovic
	* java/beans/IndexedPropertyDescriptor.java
	(IndexedPropertyDescriptor): this.setIndex = setIndex, not getIndex.

2003-10-15  Michael Koch  <konqueror@gmx.de>

	* java/text/RuleBasedCollator.java
	(RuleBasedCollator): Renamed i to index and save rules.length() to
	temporary variable.
	(getCollationElementIterator): Fixed documentation.
	(getCollationKey): Fixed documentation.

2003-10-15  Michael Koch  <konqueror@gmx.de>

	* java/text/RuleBasedCollator.java:
	Some reformating.
	(CollationElement): Made final.
	(compare): Renamed s1 to source and s2 to target.
	(getCollationElementIterator): Renamed str to source,
	replaced while loop with for loop.
	(getCollationKey): Renamed str to source.
	(getCollationElementValue): Likewise.

2003-10-15  Michael Koch  <konqueror@gmx.de>

	* java/text/CollationElementIterator.java
	(CollationElementIterator): Exchange arguments, call setText.
	(next): Reformated.
	(reset): Reformated.
	(setText): Fixed documentation, added @since tag, reformated.
	(getOffset): Added @since tag, reformated.
	(previous): Reformated.
	* java/text/CollationKey.java
	(getSourceString): Reformated.
	(hashCode): Reformated.
	(toByteArray): Reformated.
	* java/text/RuleBasedCollator.java: Reordered all methods to match
	order in libgcj.

2003-10-15  Michael Koch  <konqueror@gmx.de>

	* java/text/AttributedCharacterIterator.java,
	java/text/CharacterIterator.java:
	Reformated.

2003-10-15  Michael Koch  <konqueror@gmx.de>

	* java/text/AttributedCharacterIterator.java,
	java/text/CharacterIterator.java:
	Removed redundant modifiers.

2003-10-15  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/NIOSocket.java
	(setChannel): Initialize impl.
	* gnu/java/nio/ServerSocketChannelImpl.java
	(ServerSocketChannelImpl): Made class public final.
	(serverSocket): Made it a NIOServerSocket.
	(getNativeFD): New method.
	(implConfigureBlocking): Set socket timeout.
	(accept): Rewritten.
	* gnu/java/nio/SelectorImpl.java
	(register): Use ServerSocketChannelSelectionKey for server socket
	channels, removed comments.
	* gnu/java/nio/SocketChannelImpl.java
	(impl): New member variable.
	(SocketChannelImpl): Initialize impl.
	(getImpl): New method.
	* gnu/java/nio/NIOServerSocket.java,
	gnu/java/nio/ServerSocketChannelSelectionKey.java: New files.
	* gnu/java/nio/Makefile.am (EXTRA_DIST):
	Added NIOServerSocket.java and ServerSocketChannelSelectionKey.java.

2003-10-15  Michael Koch  <konqueror@gmx.de>

	* java/util/Map.java,
	java/util/Observer.java:
	Removed redundant modifiers.

2003-10-13  Michael Koch  <konqueror@gmx.de>

	* gnu/java/rmi/server/ProtocolConstants.java,
	gnu/java/security/der/DER.java,
	java/net/URLStreamHandlerFactory.java,
	java/rmi/activation/ActivationInstantiator.java,
	java/rmi/activation/ActivationMonitor.java,
	java/rmi/activation/ActivationSystem.java,
	java/rmi/activation/Activator.java:
	Removed redundant modifiers.
	* java/sql/DatabaseMetaData.java,
	java/sql/ParameterMetaData.java,
	java/sql/PreparedStatement.java:
	Readded accidently removed modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/io/File.java: Reformated.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/io/File.java
	(caseSensitive): New class varibale indicatinc case sensitivity.
	Currently set to true statically to support only case sensitive file
	systems.
	(equals): Support case sensitivity (in general).
	(getParentFile): Simplified.
	(hashCode): Support case sensitivity (in general).

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/nio/Buffer.java
	(hasRemaining): Made implementation more clear.
	* java/nio/MappedByteBuffer.java
	(loaded): New member variable.
	(force): Added comment.
	(isLoaded): Return value of loaded.
	(load): Set loaded to true, added comment.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/net/ServerSocket.java
	(getImpl): New package private method to be accessed only by Java NIO.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/net/JarURLConnection.java
	(jarFileURL): Made final.
	(entryName): Renamed from entry_name, made file.
	(getJarEntry): Renamed file to jarFile.
	(getCertificates): Check getJarEntry() != null.
	(getMainAttributes): Check getManifest() != null.
	* java/net/URLConnection.java
	(def_req_props): Removed, obsoleted since JDK 1.3.
	(): Renamed d to date.
	(toString): Print class name.
	(): Added possible exceptions in documentation.
	(setRequestProperty): Check for key == null and connection state.
	(addRequestProperty): Check for key == null, fixed documentation.
	(getRequestProperty): Check for connection state.
	(getRequestProperties): Check for connection state.
	(setDefaultRequestProperty): Does nothing since JDK 1.3.
	(getDefaultRequestProperty): Likewise.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/nio/channels/spi/AbstractSelectableChannel.java
	(registered): Made private.
	(blocking): Likewise.
	(LOCK): Likewise.
	(provider): Likewise.
	(keys): Made it a private LinkedList.
	(AbstractSelectableChannel): Initialize keys.
	(isRegistered): New implementation.
	(locate): Rewritten.
	(register): Rewritten.
	* java/nio/channels/spi/AbstractSelectionKey.java
	(ok): Removed.
	(cancelled): New member variable.
	(cancel): Rewritten.
	(isValid): Rewritten.
	* java/nio/channels/spi/AbstractSelector.java:
	Some methods moved.
	(closed): Make private.
	(provider): Likewise.
	(cancelledKeys): New member variable.
	(AbstractSelector): Initialize cancelledKeys.
	(cancelKey): New method.
	* java/nio/channels/spi/SelectorProvider.java
	(pr): Removed.
	(systemDefaultProvider): New member variable.
	(provider): Made it synchronized, use property
	java.nio.channels.spi.SelectorProvider.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/io/FilePermission.java
	(implies): Removed unused local variables.
	* java/io/ObjectStreamClass.java
	(getObjectStreamClasses): Removed unused local variable.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* javax/print/attribute/Attribute.java,
	javax/print/attribute/AttributeSet.java,
	javax/print/attribute/PrintRequestAttributeSet.java,
	javax/transaction/Status.java,
	javax/transaction/Synchronization.java,
	javax/transaction/Transaction.java,
	javax/transaction/TransactionManager.java,
	javax/transaction/UserTransaction.java,
	javax/transaction/xa/XAResource.java,
	javax/transaction/xa/Xid.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* javax/swing/event/AncestorListener.java,
	javax/swing/event/CaretListener.java,
	javax/swing/event/CellEditorListener.java,
	javax/swing/event/ChangeListener.java,
	javax/swing/event/DocumentEvent.java,
	javax/swing/event/DocumentListener.java,
	javax/swing/event/HyperlinkListener.java,
	javax/swing/event/InternalFrameListener.java,
	javax/swing/event/ListDataListener.java,
	javax/swing/event/ListSelectionListener.java,
	javax/swing/event/MenuDragMouseListener.java,
	javax/swing/event/MenuKeyListener.java,
	javax/swing/event/MenuListener.java,
	javax/swing/event/MouseInputListener.java,
	javax/swing/event/PopupMenuListener.java,
	javax/swing/event/TableColumnModelListener.java,
	javax/swing/event/TableModelListener.java,
	javax/swing/event/TreeExpansionListener.java,
	javax/swing/event/TreeModelListener.java,
	javax/swing/event/TreeSelectionListener.java,
	javax/swing/event/TreeWillExpandListener.java,
	javax/swing/event/UndoableEditListener.java,
	javax/swing/table/DefaultTableModel.java,
	javax/swing/table/TableCellEditor.java,
	javax/swing/table/TableCellRenderer.java,
	javax/swing/table/TableColumnModel.java,
	javax/swing/table/TableModel.java,
	javax/swing/text/AbstractDocument.java,
	javax/swing/text/Document.java,
	javax/swing/text/MutableAttributeSet.java,
	javax/swing/text/StyledDocument.java,
	javax/swing/text/ViewFactory.java,
	javax/swing/tree/DefaultMutableTreeNode.java,
	javax/swing/tree/MutableTreeNode.java,
	javax/swing/tree/RowMapper.java,
	javax/swing/tree/TreeCellEditor.java,
	javax/swing/tree/TreeCellRenderer.java,
	javax/swing/tree/TreeModel.java,
	javax/swing/tree/TreeNode.java,
	javax/swing/tree/TreeSelectionModel.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* javax/swing/Action.java,
	javax/swing/BoundedRangeModel.java,
	javax/swing/CellEditor.java,
	javax/swing/ComboBoxEditor.java,
	javax/swing/ComboBoxModel.java,
	javax/swing/DesktopManager.java,
	javax/swing/JComboBox.java,
	javax/swing/ListCellRenderer.java,
	javax/swing/ListSelectionModel.java,
	javax/swing/MenuElement.java,
	javax/swing/MutableComboBoxModel.java,
	javax/swing/Renderer.java,
	javax/swing/RootPaneContainer.java,
	javax/swing/ScrollPaneConstants.java,
	javax/swing/SingleSelectionModel.java,
	javax/swing/SpinnerModel.java,
	javax/swing/SwingConstants.java,
	javax/swing/UIDefaults.java,
	javax/swing/WindowConstants.java,
	javax/swing/border/Border.java,
	javax/swing/colorchooser/ColorSelectionModel.java,
	javax/swing/plaf/UIResource.java,
	javax/swing/plaf/metal/MetalLookAndFeel.java,
	javax/swing/undo/StateEditable.java,
	javax/swing/undo/UndoableEdit.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* javax/naming/Context.java,
	javax/naming/Name.java,
	javax/naming/NameParser.java,
	javax/naming/NamingEnumeration.java,
	javax/naming/Referenceable.java,
	javax/naming/directory/Attribute.java,
	javax/naming/directory/Attributes.java,
	javax/naming/directory/DirContext.java,
	javax/naming/event/EventContext.java,
	javax/naming/event/EventDirContext.java,
	javax/naming/event/NamespaceChangeListener.java,
	javax/naming/event/NamingListener.java,
	javax/naming/event/ObjectChangeListener.java,
	javax/naming/ldap/Control.java,
	javax/naming/ldap/ExtendedRequest.java,
	javax/naming/ldap/ExtendedResponse.java,
	javax/naming/ldap/HasControls.java,
	javax/naming/ldap/LdapContext.java,
	javax/naming/ldap/UnsolicitedNotification.java,
	javax/naming/ldap/UnsolicitedNotificationListener.java,
	javax/naming/spi/DirObjectFactory.java,
	javax/naming/spi/DirStateFactory.java,
	javax/naming/spi/InitialContextFactory.java,
	javax/naming/spi/InitialContextFactoryBuilder.java,
	javax/naming/spi/ObjectFactory.java,
	javax/naming/spi/ObjectFactoryBuilder.java,
	javax/naming/spi/Resolver.java,
	javax/naming/spi/StateFactory.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/sql/Array.java,
	java/sql/Blob.java,
	java/sql/CallableStatement.java,
	java/sql/Clob.java,
	java/sql/Connection.java,
	java/sql/DatabaseMetaData.java,
	java/sql/Driver.java,
	java/sql/ParameterMetaData.java,
	java/sql/PreparedStatement.java,
	java/sql/Ref.java,
	java/sql/ResultSet.java,
	java/sql/ResultSetMetaData.java,
	java/sql/SQLData.java,
	java/sql/SQLInput.java,
	java/sql/SQLOutput.java,
	java/sql/Savepoint.java,
	java/sql/Statement.java,
	java/sql/Struct.java,
	javax/sql/ConnectionEventListener.java,
	javax/sql/ConnectionPoolDataSource.java,
	javax/sql/DataSource.java,
	javax/sql/PooledConnection.java,
	javax/sql/RowSet.java,
	javax/sql/RowSetInternal.java,
	javax/sql/RowSetListener.java,
	javax/sql/RowSetMetaData.java,
	javax/sql/RowSetReader.java,
	javax/sql/RowSetWriter.java,
	javax/sql/XAConnection.java,
	javax/sql/XADataSource.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/sql/Array.java,
	java/sql/Blob.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/security/Key.java,
	java/security/PrivateKey.java,
	java/security/PublicKey.java,
	java/security/acl/Acl.java,
	java/security/acl/AclEntry.java,
	java/security/acl/Group.java,
	java/security/acl/Owner.java,
	java/security/acl/Permission.java,
	java/security/cert/X509Extension.java,
	java/security/interfaces/DSAKey.java,
	java/security/interfaces/DSAKeyPairGenerator.java,
	java/security/interfaces/DSAParams.java,
	java/security/interfaces/DSAPrivateKey.java,
	java/security/interfaces/DSAPublicKey.java,
	java/security/interfaces/RSAKey.java,
	java/security/interfaces/RSAPrivateCrtKey.java,
	java/security/interfaces/RSAPrivateKey.java,
	java/security/interfaces/RSAPublicKey.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/nio/channels/Channel.java,
	java/nio/channels/GatheringByteChannel.java,
	java/nio/channels/ReadableByteChannel.java,
	java/nio/channels/ScatteringByteChannel.java,
	java/nio/channels/WritableByteChannel.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/io/Externalizable.java,
	java/io/FileFilter.java,
	java/io/ObjectInput.java,
	java/io/ObjectInputValidation.java,
	java/io/ObjectOutput.java,
	java/io/ObjectStreamConstants.java,
	java/io/Serializable.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/net/ContentHandlerFactory.java,
	java/net/DatagramSocketImplFactory.java,
	java/net/FileNameMap.java,
	java/net/SocketImplFactory.java,
	java/net/SocketOptions.java:
	Removing redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/rmi/dgc/DGC.java,
	java/rmi/registry/Registry.java,
	java/rmi/registry/RegistryHandler.java,
	java/rmi/server/LoaderHandler.java,
	java/rmi/server/RMIClientSocketFactory.java,
	java/rmi/server/RMIFailureHandler.java,
	java/rmi/server/RMIServerSocketFactory.java,
	java/rmi/server/RemoteCall.java,
	java/rmi/server/RemoteRef.java,
	java/rmi/server/ServerRef.java,
	java/rmi/server/Skeleton.java,
	java/rmi/server/Unreferenced.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/beans/AppletInitializer.java,
	java/beans/BeanInfo.java,
	java/beans/Customizer.java,
	java/beans/DesignMode.java,
	java/beans/PropertyEditor.java,
	java/beans/Visibility.java,
	java/beans/beancontext/BeanContext.java,
	java/beans/beancontext/BeanContextChild.java,
	java/beans/beancontext/BeanContextChildComponentProxy.java,
	java/beans/beancontext/BeanContextChildSupport.java,
	java/beans/beancontext/BeanContextContainerProxy.java,
	java/beans/beancontext/BeanContextMembershipListener.java,
	java/beans/beancontext/BeanContextProxy.java,
	java/beans/beancontext/BeanContextServiceProvider.java,
	java/beans/beancontext/BeanContextServiceProviderBeanInfo.java,
	java/beans/beancontext/BeanContextServiceRevokedListener.java,
	java/beans/beancontext/BeanContextServices.java,
	java/beans/beancontext/BeanContextServicesListener.java:
	Removed redundant modifiers.

2003-10-12  Michael Koch  <konqueror@gmx.de>

	* java/awt/ActiveEvent.java,
	java/awt/datatransfer/ClipboardOwner.java,
	java/awt/datatransfer/FlavorMap.java,
	java/awt/datatransfer/Transferable.java,
	java/awt/dnd/Autoscroll.java,
	java/awt/dnd/peer/DragSourceContextPeer.java,
	java/awt/dnd/peer/DropTargetContextPeer.java,
	java/awt/dnd/peer/DropTargetPeer.java,
	java/awt/font/MultipleMaster.java,
	java/awt/font/OpenType.java,
	java/awt/im/spi/InputMethodDescriptor.java,
	java/awt/image/ImageConsumer.java,
	java/awt/image/ImageObserver.java,
	java/awt/image/ImageProducer.java,
	java/awt/image/RGBImageFilter.java,
	java/awt/image/RasterOp.java,
	java/awt/image/renderable/RenderableImage.java,
	java/awt/peer/ButtonPeer.java,
	java/awt/peer/CheckboxMenuItemPeer.java,
	java/awt/peer/CheckboxPeer.java,
	java/awt/peer/ChoicePeer.java,
	java/awt/peer/ComponentPeer.java,
	java/awt/peer/ContainerPeer.java,
	java/awt/peer/DialogPeer.java,
	java/awt/peer/FileDialogPeer.java,
	java/awt/peer/FramePeer.java,
	java/awt/peer/LabelPeer.java,
	java/awt/peer/ListPeer.java,
	java/awt/peer/MenuBarPeer.java,
	java/awt/peer/MenuComponentPeer.java,
	java/awt/peer/MenuItemPeer.java,
	java/awt/peer/MenuPeer.java,
	java/awt/peer/PopupMenuPeer.java,
	java/awt/peer/RobotPeer.java,
	java/awt/peer/ScrollPanePeer.java,
	java/awt/peer/ScrollbarPeer.java,
	java/awt/peer/TextAreaPeer.java,
	java/awt/peer/TextComponentPeer.java,
	java/awt/peer/TextFieldPeer.java,
	java/awt/peer/WindowPeer.java,
	java/awt/print/Pageable.java,
	java/awt/print/Printable.java,
	java/awt/print/PrinterGraphics.java:
	Removed redundant modifiers.

2003-10-09  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/PlainSocketImpl.java: Added classes SocketInputStream
	and SocketOutputStream.
	* gnu/java/net/SocketInputStream.java: Removed.
	* gnu/java/net/SocketOutputStream.java: Removed.
	* gnu/java/net/Makefile.am (EXTRA_DIST): Removed removed files.

2003-10-09  Michael Koch  <konqueror@gmx.de>

	* java/net/InetAddress.java
	(isSiteLocalAddress): Made hexadecimal numbers lowercase.
	(getLocalHostname): Renamed from getLocalHostName, fixed
	documentation.
	(aton): New method.
	(getByName): Moved functionality to aton(), simplified code.
	(getLocalHost): Reformated.
	(lookupInaddrAny): Reformated.
	* include/java_net_InetAddress.h: Regenerated.
	* native/jni/java-net/java_net_InetAddress.c
	(getLocalHostname): Renamed from getLocalHostName.

2003-10-09  Michael Koch  <konqueror@gmx.de>

	* java/math/BigInteger.java
	(add): Removed unused local variable len.

2003-10-08  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkButtonPeer.java (handleEvent): Remove
	modality check.
	* gnu/java/awt/peer/gtk/GtkDialogPeer.java (initializeInsets):
	Initialize insets to use latest insets.
	* gnu/java/awt/peer/gtk/GtkFramePeer.java: Likewise.
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java (latestInsets): New
	field.
	(postConfigureEvent): Update latestInsets field when insets
	change.  Remove call to setSize.  Move validate call outside of
	if blocks.
	(setVisible): Call setBounds before showing window.
	(nativeSetVisible): New native method.
	* java/awt/Window.java (show): Show visible owned windows.
	(hide): Hide visible owned windows.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(awt_event_handler): Implement modality using GTK grabs.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMainThread.c
	(global_gtk_window_group): New global variable.
	(gtkInit): Initialize global_gtk_window_group.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c (create):
	Clamp width and height values to at least 1.  Add this window to
	the global GTK window group.
	(setVisible): Rename to nativeSetVisible.
	(setup_window): Remove function.
	(setSize): Clamp width and height values to at least 1.
	(nativeSetBounds): Likewise.
	(gdk_window_get_root_geometry): Remove function.
	* jni/gtk-peer/gtkpeer.h: Remove gdk_window_get_root_geometry
	and setup_window declarations.  Declare global_gtk_window_group.

	* gnu/java/awt/peer/gtk/GtkButtonPeer.java,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkButtonPeer.c
	(gtkSetFont): Handle BOLD and ITALIC style specifiers.
	(gtkWidgetSetForeground): New method.
	* gnu/java/awt/peer/gtk/GtkComponentPeer.java,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(gtkWidgetSetBackground, gtkWidgetSetForeground): New methods.
	(setBackground, setForeground): Implement.
	* gnu/java/awt/peer/gtk/GtkTextAreaPeer.java,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextAreaPeer.c
	(gtkSetFont): Handle BOLD and ITALIC style specifiers.
	* gnu/java/awt/peer/gtk/GtkTextFieldPeer.java,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextFieldPeer.c: Likewise.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics.c (drawString):
	Position PangoLayout relative to text's baseline.
	* jni/gtk-peer/gtkpeer.h: Define AWT font style constants.

	* java/awt/FlowLayout.java (layoutContainer): Fix offset problem
	for CENTER and RIGHT alignments.

2003-10-08  Tom Tromey  <tromey@redhat.com>

	* java/lang/StrictMath.java (toDegrees): Multiply before
	dividing.
	(toRadians): Likewise.

	* java/lang/reflect/Proxy.java (generate): Removed comment about
	security hole.

2003-10-08  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkMenuItemPeer.java (setEnabled): Stub
	out.
	* jni/classpath/jcl.c [!__GNUC__]: Elide __attribute__.
	(JCL_free): Attach "unused" attribute to env parameter.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkChoicePeer.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkClipboard.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkImagePainter.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkListPeer.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMainThread.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMenuItemPeer.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMenuPeer.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkPopupMenuPeer.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextComponentPeer.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkToolkit.c,
	jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c,
	jni/gtk-peer/gthread-jni.c: Attach "unused" attribute to unused
	parameters.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkClipboard.c:
	(initNativeState): Pass 0 as info argument to
	gtk_selection_add_target.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c:
	(setVisible, gtkFixedNew, gtkFixedPut, gtkFixedMove): Remove
	unused method implementations.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(awt_event_handler): Add break statement after default label.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkImagePainter.c
	(drawPixels): Remove unused variable i.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMenuItemPeer.c
	(setEnabled): Remove method implementation.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMenuPeer.c
	(accel_attach): Call _gtk_accel_group_attach with G_OBJECT
	argument.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkPanelPeer.c (sr): Remove
	unused function.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkPopupMenuPeer.c
	(menu_pos): Assign TRUE to push_in.
	(setupAccelGroup): Call _gtk_accel_group_attach with G_OBJECT
	argument.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkScrollPanePeer.c
	(create): Remove unused variable layout.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c (create):
	Pass window_widget, rather than window, to
	gtk_widget_set_size_request.
	* jni/gtk-peer/gthread-jni.c (g_thread_jni_functions): Fill out
	structure initialization with NULL values.
	* jni/gtk-peer/gtkpeer.h [!__GNUC__]: Elide __attribute__.

2003-10-07  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkTextAreaPeer.java (gtkTextGetSize):
	Remove unused parameters.
	* gnu/java/awt/peer/gtk/GtkTextFieldPeer.java (gtkEntryGetSize):
	Likewise.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(keyevent_state_to_awt_mods): Export function.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextComponentPeer.c
	(getCaretPosition): Fix TextArea case.
	(textcomponent_commit_cb): Get exact event time and modifier
	state.
	* jni/gtk-peer/gtkpeer.h: Declare keyevent_state_to_awt_mods.

2003-10-07  Michael Koch  <konqueror@gmx.de>

	* java/security/Security.java: Merged formating with libgcj,
	added non-breaking space in documentation.

2003-10-07  Michael Koch  <konqueror@gmx.de>

	* java/security/Security.java
	(providersList): Renamed to "providers".
	(providersInited): Removed.
	(static): New static initializer.
	(providers): Removed.

2003-10-06  Michael Koch  <konqueror@gmx.de>

	* java/rmi/server/RMIClassLoader.java: Reformated to match libgcj's
	version more.
	(defaultAnnotation): Added comment.

2003-10-06  Michael Koch  <konqueror@gmx.de>

	* java/net/ServerSocket.java
	(ServerSocket): New package-private constructor used by java.nio.

2003-10-06  Michael Koch  <konqueror@gmx.de>

	* java/nio/ByteBufferHelper.java:
	Rewrote all methods by suggestions from Eric Blake.

2003-10-02  Arnaud Vandyck <arnaud.vandyck@ulg.ac.be>

	* javax/swing/table/AbstractTableModel.java
	(getColumnName): Simplified code much. Thanks to Yannick Boogaerts who
	helped stop pulling my hair on this +1 then -1 tricky thing!

2003-10-02  Michael Koch  <konqueror@gmx.de>

	* java/text/SimpleDateFormat.java
	(compileFormat): Character.isLetter(char) allows too much characters.
	Replace it with Character.isLowerCase(char) ||
	Character.isUpperCase(char).

2003-10-02  Michael Koch  <konqueror@gmx.de>

	* java/util/prefs/Preferences.java
	(defaultFactoryClass): Fixed default factory class name.
	(getFactory): Instantiate factory class.

2003-10-02  Michael Koch  <konqueror@gmx.de>

	* java/net/InetAddress.java
	(isSiteLocalAddress): New method.
	(isMCLinkLocal): New method.
	(getByAddress): Call getByAddress alternative instead of implementing
	it again.
	(getAllByName): Added security manager check.
	(getLocalHost): Fixed documentation.
	(readResolve): Added documentation.

2003-10-02  Guilhem Lavaux  <guilhem@kaffe.org>

	* java/net/InetSocketAddress.java
	(InetSocketAddress): Made exception more clear.
	(equals): Handle case when addr is null.
	(toString): Likewise.
	* java/net/NetworkInterface.java
	(static): Load native library.
	(getNetworkInterfaces): Rewritten.

2003-10-02  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkComponentPeer.java (insets): New
	field.
	(initializeInsets): New method.
	(GtkComponentPeer): Call initializeInsets.  Call setCursor and
	setBounds unconditionally.
	(setBounds): Convert coordinates if parent is a Window.
	* gnu/java/awt/peer/gtk/GtkContainerPeer.java (insets): Move
	field to GtkComponentPeer.
	(GtkContainerPeer): Don't initialize insets.
	* gnu/java/awt/peer/gtk/GtkDialogPeer.java (initializeInsets):
	New method.
	(create): Call new GtkWindowPeer create method.
	* gnu/java/awt/peer/gtk/GtkFramePeer.java (initializeInsets):
	New method.
	(create): Call new GtkWindowPeer create method.
	(setBounds): Remove method.
	(postConfigureEvent): Likewise.
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java: Replace GTK window
	type constants with GDK window type constants.
	(create(int,boolean,int,int,GtkWindowPeer)): New method.
	(create(int,boolean)): Likewise.
	(create()): Call create(int,boolean).
	(nativeSetBounds): New native method declaration.
	(setBounds): Call native method declaration.
	(setSize): New native method declaration.
	(setBoundsCallback): Likewise.
	(postConfigureEvent): Handle change in insets.  Call setSize and
	setBoundsCallback methods.
	* java/awt/Window.java (Window): Set visible to false.
	(setBoundsCallback): New method.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(gtkWidgetGetLocationOnScreen): If this component is not a
	container, adjust the location returned based on the peer's
	allocation.
	(set(String,boolean)): Revert change from 2003-09-19.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(awt_event_handler): Fix inset calculation.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMainThread.c: Add JNI
	glue for Window.setBoundsCallback.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c (create):
	Set up stacking order, window decorations and window manager
	hints.
	(setBoundsCallback): New method.
	(setSize): New method.
	(nativeSetBounds): New method.
	* jni/gtk-peer/gtkpeer.h: Declare setBoundsCallbackID.

2003-10-02  Michael Koch  <konqueror@gmx.de>

	* java/net/InetAddress.java
	(toString): Got of StringBuffer, return SUN compliant string.

2003-10-02  Michael Koch  <konqueror@gmx.de>

	* java/net/InetAddress.java
	(isAnyLocalAddress): New method.
	(isLoopbackAddress): New method.
	(getAddress): Clone addr instead of copying it ourself.
	(hashCode): Merge much simpler (but SUN conform) code from libgcj.
	(equals): Renamed "test_ip" to "addr2".
	(getByName): Added security manager check, fixed documentation.
	(getAllByName): Fixed documentation.

2003-10-02  Michael Koch  <konqueror@gmx.de>

	* java/net/URL.java
	(DEFAULT_SEARCH_PATH): Added sun.net.www.protocol to search path.
	(ph_cache): Made it a HashMap.
	(ph_search_path): Removed.
	(static): Removed initialization of ph_search_path.
	(getURLStreamHandler): Get java.protocol.handler.pkgs property and
	append DEFAULT_SEARCH_PATH locally.

2003-10-02  Michael Koch  <konqueror@gmx.de>

	* gnu/classpath/Configuration.java.in
	(default_awt_peer_toolkit) :
	New member variable for default AWT toolkit.
	* java/awt/Toolkit.java
	(default_toolkit_name): Initialize with
	gnu.classpath.Configuration.default_awt_peer_toolkit.

2003-09-29  Michael Koch  <konqueror@gmx.de>

	* javax/swing/table/AbstractTableModel.java
	(findColumnName): Prevent from NullPointerException if argument
	columnName is null.

2003-09-29  Michael Koch  <konqueror@gmx.de>

	* javax/swing/table/AbstractTableModel.java:
	This patch is based on a patch done by Arnaud Vandyck
	<arnaud.vandyck@ulg.ac.be>.
	(getColumnName): Fixed method documentation.
	(findColumn): Likewise.
	(getColumnClass): Likewise.
	(isCellEditable): Likewise.
	(setValueAt): Likewise.
	(addTableModelListener): Likewise.
	(removeTableModelListener): Likewise.
	(getTableModelListeners): New method.

2003-09-29  Michael Koch  <konqueror@gmx.de>

	* javax/swing/table/AbstractTableModel.java:
	Reformated.

2003-09-29  Michael Koch  <konqueror@gmx.de>

	* java/net/InetAddress.java
	(isLinkLocalAddress): New method.
	(isMCGlobal): Likewise.
	(isMCNodeLocal): Likewise.
	(isMCSiteLocal): Likewise.
	(isMCOrgLocal): Likewise.

2003-09-29  Michael Koch  <konqueror@gmx.de>

	* java/net/InetAddress.java: Reformatted.
	* java/net/URL.java
	(DEFAULT_SEARCH_PATH): New constant for default handler search path.
	(static): Use DEFAULT_SEARCH_PATH instead of static string.
	(getURLStreamHandler): Put instances of the handlers into the cache.

2003-09-28  Bryce McKinlay  <bryce@mckinlay.net.nz>

	* java/text/DateFormat.java (format): Throw IllegalArgumentException
	if `obj' is not a Number or Date instance.
	* java/text/SimpleDateFormat.java (tokens): Make it an ArrayList
	instead of Vector.

2003-09-28  Bryce McKinlay  <bryce@mckinlay.net.nz>

	* java/text/SimpleDateFormat.java (parse): Revert patch of 2003-09-09.
	Don't call setTimeZone on calendar.

2003-09-27  Michael Koch  <konqueror@gmx.de>

	* java/net/InetAddress.java: Reordered several methods to match order
	in libgcj's version of InetAddress.java. Some code got reformated too.

2003-09-27  Michael Koch  <konqueror@gmx.de>

	* AUTHORS: Added myself.

2003-09-27  Michael Koch  <konqueror@gmx.de>

	* java/net/URL.java (getURLStreamHandler):
	Initialize ph, make loop over StringTokenizer more efficient
	a.k.a. do eventually less loops.

2003-09-27  Michael Koch  <konqueror@gmx.de>

	* java/awt/image/IndexColorModel.java: Reformated.

2003-09-27  Michael Koch  <konqueror@gmx.de>

	* java/net/URL.java (getURLStreamHandler):
	Try to put handler into cache only once. Reformat some code
	to match libgcj more.

2003-09-26  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/PlainDatagramSocketImpl.java,
	gnu/java/net/PlainSocketImpl.java:
	(getNativeFD): New method.
	* gnu/java/nio/DatagramChannelImpl.java,
	gnu/java/nio/DatagramChannelSelectionKey.java,
	gnu/java/nio/SelectionKeyImpl.java,
	gnu/java/nio/SelectorImpl.java,
	gnu/java/nio/SocketChannelImpl.java:
	Many fixes, I cant write them all down here again.
	Files are merged from libgcj.
	* gnu/java/nio/DatagramChannelSelectionKey.java,
	gnu/java/nio/SocketChannelSelectionKey.java:
	New files.
	* gnu/java/nio/Makefile.am (EXTRA_DIST):
	Added DatagramChannelSeclectionKey.java and
	SocketChannelSelectionKey.java.

2003-09-26  Michael Koch  <konqueror@gmx.de>

	* java/nio/ByteBufferHelper.java:
	Totally reworked with help from Eric Blake.

2003-09-26  Tom Tromey  <tromey@redhat.com>

	* java/awt/geom/RoundRectangle2D.java (getPathIterator): Wrote.
	* java/awt/geom/PathIterator.java: Documentation fixes.

2003-09-26  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/image/SinglePixelPackedSampleModel.java (createDataBuffer): 
	Save space for some pixels at the buffer end.  Added Javadoc.

2003-09-25  Tom Tromey  <tromey@redhat.com>

	* java/io/ObjectOutputStream.java (writeFields): Fixed
	indentation.
	(putFields): Likewise.

2003-09-25  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkDialogPeer.java (create()): Create a
	top-level GTK window.
	(getArgs): Add "title" property.
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java (setResizable): Use
	"allow_shrink" and "allow_grow" properties.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c: Remove
	unused GtkArg code.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(create): Set window's size requisition.
	(connectHooks): Fix indentation.
	(setResizable): Remove function.
	(static setBounds): Likewise.
	(setBounds): Replace call to setBounds with GTK size requisition
	and resize calls.

	* java/awt/Dialog.java: Initialize resizable to true and change
	comments accordingly.  Initialize visible to false in
	constructors.
	* java/awt/Frame.java (dispose): Remove method.
	* java/awt/Window.java (ownedWindows): New field.
	(Window(Window,GraphicsConfiguration)): Add a weak reference to
	owner's ownedWindows vector.
	(finalize): Remove method.
	(hide): Hide owned windows.
	(dispose): Dispose of owned windows.
	(getOwnedWindows): Implement.

2003-09-25  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/PlainDatagramSocketImpl.java:
	Reordered imports.
	* gnu/java/net/PlainSocketImpl.java:
	Removed import for java.net.NetworkInterface.

2003-09-25  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/SelectorImpl.java
	(implSelect): Renamed from java_do_select.
	(select): Made final, throws IOException,
	call native implSelect() and add support for Thread interruption.
	(selectNow): Made final, throws IOException.
	(getFDsAsArray): Made final.
	(selectedKeys): Likewise.
	(wakeup): Likewise.
	(deregisterCancelledKeys): Likewise.
	(register): Likewise.
	(ass): Removed.
	(add_selected): Removed.

2003-09-25  Tom Tromey  <tromey@redhat.com>

	* java/lang/Math.java (min): Revert to using != for NaN
	detection.
	(max): Likewise.
	(round): Likewise.

2003-09-25  Mark Wielaard  <mark@klomp.org>

	* java/nio/Makefile.am (EXTRA_DIST): Add ByteBufferHelper.java. 
	* java/lang/Makefile.am (EXTRA_DIST): Add Thread.java.
	* vm/reference/java/lang/Makefile.am (EXTRA_DIST): Remove Thread.java.
	Add VMThread.java.

2003-09-25  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/image/Raster.java(Raster): Interpret null origin as (0,0).
	* java/awt/image/WritableRaster.java(WritableRaster): Likewise.

2003-09-25  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/image/BufferedImage.java (toString): Implement.

2003-09-25  Michael Koch  <konqueror@gmx.de>

	* include/java_lang_reflect_Array.h: Regenerated.

2003-09-25  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/DatagramChannelImpl.java
	(DatagramChannelImpl): Made class final.
	(blocking): Made private.
	(socket): Made it a NIODatagramSocket and private.
	(DatagramChannelImpl): create NIODatagramSocket instead of
	DatagramSocket.
	(implConfigureBlocking): Set socket timeout.
	(connect): Check that channel is not closed.
	(write): Implemented.
	(write): Rewritten.
	(read): Implemented.
	(read): Rewritten.
	(receive): Implemented.
	(send): Implemented.
	* gnu/java/nio/SelectionKeyImpl.java
	(readyOps): Made private.
	(interestOps): Made private.
	(impl): Made private.
	(ch): Made private.
	(readyOps): Check if selection key is valid.
	(interestOps): Likewise.
	* gnu/java/nio/SelectorImpl.java
	(closed): Removed.
	(keys): Made private.
	(selected): Made private.
	(finalize): New method.
	(implCloseSelector): Rewritten.
	(keys): Return unmodifiable Set.
	(deregisterCancelledKeys): Fixed typo in method name.
	* gnu/java/nio/SocketChannelImpl.java
	(SocketChannelImpl): Made class final.
	(socket): Made it a NIOSocket and private.
	(blocking): Made private.
	(connected): Made private.
	(connectionPending): New member variable.
	(SocketChannelImpl): New implementation.
	(finalizer): Use isConnected().
	(connect): Rewritten.
	(finishConnect): Throws IOException, implemented.
	(isConnectionPending): Return connectionPending.
	(read): Rewritten.
	(write): Rewritten.
	* gnu/java/nio/NIOConstants.java: New file.
	* java/nio/ByteBufferHelper.java:
	New file.
	* java/nio/ByteBufferImpl.java,
	java/nio/DirectByteBufferImpl.java,
	java/nio/MappedByteBufferImpl.java
	(getType,putType): Use new helper class ByteBufferHelper.
	* gnu/java/nio/Makefile.am (EXTRA_DIST): Added NIOConstants.java.

2003-09-25  Michael Koch  <konqueror@gmx.de>

	* include/Makefile.am: Dont generated gnu_java_nio_FileChannelImpl.h.
	* include/gnu_java_nio_FileChannelImpl.h: Removed.
	* native/jni/java-nio/java_nio.c:
	Include java_nio_channels_FileChannelImpl.h instead of
	gnu_java_nio_FileChannelImpl.h.

2003-09-25  Michael Koch  <konqueror@gmx.de>

	* java/rmi/server/RMIClassLoader.java:
	Reindented and reformatted code, no functional changes.

2003-09-23  Tom Tromey  <tromey@redhat.com>

	* java/lang/ClassLoader.java: Don't import SystemClassLoader.
	(systemClassLoader): Fixed indentation.

2003-09-24  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/geom/Rectangle2D.java (getPathIterator): Use the same
	winding rule as Sun J2SE.

2003-09-24  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/border/MatteBorder.java (MatteBorder(Icon)): Docfix.

2003-09-24  Bryce McKinlay  <bryce@mckinlay.net.nz>

	* java/lang/StringBuffer.java (substring): Don't set `shared' on small
	Strings, even if buffer is already shared.

2003-09-23  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/font/FontRenderContext.java (getTransform): Return
	copy of internal transform object. Add Javadoc.

2003-09-22  Michael Koch  <konqueror@gmx.de>

	* external/.cvsignore: New file, ignore Makefile and Makefile.in.

2003-09-21  Ralph Loader  <suckfish@ihug.co.nz>

	PR java/12350:
	* java/lang/StringBuffer.java (substring): Fix handling of shared flag.

2003-09-22  Michael Koch  <konqueror@gmx.de>

	* java/net/InetAddress.java
	(static): Unified static initializers.
	(address): Made private.
	(InetAddress): Moved around.
	(isMulticastAddress): Moved around.
	(getByAddress): New method, merged from libgcj.
	(readResolve): Likewise.
	(readObject): Likewise.
	(writeObject): Likewise.

2003-09-21  Michael Koch  <konqueror@gmx.de>

	* java/net/JarURLConnection.java
	(JarURLConnection): Rename "str" (again) to "spec" to match libgcj
	better.

2003-09-21  Michael Koch  <konqueror@gmx.de>

	* java/net/JarURLConnection.java
	(JarURLConnection): Added some comments.
	(getAttributes): Reimplements because getJarEntry() can return null.

2003-09-21  Michael Koch  <konqueror@gmx.de>

	* java/net/JarURLConnection.java:
	(jar_file): Removed.
	(JarURLConnection): Renamed "url_string" to "str", no need to strip
	"jar:", URL.getFile does this already for us, simplified code.
	(getJarEntry): Reimplemented without using jar_file.
	(getManifest): Likewise.

2003-09-21  Michael Koch  <konqueror@gmx.de>

	* java/net/JarURLConnection.java
	(real_url): Renamed to jarFileURL.
	(jarFileURL): Renamed from jarFileURL (to match libgcj).
	(JarURLConnection): Renamed real_url to jarFileURL, made exception
	descriptions more descriptive and move "jar" protocol test around.
	(getJarFileURL): Return jarFileURL.

2003-09-21  Michael Koch  <konqueror@gmx.de>

	* java/net/JarURLConnection.java
	(JarURLConnection): Store result of url_string.index ("!/") in a local
	variable instead of computing it 4 times.

2003-09-21  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramSocket.java
	(DatagramSocket): Implemented socket implementaion initialization
	with respect to "impl.prefix" property. This is a merge from libgcj.

2003-09-21  Michael Koch  <konqueror@gmx.de>

	* gnu/java/nio/NIODatagramSocket.java,
	gnu/java/nio/NIOSocket.java: New files,
	merged from libgcj.
	* gnu/java/nio/Makefile.am
	(EXTRA_DIST): Added new files NIODatagramSocket.java
	and NIOSocket.java.

2003-09-20  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramSocket.java
	(getLocalAddress): Check if socket got closed,
	return InetAddress.ANY_IF when SecurityManager.checkConnect() fails.
	* java/net/URLConnection.java
	(getInputStream): Throw UnknownServiceException.
	(getOutputStream): Likewise.
	(setRequestProperty): Fixed link in method documentation.

2003-09-19  Mark Wielaard  <mark@klomp.org>

	* doc/www.gnu.org/home.wml: The latest release can again be found at
	ftp://alpha.gnu.org/gnu/classpath/.

2003-09-19  Michael Koch  <konqueror@gmx.de>

	* java/net/DatagramSocket.java
	(ch): Removed.
	(receive): Use getChannel() instead of ch.
	(send): Likewise.
	(getChannel): Return null.
	* java/net/ServerSocket.java
	(ch): Removed.
	(setChannel): Removed.
	(implAccept): Use getChannel() instead of ch.
	(close): Likewise.
	(getChannel): Return null.
	* java/net/Socket.java
	(ch): Removed.
	(connect): Use getChannel() instead of ch.
	(setChannel): Removed.
	(getChannel): Return null.

2003-09-19  Michael Koch  <konqueror@gmx.de>

	* java/nio/channels/FileChannelImpl.java
	(read): Set position before actually reading.
	(write): Set position before acturally writing.
	(transferTo): Flip buffer before writing.
	(transferFrom): Likewise.

2003-09-19  Tom Tromey  <tromey@redhat.com>

	* java/net/URLClassLoader.java: Some documentation fixes.
	* java/net/URLStreamHandler.java (parseURL): If original file
	ends with "/", so must canonical result.

2003-09-19  Michael Koch  <konqueror@gmx.de>

	* gnu/java/net/PlainDatagramSocketImpl.java,
	gnu/java/net/PlainSocketImpl.java,
	gnu/java/net/SocketInputStream.java,
	gnu/java/net/SocketOutputStream.java: Moved from java/net.
	* gnu/java/net/Makefile.am
	(EXTRA_DIST): Added new files:
	PlainDatagramSocketImpl.java, PlainSocketImpl.java,
	SocketInputStream.java, SocketOutputStream.java.
	* include/gnu_java_net_PlainDatagramSocketImpl.h,
	include/gnu_java_net_PlainSocketImpl.h: New generated JNI header.
	* include/java_net_PlainDatagramSocketImpl.h,
	include/java_net_PlainSocketImpl.h: Removed generated JNI header.
	* include/Makefile.am: Generate and install new JNI header files
	instead of the old ones.
	* java/net/PlainDatagramSocketImpl.java,
	java/net/PlainSocketImpl.java,
	java/net/SocketInputStream.java,
	java/net/SocketOutputStream.java: Moved to gnu/java/net.
	* java/net/DatagramSocket.java:
	Import gnu.java.net.PlainDatagramSocketImpl.
	* java/net/ServerSocket.java,
	java/net/Socket.java: Import gnu.java.net.PlainSocketImpl.
	* java/net/Makefile.am (EXTRA_DIST): Removed the following files:
	PlainDatagramSocketImpl.java, PlainSocketImpl.java,
	SocketInputStream.java, SocketOutputStream.java.
	* native/jni/java-net/gnu_java_net_PlainDatagramSocketImpl.c,
	native/jni/java-net/gnu_java_net_PlainSocketImpl.c,
	native/jni/java-net/java_net_PlainDatagramSocketImpl.c,
	native/jni/java-net/java_net_PlainSocketImpl.c:
	Moved from java.net namespace to gnu.java.net.
	* native/jni/java-net/Makefile.am:
	Compile new files instead of old ones.

2003-09-18  Tom Tromey  <tromey@redhat.com>

	* java/awt/Toolkit.java: Added missing "in" in javadoc.

2003-09-13 Dalibor Topic <robilad@kaffe.org>,
	   Helmer Kraemer <hkraemer@freenet.de>

	* javax/naming/spi/NamingManager.java (getURLContext,
	getObjectInstance, getStateToBind): Always use current thread's
	context class loader when calling Class.forName.

2003-09-18  Tom Tromey  <tromey@redhat.com>

	* javax/naming/InitialContext.java: Reindented.

2003-09-18  Michael Koch  <konqueror@gmx.de>

	* include/.cvsignore: Ignore Makefile.in and Makefile.

2003-09-18  Michael Koch  <konqueror@gmx.de>

	* java/awt/event/KeyEvent.java: Some reformatting.
	This merges KeyEvent with libgcj.

2003-09-18  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* java/awt/Frame.java (Frame(String)): Initialize visible field
	to false.
	(Frame(GraphicsConfiguration)): Likewise.
	(Frame(String,GraphicsConfiguration)): Likewise.

2003-09-17  Graydon Hoare  <graydon@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics2D.java,
	gnu/java/awt/peer/gtk/GdkPixbufDecoder.java,
	native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics2D.c,
	native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkPixbufDecoder.c: 
	New files.

2003-09-16  Graydon Hoare  <graydon@redhat.com>

	* java/awt/BufferedImage.java (setData): Support non-component
	sample models.
	(getData): Same.

2003-09-10  Graydon Hoare  <graydon@redhat.com>

	* java/awt/geom/AffineTransform.java(transform): Fix airthmetic bugs.
	* java/awt/geom/Arc2D.java: Approximate arc segments with cubics.

2003-09-15  Ingo Proetel  <proetel@aicas.com>

	* native/jni/java-net/java_net_PlainDatagramSocketImpl.c (receive, receive0): renamed receive to receive0 

	* include/java_net_PlainDatagramSocketImpl.h (receive, receive0): renamed receive to receive0 

	* java/net/PlainDatagramSocketImpl.java (receive0): added
	(receive): changed to call receive0 and serialize access on RECEIVE_LOCK
	(send): chanded to serialize access on SEND_LOCK
	

2003-09-11  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/Toolkit.java (getSystemEventQueue, getSystemEventQueueImpl):
	Replace UTF-8 characters in Javadoc by XML/HTML escape sequence.

2003-09-11  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/Toolkit.java (getSystemEventQueue): Call SecurityManager
	if one is installed. Improve Javadoc.
	(getSystemEventQueueImpl): Improve Javadoc.

2003-09-10  David Daney <ddaney@avtrex.com>

	* java/util/Arrays.java (equals(all variants)): Quit using
	NullPointerException catching to detect null valued parameters.

2003-09-09  Guilhem Lavaux  <guilhem@kaffe.org>

	* java/text/SimpleDateFormat.java (parse): Don't use class calendar
	field.

2003-09-09  Mark Wielaard  <mark@klomp.org>

	* java/lang/reflect/Array.java (set): Allow null for Object arrays.

2003-09-09  Guilhem Lavaux  <guilhem@kaffe.org>

	* java/text/DecimalFormat.java (format): Don't immediatly round
	baseNumber to long.
	(setMinimumIntegerDigits): Call super.
	(setMinimumFractionDigits): Likewise.
	(setMaximumIntegerDigits): Likewise.
	(setMaximumFractionDigits): Likewise.

2003-09-07  Dalibor Topic  <robilad@kaffe.org>

       * java/awt/BasicStroke.java (BasicStroke): Fixed illegal argument
       checking to follow 1.4.2 spec.

2003-08-25  Scott Gilbertson  <scottg@mantatest.com>

	* java/awt/Component.java (createImage): changed to use peer method.

2003-08-31  Mark Wielaard  <mark@klomp.org>

	* doc/www.gnu.org/home.wml: Update project description and status.
	Mark links which are temporarily unreachable. Add news section.
	Move distribution terms to the end. Add Kaffe OpenVM.
	* doc/www.gnu.org/docs/docs.wml: Mark api doc as temporarily down.

2003-08-31  David P Grove  <groved@us.ibm.com>

	* java/io/LineNumberReader (read): Don't reset pos & limit when
	markPos is 0.

2003-08-29  Dalibor Topic  <robilad@kaffe.org>

	* gnu/java/rmi/rmic/Compile_gcj.java (COMPILER_ARGS): New private
	constant.
	(computeArguments): use computeTypicalArguments.

	* gnu/java/rmi/rmic/Makefile.am (EXTRA_DIST): Add Compile_kjc.java,
	Compile_jikes.java and RMICException.java.
	* gnu/java/rmi/rmic/Compile_kjc.java: New file.
	* gnu/java/rmi/rmic/Compile_jikes.java: Likewise.
	* gnu/java/rmi/rmic/RMICException.java: Likewise.
 
	* gnu/java/rmi/rmic/Compiler.java (getDestination): New method.
 
	* gnu/java/rmi/rmic/CompilerProcess.java: Import java.io.InputStream.
	(computeTypicalArguments): New method.
	(compile): Print compiler output to System.out. Collect compiler
	error output and use it in exception message.
 
	* gnu/java/rmi/rmic/RMIC.java: Import java.util.Set.
	(destination): Initialize to null.
	(run): Replace file separator with '.' when processing class.
	(processClass): Replace '.' with file separator when compiling
	classes.
	(findClass): Use SystemClassLoader to load class.
	(generateStub): Use full class name for generated stub, that puts
	it in right path.  Replace '.' with file separator when generating
	stub file name. Write just the stub class name without package
	information as class name, and constructor name. Write only
	interface names for interfaces extending java.rmi.Remote as
	implemented.
	(generateSkel): Use full class name for generated skel, that puts
	it in right path.  Replace '.' with file separator when generating
	stub file name. Write just the stub class name without package
	information as class name.

2003-08-29  Stephen Crawley  <crawley@dstc.edu.au>

	* ltmain.sh: Define SED and max_cmd_len when undefined.

2003-08-29  Jeroen Frijters <jeroen@frijters.net>

	* java/lang/Thread.java: New file.
	* vm/reference/java/lang/Thread.java: Removed.
	* vm/reference/java/lang/VMThread.java: New file.

2003-08-26  Tom Tromey  <tromey@redhat.com>

	* java/lang/reflect/Proxy.java (ProxyData): `pack' now a String.
	(ProxyData.getPackage): New method.
	(ProxyData.getProxyData): Use package name, not Package.
	(ClassFactory.ClassFactory): Updated.

2003-08-25  Mark Wielaard  <mark@klomp.org>

	* vm/reference/java/lang/Thread.java (join(long)): Call sleep(10),
	not sleep(1). Explicitly check elapsed time.

2003-08-24  Mark Wielaard  <mark@klomp.org>

	* configure.in (AC_INIT): Use four argument version.
	(AC_CONFIG_SRCDIR): New to explicitly set src dir.
	(AM_INIT_AUTOMAKE): Use zero argument version.
	(AC_SUBST): Only set LIBVERSION explicitly. Removed variables
	PACKAGE, VERSION which are substituted implicitly.
	(AM_DISABLE_STATIC): Renamed to AC_DISABLE_STATIC.
	(AC_DISABLE_STATIC): Renamed from AM_DISABLE_STATIC.
	(AM_PROG_LIBTOOL): Renamed to AC_PROG_LIBTOOL.
	(AC_PROG_LIBTOOL: Renamed from AM_PROG_LIBTOOL.
	(--enable-jni): Default to yes.
	* config.guess: New version from libtoolize --force --copy.
	* config.sub: Likewise.
	* ltmain.sh: Likewise.
	* HACKING: Document that libtool 1.5a works.
	* lib/Makefile.am (MAINTAINERCLEANFILES): Renamed to CLEANFILES.
	(CLEANFILES): New variable renamed from MAINTAINERCLEANFILES with
	glibj.zip and classes.1 added.
	(maintainer-clean-local): Renamed to clean-local.
	(clean-local): Renamed from maintainer-clean-local.
	
2003-08-22  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GdkGraphics.java (drawString): Pass font
	name, not XLFD, to native drawString.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GdkGraphics.c (drawString):
	Replace XLFD-based implementation with Pango-based
	implementation.

2003-08-22  Scott Gilbertson  <scottg@mantatest.com>
            Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/GLightweightPeer.java: Remove file.
	* gnu/java/awt/Makefile.am (EXTRA_DIST): Remove
	GLightweightPeer.java.
	* gnu/java/awt/peer/GLightweightPeer.java: New file.
	* gnu/java/awt/peer/Makefile.am (EXTRA_DIST): Add
	GLightweightPeer.java.
	* java/awt/Component.java (getToolkit): Add comment about
	lightweight components.
	* java/awt/Toolkit.java (createComponent): Return
	gnu.java.awt.peer.GLightweightPeer.

2003-08-22  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkDialogPeer.java (create): Create
	GTK_WINDOW_POPUP window.
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java: Remove
	GTK_WINDOW_DIALOG.  Set GTK_WINDOW_POPUP to 1.

2003-08-22  Mark Wielaard  <mark@klomp.org>

	* configure.in (VERSION): Set to 0.06+cvs.

2003-08-22  Mark Wielaard  <mark@klomp.org>

	* configure.in (VERSION): Set to 0.06.

2003-08-20  Tom Tromey  <tromey@redhat.com>

	* java/lang/ref/Reference.java (get): Indentation fix.
	(clear): Comment fix.
	(enqueue): Likewise.
	(lock): Likewise.
	(referent): Likewise.

2003-08-19  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/jni/java-nio/java_nio_FileChannelImpl.c:
	Added includes target_native.h, target_native_math_int.h

2003-08-19  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/target/generic/target_generic_network.h:
	Fixed TARGET_NATIVE_NETWORK_GET_HOSTNAME() macro

2003-08-19  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/jni/java-nio/java_nio_FileChannelImpl.c:
	Fixed return value of Java_java_nio_channels_FileChannelImpl_size(),
        Java_java_nio_channels_FileChannelImpl_implPosition__()

2003-08-19  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/jni/java-io/java_io_File.c:
	Fixed return value of 0 in Java_java_io_File_lastModifiedInternal()

2003-08-18  Mark Wielaard  <mark@klomp.org>

	* Makefile.am (DISTCHECK_CONFIGURE_FLAGS): Disable --enable-gjdoc.
	* doc/api/Makefile.am (dist-hook): Removed.

2003-08-18  Mark Wielaard  <mark@klomp.org>

	* Makefile.am (dist-hook): Remove entries now handled by Makefile.am
	in the external directory.

2003-08-17  Mark Wielaard  <mark@klomp.org>

	* external/jaxp/source/javax/xml/transform/TransformerFactory.java:
	Don't use &nbsp; in the api documentation.
	external/jaxp/source/org/xml/sax/ext/Locator2.java: Likewise.

2003-08-17  Mark Wielaard  <mark@klomp.org>

	* doc/api/Makefile.am (core): Don't include doc-files in package list.
	(jaxp): Don't include gnu packages.
	(create_html): Add classpath-copyright.xml as -bottomnote.
	* doc/api/classpath-copyright.xml: Updated year.

2003-08-17  Mark Wielaard  <mark@klomp.org>

	* Makefile.am (SUBDIRS): Add external.
	* configure.in (AC_OUTPUT): Add external/Makefile.
	* external/README: Add how to update Makefile.am jaxp_FILES entry.
	* external/Makefile.am: New file.

2003-08-16  Mark Wielaard  <mark@klomp.org>

	* java/security/Security.java: Don't use &nbsp; in the api
	documentation.
	* java/security/acl/Acl.java: Fix broken p tag.
	* java/text/DateFormatSymbols.java: Correctly open and close li tags.
	* javax/swing/border/LineBorder.java: Close img tag alt attributes.
	* javax/swing/plaf/TreeUI.java: Likewise.
	* javax/swing/plaf/basic/BasicTreeUI.java: Likewise.

2003-08-16  Mark Wielaard  <mark@klomp.org>

	* java/util/Properties.java: Use the word umlaut, not &auml; in api
	documentation.
	* java/util/PropertyResourceBundle.java: Likewise and add closing code
	tag.

2003-08-16  Mark Wielaard  <mark@klomp.org>

	* NEWS: Fix java.swing.border -> javax.swing.border and nativee ->
	native.

2003-08-16  Mark Wielaard  <mark@klomp.org>

	Reported by Patrik Reali
	* gnu/java/io/decode/DecoderUTF8.java (charsInByteArray): Take offset
	into account.
	(convertToChars): Take buf_offset into account.
	(read): Take offset into account. Break loop early when
	in.avaiable() <= 0.

2003-08-16  Mark Wielaard  <mark@klomp.org>

	Reported by Julian Dolby
	* java/lang/Package.java (getPackage): Use currentClassLoader() not
	VMSecurityManager.getClassContext()[1].getClassLoader().

2003-08-16  Mark Wielaard  <mark@klomp.org>

	Reported by Guilhem Lavaux and Julian Dolby
	* java/io/ObjectStreamClass.java (getSerialPersistentFields): Get the
	field "serialPersistentFields", not "getSerialPersistentFields".

2003-08-15  Mark Wielaard  <mark@klomp.org>

	* NEWS: Updated with important improvements for 0.06 release.

2003-08-15  Mark Wielaard  <mark@klomp.org>

	* HACKING: Updated known working/not-working versions of auto-tools.

2003-08-14  Archie Cobbs  <archie@dellroad.org>

	* java/lang/reflect/Constructor.java (equals):
	Completely rewritten for correctness.
	* java/lang/reflect/Field.java (equals):
	Completely rewritten for correctness.
	* java/lang/reflect/Method.java (equals):
	Completely rewritten for correctness.

2003-08-14  Mark Wielaard  <mark@klomp.org>

	* configure.in (AC_OUTPUT): Add native/target/Makefile,
	native/target/Linux/Makefile and native/target/generic/Makefile.
	* native/Makefile.am (SUBDIRS): Add target.
	* native/target/.cvsignore: New file.
	* native/target/Makefile.am: Likewise.
	* native/target/Linux/.cvsignore: Likewise.
	* native/target/Linux/Makefile.am: Likewise.
	* native/target/generic/.cvsignore: Likewise.
	* native/target/generic/Makefile.am: Likewise.

2003-08-14  Mark Wielaard  <mark@klomp.org>

	* include/gnu_java_awt_peer_gtk_GtkMainThread.h: Regenerated.
	* include/gnu_java_nio_FileChannelImpl.h: Likewise.

2003-08-14  Stephen Crawley  <crawley@dstc.edu.au>

	* java/security/Security.java (providers_lazy): Renamed.
	(providersList): Renamed providers_lazy field.
	(providers_lazy_set): Renamed
	(providersInited): Renamed providers_lazy_set field.
	(providers): Set providersInited to true. Reindent.

2003-08-12  Graydon Hoare  <graydon@redhat.com>

	* java/awt/Font.java: 
	Stub out more recent API. 

2003-08-12  Graydon Hoare  <graydon@redhat.com>

	* java/awt/Color.java (getAlpha): 
	Prevent sign-extended alpha values.

2003-08-12  Ingo Proetel  <proetel@aicas.com>

	* java/util/TimeZone.java: initialize lazily 
	* java/util/Locale.java:readManifest: fix check for country 
	* java/util/GregorianCalendar.java:make use of ResourceBundle better traceable 
	* java/util/Calendar.java: make use of ResourceBundle better traceable 

2003-08-12  Ingo Proetel  <proetel@aicas.com>

	* gnu/java/io/encode/EncoderEightBitLookup.java: conserve memory 
	* gnu/java/io/decode/DecoderEightBitLookup.java: override ready()-method 

2003-08-12  Ingo Proetel  <proetel@aicas.com>

	* java/util/logging/SimpleFormatter.java:print souceClassName and sourceMethodName

2003-08-12  Ingo Proetel  <proetel@aicas.com>

	* java/rmi/server/RMIClassLoader.java: identify cached classloaders by 
	codebase and contextclassloader 
	* java/rmi/Naming.java: added comments, now accepts pseudo protocol "rmi" 
	* gnu/java/rmi/rmic/RMIC.java: uncommeted code  

2003-08-12  Jeroen Frijters  <jeroen@frijters.net>

	* java/net/URLClassLoader: (findClass): close InputStream after
        we're done with it

2003-08-12  Ingo Proetel  <proetel@aicas.com>

	* java/util/logging/Logger.java: provide class and method information 
	* java/util/logging/LogManager.java: create handlers  

2003-08-12  Ingo Proetel  <proetel@aicas.com>

	* java/io/ObjectOutputStream.java : allow putFields be called more than once 

2003-08-12  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/font/OpenType.java: Remove 'public static final'
	from OpenType tags, reverting the change of 2003-08-11.  See
	Classpath discussion list of 2003-08-11.

2003-08-11  Tom Tromey  <tromey@redhat.com>

	* java/awt/EventQueue.java (currentEvent, lastWhen): New fields.
	(postEvent): Removed FIXME comment.
	(isDispatchThread): Documented.
	(getCurrentEvent): New method.
	(dispatchEvent): Set currentEvent and lastWhen.
	(getMostRecentEventTime): Rewrote.
	(invokeLater): Documented.

2003-08-11  Ingo Proetel  <proetel@aicas.com>

	* gnu/java/rmi/server/UnicastRef.java: make constructor public and check if serverobject  
	is compatible in case client and server are running in the same VM
	* gnu/java/rmi/rmic/RMIC.java: fix that methods of the remote interfaces are used
	instead of the xxxImpl class
	

2003-08-11  Ingo Proetel  <proetel@aicas.com>

	* gnu/java/net/protocol/http/HttpURLConnection.java: fixed NullPointerException.
	* gnu/java/net/protocol/http/Handler.java: override getDefaultPort() to return 80

2003-08-11  Ingo Proetel <proetel@aicas.com>

	* native/jni/classpath/jcl.c: removed static array for error string.
	The use of this static array made the code non-reentrant and wasted 
	memory when it was not needed. 

2003-08-11 Ingo Proetel <proetel@aicas.com>

	* java/util/class-dependencies.conf,
	java/text/class-dependencies.conf,
	java/nio/class-dependencies.conf,
	java/net/class-dependencies.conf,
	java/math/class-dependencies.conf,
	java/lang/class-dependencies.conf,
	java/io/class-dependencies.conf,
	gnu/java/io/class-dependencies.conf:
	Added use of variables in class dependencies. These variable can be 
	used to configure the set of supported libraries for features such 
	as supported encoders/decoders, URL protocols, etc.
	
2003-08-11 Ingo Proetel <proetel@aicas.com>

	* java/security/Security.java: moved initialization code of providers
	from static initializer into a method to allow lazy evaluation of
	this code. This permits faster startup and even automatic removal of
	this code if it is not needed. 

2003-08-11  Sascha Brawer  <brawer@dandelis.ch>

	* java/awt/font/OpenType.java: Declare OpenType tags
	as 'public static final'.

2003-08-10  Mark Wielaard  <mark@klomp.org>

	* doc/www.gnu.org/home.wml: Add Joas and JAmiga. Update links.
	Remove links to proprietary projects.

2003-08-10  Mark Wielaard  <mark@klomp.org>

	* gnu/classpath/Makefile.am (EXTRA_DIST): Add RawData.java.
	* javax/swing/Makefile.am (EXTRA_DIST): Add Popup.java and
	PopupFactory.java.
	* vm/reference/java/lang/Makefile.am (EXTRA_DIST): Add VMDouble.java,
	VMFloat.java and VMString.java.

2003-08-10  Mark Wielaard  <mark@klomp.org>

	* gnu/java/security/x509/Makefile.am (EXTRA_DIST): Corrected spelling
	of X500DistingushedName.java to X500DistinguishedName.java.
	* java/nio/Makefile.am (EXTRA_DIST): Changed CharViewBuffer.java,
	DoubleViewBuffer.java, FloatViewBuffer.java, IntViewBuffer.java,
	LongViewBuffer.java and ShortViewBuffer.java to
	CharViewBufferImpl.java, DoubleViewBufferImpl.java,
	FloatViewBufferImpl.java, IntViewBufferImpl.java,
	LongViewBufferImpl.java and ShortViewBufferImpl.java.

2003-08-10  Jeroen Frijters  <jeroen@frijters.net>

	* java/awt/Container.java
	(getPreferredSize): Call preferredSize.
	(preferredSize): Moved body of getPreferredSize here.
	(getMinimumSize): Call minimumSize.
	(minimumSize): Moved body of getMinimumSize here.

2003-08-10  Bryce McKinlay  <bryce@mckinlay.net.nz>

	* java/io/PrintStream.java (print): Always flush if auto_flush is
	set. Don't check for newline characters.
	(write (int)): Implement without using a temporary array.
	(write (byte[], int, int): Always flush if auto_flush is set. Don't
	check for newline characters.
	Fixes PR libgcj/11778.

2003-08-09  Mark Wielaard  <mark@klomp.org>

	Reported by David Holmes <dholmes@dltech.com.au>, fixes bug #3229.
	* java/lang/InheritableThreadLocal.java (threadMap): Wrap inside
	Collections.synchronizedMap.
	* java/lang/ThreadLocal.java (valueMap): Likewise.

2003-08-09  Mark Wielaard  <mark@klomp.org>

	Reported by Archie Cobbs <archie@dellroad.org>
	* vm/reference/java/lang/Thread.java (Thread): Explicitly set
	contextClassLoader.

2003-08-09  Mark Wielaard  <mark@klomp.org>

	* LICENSE: Update with current exception statement.

2003-08-08  Tom Tromey  <tromey@redhat.com>

	* java/lang/System.java: Typo fix.

2003-08-07  Bryce McKinlay  <bryce@mckinlay.net.nz>

	* java/net/Socket.java (Socket (SocketImpl)): Don't allow null
	SocketImpl. Update Javadoc.
	(bind): Call close() not impl.close() in event of exception.
	(connect): Likewise.
	Remove superfluous null checks throughout.
	* java/net/ServerSocket.java (ServerSocket (int, int, InetAddress)):
	Don't create an extra socket. Fix for PR libgcj/10868.
	(bind): Clean up exception handling.
	Remove superfluous null checks throughout.
	
2003-08-06  Tom Tromey  <tromey@redhat.com>

	* java/io/FilePermission.java (equals): Use correct index for
	last character of path.

2003-08-06  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkComponentPeer.java (postKeyEvent):
	Add keyLocation parameter.
	* java/awt/event/KeyEvent.java (getKeyText): Fix "NumPad-"
	string.
	(paramString): Generate keyChar string according to keyChar, not
	keyCode.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkEvents.c
	(state_to_awt_mods): Handle ALT key.
	(keyevent_state_to_awt_mods): New function.
	(get_first_keyval_from_keymap): New function.
	(keysym_to_awt_keycode): Get virtual key code from keymap.
	Handle missing VK_ values.
	(keysym_to_awt_keylocation): New function.
	(keyevent_to_awt_keychar): New function.
	(generates_key_typed_event): Handle non-text-component case.
	Handle GDK_KP_Delete and GDK_KP_Enter.
	(awt_event_handler): Call new functions to get postKeyEvent
	parameters.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkMainThread.c (gtkInit):
	Update postKeyEvent method signature.
	* jni/gtk-peer/gtkpeer.h: Add KEY_LOCATION defines.  Add missing
	VK_ defines.

2003-08-05  Tom Tromey  <tromey@redhat.com>

	* java/lang/ClassLoader.java (getParent): Use isAncestorOf.
	(isAncestorOf): New method.

2003-08-01  David P Grove  <groved@us.ibm.com>

	* java/text/DecimalFormat.java (format): avoid ArithmeticException
	when groupingSize is 0.
	(parse): Likewise.

2003-08-04  Jeroen Frijters  <jeroen@frijters.net>

	* java/lang/Class.java (forName(String,boolean,ClassLoader)):
	Call ClassLoader.loadClass(String) instead of
	ClassLoader.loadClass(String,boolean) as per VM spec.

2003-08-01  David P Grove  <groved@us.ibm.com>

	* java/util/zip/InflaterInputStream.java (close): Only close
	once.
	* java/io/InputStreamReader.java (close): Only close once.

2003-08-01  Tom Tromey  <tromey@redhat.com>

	* java/util/WeakHashMap.java (WeakHashMap(int,float)): If
	initialCapacity is 0, set it to 1.

2003-08-01  Mark Wielaard  <mark@klomp.org>

	* java/math/BigDecimal.java (divide): Calculate sign correctly. And
	optimize checks againsts sign and half values.

2003-07-31  Tom Tromey  <tromey@redhat.com>

	* java/io/ObjectInputStream.java (processResolution): Use
	getMethod.
	(getMethod): Make method accessible.
	(getField): Make field accessible.
	(setBooleanField): Don't call setAccessible here.
	(setByteField, setCharField, setDoubleField, setFloatField,
	setIntField, setLongField, setShortField, setObjectField):
	Likewise.
	(callReadMethod): Don't check whether method is null.  Catch
	NoSuchMethodException.
	* java/io/ObjectOutputStream.java (callWriteMethod): Initialize
	cause on thrown exceptions.

2003-07-31  Stepan Koltsov  <yozh@mx1.ru>

	* java/util/HashMap.java (readObject): Set size.

2003-07-31  Tom Tromey  <tromey@redhat.com>

	* java/io/ObjectOutputStream.java (getMethod): Make method
	accessible.
	(getField): Likewise.
	(writeObject): Use getMethod.
	Import PrivilegedAction and AccessController.
	(callWriteMethod): Don't check whether m is null.  Catch
	NoSuchMethodException.

2003-07-31  Tom Tromey  <tromey@redhat.com>

	* java/awt/geom/Arc2D.java (getBounds2D): Implement.
	(containsAngle): Likewise.
	(getStartPoint): Rewrote.
	(getEndPoint): Likewise.
	(setAngleStart(Point2D)): Likewise.

2003-07-31  Torsten Rupp  <rupp@lisa.aicas.com>

	* java/lang/SecurityManager.java:
	checkPackageList(): replace access of String.count with
        String.length() to make it compatible with other
        implementations of class String

2003-07-31  Torsten Rupp  <rupp@lisa.aicas.com>

	* java/io/File.java:
	createTempFile(): use long names on system where file
        separator is not '\', otherwise limit filenames to
        8+3-convention

2003-07-30  Tom Tromey  <tromey@redhat.com>

	* include/*.h: Rebuilt.

	* native/jni/java-nio/java_nio_FileChannelImpl.c: Include
	java_nio_channels_FileChannelImpl.h.
	* include/java_nio_FileChannelImpl.h: Removed.
	* include/java_nio_channels_FileChannelImpl.h: New file.
	* include/Makefile.am (H_FILES): Added
	java_nio_channels_FileChannelImpl.h.
	($(top_srcdir)/include/java_nio_channels_FileChannelImpl.h): New rule.

2003-07-30  Michael Koch  <konqueror@gmx.de>

	* java/net/PlainSocketImpl.java
	(connect): Reverted Torsten's commit.

2003-07-30  Torsten Rupp  <rupp@lisa.aicas.com>

	* include/java_nio_FileChannelImpl.h:
	copied from gnu_java_nio_FileChannelImpl.h, renamed
        Java_gnu_java_nio_channels_* -> Java_java_nio_channels*
        to match new implementation of FileChannelImpl.java,
        added some missing native functions

2003-07-30  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/jni/java-nio/java_nio_FileChannelImpl.c:
	rename Java_gnu_java_nio_channels_* -> Java_java_nio_channels*
        to match new implementation of FileChannelImpl.java, added some
        missing native functions

2003-07-30  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/jni/java-io/FileDescriptor.c:
	fixed warning in Java_java_io_FileDescriptor_nativeSync()

2003-07-30  Torsten Rupp  <rupp@lisa.aicas.com>

	* java/net/PlainSocketImpl.java:
	implemented connect(SocketAddress address, int timeout)
        (preliminary implementation; timeout still not supported)

2003-07-29  Tom Tromey  <tromey@redhat.com>

	* java/lang/StrictMath.java: Typo fix.
	* java/lang/Math.java: Typo fix.

2003-07-29  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkButtonPeer.java: Call getName rather
	than getXLFD.
	* gnu/java/awt/peer/gtk/GtkTextFieldPeer.java: Likewise.
	* gnu/java/awt/peer/gtk/GtkTextAreaPeer.java: Likewise.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkButtonPeer.c
	(gtkSetFont): Scale size parameter by PANGO_SCALE.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextFieldPeer.c:
	Likewise.
	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkTextAreaPeer.c:
	Likewise.

2003-07-29  Stephen Crawley <crawley@dstc.edu.au>

	* java/net/SocketImpl.java (toString): Display the remote address
	of an unconnected server socket as "0.0.0.0/0.0.0.0".
	* native/jni/java-net/javanet.c (_javanet_connect):
	Don't create a new InetAddress for the remote host.
	Instead, attach the parameter InetAddress to the
	connected SocketImpl object.
	* java/net/PlainSocketImpl.java (connect):
	Implemented connect(SocketAddress, int) overloading.

2003-07-28  C. Brian Jones  <cbj@gnu.org>

	* vm/reference/java/lang/Thread.java (stop): no longer remove 
	thread from thread group in this method.  JVMs must remove thread
	from thread group after thread has had a chance to finishing running
	after catching ThreadDeath.  Mauve test case exists, see bug #2685.

2003-07-28  Torsten Rupp  <rupp@lisa.aicas.com>

	* include/jni.h.in:
	removed obsoleted constants JNI_JLONG_CONST*

2003-07-28  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/jni/java-net/java_net_PlainDatagramSocketImpl.c:
	improved some exception messages in Java_java_net_PlainDatagramSocketImpl_receive,
        Java_java_net_PlainDatagramSocketImpl_sendto

2003-07-28  Sascha Brawer  <brawer@dandelis.ch>

	* javax/swing/border/BevelBorder.java,
	javax/swing/border/EtchedBorder.java,
	javax/swing/border/LineBorder.java,
	javax/swing/border/MatteBorder.java,
	javax/swing/border/SoftBevelBorder.java,
	javax/swing/plaf/BorderUIResource.java,
	javax/swing/plaf/ComponentUI.java,
	javax/swing/plaf/TreeUI.java,
	javax/swing/plaf/basic/BasicBorders.java,
	javax/swing/plaf/basic/BasicGraphicsUtils.java,
	javax/swing/plaf/basic/BasicTreeUI.java:
	Prepend "doc-files" to all paths to embedded Javadoc images, so
	that the generated documentation contains the correct URL.

2003-07-24  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* jni/gtk-peer/gnu_java_awt_peer_gtk_GtkLabelPeer.c (create):
	Don't pack label in an event box.

2003-07-24  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* Makefile.am (SUBDIRS): Add include.
	* configure.in: Add --enable-regen-headers flag.
	(AC_OUTPUT): Add include/Makefile.
	* include/Makefile.am: New file.

2003-07-24  Jeroen Frijters  <jeroen@frijters.net>

	* java/sql/Timestamp.java
	(valueOf): Fixed confusion of java.sql.Date and java.util.Date

2003-07-24  H. Väisänen  <hvaisane@joyx.joensuu.fi>

	* java/text/SimpleDateFormat.java (format) [YEAR_FIELD]: Zero pad
	unless field size is 2.

2003-07-24  Jeroen Frijters  <jeroen@frijters.net>

	* java/awt/Component.java
	(getPreferredSize): Call preferredSize.
	(preferredSize): Moved body of getPreferredSize here.
	(getMinimumSize): Call minimumSize.
	(minimumSize): Moved body of getMinimumSize here.
	(prepareImage): Fall back on Toolkit.prepareImage if there is no peer
	(checkImage(Image,ImageObserver)): Don't call getWidth/getHeight, but
	pass -1
	* java/awt/Container.java
	(validate): Don't validate if there is no peer.
	(update): Clear background before calling paint.
	* java/awt/GridBagLayout.java
	Completed the implementation and fixed several bugs.
	* java/awt/MediaTracker.java
	(MediaEntry.imageUpdate): Fixed typo. & instead of | was used to
	combine flags.
	* java/awt/Window.java
	(Window): Don't call setVisible(false). Windows are invisible by
	default and calling virtual methods from constructor causes
	compatibility problems (e.g. subclasses may assume that the peer
	already exists).

2003-07-23  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/target/generic/target_generic_file.h:
	Fixed include of utime.h, sys/utime.h: rename HAVE_UTIME -> 
        HAVE_UTIME_H, HAVE_SYS_UTIME -> HAVE_SYS_UTIME_H

2003-07-23  Torsten Rupp  <rupp@lisa.aicas.com>

	* gnu/java/io/class-dependencies.conf:
	Added missing class-dependency file

2003-07-23  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/jni/java-io/java_io_File.c:
	Replaced JNI_JLONG_CONST* -> TARGET_NATIVE_MATH_INT_*, because
        JNI_JLONG_CONST* should be removed from jni.h

2003-07-23  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/jni/java-io/java_io_File.c:
	Replaced JNI_JLONG_CONST* -> TARGET_NATIVE_MATH_INT_*, because
        JNI_JLONG_CONST* should be removed from jni.h

2003-07-23  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/jni/java-io/FileDescriptor.c:
	Replaced JNI_JLONG_CONST* -> TARGET_NATIVE_MATH_INT_*, because
        JNI_JLONG_CONST* should be removed from jni.h
        removed HAVE_FTRUNCATE, HAVE_FSYNC, HAVE_SELECT (now set in
        configure)

2003-07-23  Torsten Rupp  <rupp@lisa.aicas.com>

	* native/jni/java-nio/java_nio.c:
	Replaced JNI_JLONG_CONST_0 -> TARGET_NATIVE_MATH_INT_INT64_CONST_0,
        because JNI_JLONG_CONST* should be removed from jni.h

2003-07-23  Torsten Rupp  <rupp@lisa.aicas.com>

        * native/jni/java-net/javanet.c:
        Enable option SO_BROADCAST for datagram sockets

2003-07-23  Torsten Rupp  <rupp@lisa.aicas.com>

        * native/target/generic/target_generic_file.h:
        added TARGET_NATIVE_FILE_FILEPERMISSION_READONLY, improved
        TARGET_NATIVE_FILE_VALID_FILE_DESCRIPTOR: now use fcntl()
        or fstat()

2003-07-22  Tom Tromey  <tromey@redhat.com>

	* java/awt/Window.java (getWarningString): Just return the
	string.
	(Window): Set warningString; check with security manager.

	* java/net/URLEncoder.java (encode(String)): Use platform default
	encoding.
	(encode(String,String)): Convert to 2-digit upper-case hex
	number.
	(hex): New field.

2003-07-22  Torsten Rupp  <rupp@lisa.aicas.com>

        * native/target/generic/target_generic_network.h:
        removed double defined macros, added
        TARGET_NATIVE_NETWORK_SOCKET_SET_OPTION_BROADCAST(),
        TARGET_NATIVE_NETWORK_SOCKET_GET_OPTION_BROADCAST()

2003-07-22  Torsten Rupp  <rupp@lisa.aicas.com>

        * native/target/generic/target_generic_math_float.h:
        added macro TARGET_NATIVE_MATH_FLOAT_FLOAT_FINITE(),
        TARGET_NATIVE_MATH_FLOAT_DOUBLE_FINITE()

2003-07-21  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(create): Remove unused method implementation.
	(connectHooks): Remove debug messages.

2003-07-20  Tom Tromey  <tromey@redhat.com>

	* vm/reference/java/lang/Runtime.java: Typo fix.

2003-07-20  Michael Koch  <konqueror@gmx.de>

	* java/net/URL.java
	(handlers): Removed member variable, unused.
	I think this came in with a libgcj merge.

2003-07-19  Michael Koch  <konqueror@gmx.de>

	* java/net/URL.java:
	Partly merged with libgcj.

2003-07-19  Torsten Rupp  <rupp@lisa.aicas.com>

        * java/io/File.java:
        canWrite(): set prefix for temporary file to "tmp" to make methode
